.SUFFIXES : .c .cpp .o

.cpp.o:
	$(CCC) $(CFLAGS) -c $(IPATHS) $<

.c.o:
	$(CC) $(CFLAGS) -c $(IPATHS) $<

.y.c:

# Platform specific definitions for Linux/GNU. Assumes 
# GNU GCC 3.x or 2.95.x compiler.

# The following variables are platform specific and may need
# to be edited if moving to a different system.

# compiler defs
CC        = gcc
CCC       = g++
CVARS_ = -DGNU -D_GNU_SOURCE -DHAVE_STDINT_H -DHAVE_VA_COPY  
LINKDBG_  = -g
CELF_     = -fPIC
CUSEELF_  = -fpic
CEXCEPT_  = 
CVARS0_   = $(CVARS_)
CVARSR_   = $(CVARS_)
CVARSMT_  = $(CVARS_)
CVARSMTR_ = $(CVARS_)
CVARSMTD_ = $(CVARS_)
CVARSMTR_ = $(CVARS_)
PIC = -fPIC 

CDEBUG_    = -g
CFLAGS0_   = -o $@ -DHAVE_STDINT_H
COPTIMIZE_ = -O2
LINKOPT_ = -o $@ -Wl,-Bstatic 
LINKOPTRLM_ = $(LINKOPT_)
CBLDTYPE_  = $(COPTIMIZE_)


CFLAGS_ = -fPIC -o $@ 
CCFLAGS_ = $(CFLAGS_) -DHAS_STL $(CEXCEPT_) 
CCDEBUG_  = $(CDEBUG_)

LIBCMD    = ar r $@
LINK      = $(CCC)
LINKSO    = $(LINK)
LINKOPT2  = $(LINKOPT_)
LINKELF_ = -shared $(CELF_) -o $@ 
LINKELF2_ = $(LINKELF_)
LINKUELF_ = $(CUSEELF_) -o $@
COMPACT   = -Os -D_COMPACT
OBJOUT    = 

# File extensions
EXE     = 
OBJ     = .o
SO      = .so

# Run-time library
LIBPFX  = lib
LIBEXT  = a
LPPFX   = -L

A       = .$(LIBEXT)
MTA     = $(A)
MDA     = $(A)

# Include and library paths
PS      = /
FS      = :
IPATHS_ = 

# O/S commands
COPY     = cp -f
MOVE     = mv -f
MV       = $(MOVE)
RM       = rm -f
STRIP    = strip
MAKE     = make
MKDIR    = mkdir -p
RMDIR    = rm -rf

LLSYS = -Wl,-Bdynamic -lm -lpthread 

# LIBXML2 defs
LIBXML2ROOT = $(OSROOTDIR)/libxml2src
LIBXML2INC  = $(LIBXML2ROOT)/include
LIBXML2LIBDIR = ../lib 
LLXML2 = -lxml2

# XERCES defs
XERCESROOT = /usr/xercesc
XERCESINC  = $(XERCESROOT)/include
XERCESLIBDIR = $(XERCESROOT)/lib

# XML4C defs
XML4CROOT = /usr/xml4c
XML4CINC  = $(XML4CROOT)/include
XML4CLIBDIR = $(XML4CROOT)/lib

# RLM defs
RLMDIR = $(OSROOTDIR)/licmgr/RLM
RLMLIBDIR = $(RLMDIR)/bin
LLRLM   = -lrlm


# START XBINDER
LLOSRT = -losysrt
LLOSJSON = -losysrtjson
LLOSXML = -losysrtxml
LLOSDOMAPI = -losysdomapi
OSRTLIBNAME = libosysrt.a
OSJSONLIBNAME = libosysrtjson.a
OSXMLLIBNAME = libosysrtxml.a
# END XBINDER
