/*
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * This software is furnished under a license and may be used and copied
 * only in accordance with the terms of such license and with the
 * inclusion of the above copyright notice. This software or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person. No title to and ownership of the software is hereby
 * transferred.
 *
 * The information in this software is subject to change without notice
 * and should not be construed as a commitment by Objective Systems, Inc.
 *
 * PROPRIETARY NOTICE
 *
 * This software is an unpublished work subject to a confidentiality agreement
 * and is protected by copyright and trade secret law.  Unauthorized copying,
 * redistribution or other use of this work is prohibited.
 *
 * The above notice of copyright on this source code product does not indicate
 * any actual or intended publication of such source code.
 *
 *****************************************************************************/
/**
 * @file rtSaxCppAnyType.h
 */
#ifndef _RTSAXCPPANYTYPE_H_
#define _RTSAXCPPANYTYPE_H_

#include "rtxsrc/OSRTContext.h"
#include "rtxmlsrc/osrtxml.h"
#include "rtxmlsrc/rtSaxCppParser.h"
#include "rtxmlsrc/rtXmlCppMsgBuf.h"
#ifndef ASN1RT
#include "rtxsrc/rtxCppXmlString.h"
#include "rtxmlsrc/OSXSDAnyTypeClass.h"
#endif

class EXTERNXML OSXMLAnyTypeHandler : public OSXMLDefaultHandler {
 private:
   OSRTContext mEncCtxt;
   OSXSDAnyTypeClass* mpAnyTypeMsgData;
   void   localInit (OSRTContext* pContext);
   OSBOOL isEmptyElement (const OSUTF8CHAR* qname);
   OSXMLAnyTypeHandler& operator= (const OSXMLAnyTypeHandler&);

 public:
   OSXMLAnyTypeHandler
      (OSXSDAnyTypeClass& msgData, OSRTContext* pContext, int level = 0);

   OSXMLAnyTypeHandler
      (OSXSDAnyTypeClass& msgData, OSRTContext* pContext,
       const OSUTF8CHAR* elemName);

   ~OSXMLAnyTypeHandler ();

   virtual int startElement
      (const OSUTF8CHAR* const uri,
       const OSUTF8CHAR* const localname,
       const OSUTF8CHAR* const qname,
       const OSUTF8CHAR* const* attrs);

   virtual int characters
      (const OSUTF8CHAR* const chars, OSUINT32 length);

   virtual int endElement
      (const OSUTF8CHAR* const uri,
       const OSUTF8CHAR* const localname,
       const OSUTF8CHAR* const qname);
} ;

#endif /* _RTSAXCPPANYTYPE_H_ */
