/*
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * This software is furnished under a license and may be used and copied
 * only in accordance with the terms of such license and with the
 * inclusion of the above copyright notice. This software or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person. No title to and ownership of the software is hereby
 * transferred.
 *
 * The information in this software is subject to change without notice
 * and should not be construed as a commitment by Objective Systems, Inc.
 *
 * PROPRIETARY NOTICE
 *
 * This software is an unpublished work subject to a confidentiality agreement
 * and is protected by copyright and trade secret law.  Unauthorized copying,
 * redistribution or other use of this work is prohibited.
 *
 * The above notice of copyright on this source code product does not indicate
 * any actual or intended publication of such source code.
 *
 *****************************************************************************/

/**
 * @file rtSaxCppSoap.h
 */

#ifndef _RTSAXCPPSOAP_H_
#define _RTSAXCPPSOAP_H_

#include "rtxsrc/rtxCppDynOctStr.h"
#include "rtxsrc/OSRTContext.h"
#include "rtxsrc/OSRTMemBuf.h"
#include "rtxsrc/rtxCppXmlString.h"
#include "rtxmlsrc/osrtxml.h"
#include "rtxmlsrc/rtSaxCppParser.h"
#include "rtxmlsrc/rtXmlCppMsgBuf.h"

class EXTERNXML OSXMLSoapHandler : public OSXMLDefaultHandler {
 private:
   OSXMLDefaultHandler* mpMsgSaxHandler;
   OSXMLDefaultHandler* mpFaultMsgSaxHandler;
   OSRTMemBuf mCurrElemValue;
//   OSXMLStringClass mFaultCode;
//   OSXMLStringClass mFaultString;
   OSBOOL mbEnvelopeParsed;
   OSBOOL mbFault;
   OSBOOL mbProcessingDetailFault;
   OSBOOL mbParsingHeader;

 public:
   OSXMLSoapHandler
      (OSXMLDefaultHandler* msgSaxHandler,
       OSRTContext* pContext,
       OSXMLDefaultHandler* faultSaxHandler = 0);
   ~OSXMLSoapHandler ();

   virtual int startElement
      (const OSUTF8CHAR* const uri,
       const OSUTF8CHAR* const localname,
       const OSUTF8CHAR* const qname,
       const OSUTF8CHAR* const* attrs);

   virtual int characters
      (const OSUTF8CHAR* const chars, unsigned int length);

   virtual int endElement
      (const OSUTF8CHAR* const uri,
       const OSUTF8CHAR* const localname,
       const OSUTF8CHAR* const qname);

   OSBOOL isSoapEnv(const OSUTF8CHAR* uri);
} ;

#endif /* _RTSAXCPPSOAP_H_ */
