/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

AcceptCall_ELEM* Test_AcceptCall (OSCTXT* pctxt);
AcceptCallResponse_ELEM* Test_AcceptCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   AcceptCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_AcceptCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_AcceptCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

AcceptCall_ELEM* Test_AcceptCall (OSCTXT* pctxt)
{
   AcceptCall_ELEM* pvalue = rtxMemAllocType (pctxt, AcceptCall_ELEM);
   Init_AcceptCall_ELEM (pctxt, pvalue);
   pvalue->callToBeAccepted.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->callToBeAccepted.u._seq2));
   pvalue->callToBeAccepted.u._seq2.callID.value = 
      OSUTF8("pvalue->callToBeAccepted.u._seq2.callID");
   pvalue->callToBeAccepted.u._seq2.callID.cdata = FALSE;

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 1;
   { static const OSOCTET testdata[] = {
   0xe1, 0xa2, 0x5f, 0x73, 0xaf, 0x48, 0x3b, 0x99, 
   0x51, 0xfa, 0xe3, 0x32, 0x3b, 0x5a, 0x51, 0xa7, 
   0x0, 0x74, 0x3e, 0xce, 0xd6, 0xc7, 0x86, 0xdd, 
   0x81, 0x21, 0x49, 0x12, 0x2f, 0x81, 0x1c, 0xaf, 
   0xc8, 0xc9, 0x46, 0xd6, 0x43, 0x53, 0xd4, 0xdf, 
   0xe1, 0xb9, 0x3, 0x2c, 0x9, 0xf6, 0xbc, 0xac, 
   0x81, 0x1a, 0xc5, 0x4, 0x5e };
   pvalue->userData.u.string.numocts = 53;
   pvalue->userData.u.string.data = testdata;
   }

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   return (pvalue);
}

AcceptCallResponse_ELEM* Test_AcceptCallResponse (OSCTXT* pctxt)
{
   AcceptCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, AcceptCallResponse_ELEM);
   Init_AcceptCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   pvalue->extensions.security.m.securityInfoPresent = 1;
   pvalue->extensions.security.securityInfo.t = 2;
   Init_SecurityInfo_private (pctxt, &(pvalue->extensions.security.securityInfo
      .u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->extensions.security.securityInfo.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 1;
   { static const OSOCTET testdata[] = {
   0x9d, 0xfe, 0x7f, 0x12, 0x4a, 0x90, 0xf1, 0x65, 
   0xee, 0x65, 0x49, 0x97, 0x91, 0x2a, 0xed, 0x55, 
   0xc2, 0xa3, 0x77, 0x6c, 0x6, 0xc0, 0xf8, 0x51, 
   0x52, 0xdc, 0xcb, 0xed, 0xb1, 0xc3, 0x10, 0x89, 
   0x9a, 0x6d, 0x9a, 0x47, 0x89, 0xfa, 0x71, 0xf9, 
   0x88, 0x7d, 0xab, 0xe0, 0x96, 0x7f, 0x3f, 0x7f, 
   0xa9, 0x5d, 0xa1, 0xa2, 0x35, 0xf8, 0xb3, 0xc8, 
   0x75, 0xaf, 0x73, 0x4, 0x66, 0xbb, 0x5f, 0x7, 
   0x25, 0xe6, 0xfa, 0xeb, 0x2b, 0xa5, 0x7f, 0xf8, 
   0x16, 0x12, 0x89, 0xde };
   pvalue->extensions.privateData.u.string.numocts = 76;
   pvalue->extensions.privateData.u.string.data = testdata;
   }

   return (pvalue);
}

