/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

AlternateCall_ELEM* Test_AlternateCall (OSCTXT* pctxt);
AlternateCallResponse_ELEM* Test_AlternateCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   AlternateCallResponse_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_AlternateCallResponse (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_AlternateCallResponse (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

AlternateCall_ELEM* Test_AlternateCall (OSCTXT* pctxt)
{
   AlternateCall_ELEM* pvalue = rtxMemAllocType (pctxt, AlternateCall_ELEM);
   Init_AlternateCall_ELEM (pctxt, pvalue);
   pvalue->heldCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->heldCall.u.deviceID));
   pvalue->heldCall.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x96, 0x95, 0x3d, 0x8c, 0xe5, 0xe3, 0xe7, 0x58, 
   0x5c, 0x34, 0x1a, 0x15, 0x84, 0xa5, 0xfd, 0x5b, 
   0x7e, 0xd7, 0x73, 0x99, 0x24, 0x12, 0xde, 0xa8, 
   0x95, 0x30, 0xc2, 0x14, 0xb6, 0xb4, 0x41, 0x23, 
   0x60, 0xce, 0xed, 0x7d, 0x41, 0xb4, 0x88, 0x78, 
   0xc9, 0x8a, 0x19, 0x68, 0x7, 0x4e, 0xf8, 0x84, 
   0x47, 0xf8, 0xc2, 0xb0, 0xa, 0xc9, 0x3c };
   pvalue->heldCall.u.deviceID._base.u.otherPlan.numocts = 55;
   pvalue->heldCall.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pvalue->heldCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPublic_unknown;
   pvalue->heldCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_dataBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_audioBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_messageBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->heldCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->heldCall.u.deviceID.connectionRate
       = OSI64CONST(7488588814004469600);
   pvalue->heldCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->heldCall.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pvalue->heldCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->heldCall.u.deviceID.delayTolerance
       = OSI64CONST(6517189024607032192);
   pvalue->heldCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->heldCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_atm;
   pvalue->heldCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x46, 0xe3, 0x6b, 0xc9, 0x4d, 0xa0, 0x9d, 0x62, 
   0xbf, 0xc1, 0x4e, 0xf, 0xa, 0x51, 0x35, 0x64, 
   0xf8, 0x8b, 0x5, 0x60, 0x14, 0x90, 0xda, 0xe9, 
   0xaa, 0x2b, 0x5, 0xd1, 0xe9, 0xc2, 0x33, 0x1, 
   0xcb, 0x69, 0xee, 0x77, 0xcb, 0x16, 0xe0, 0xbe, 
   0x83, 0xd, 0x3f, 0x6d, 0xc0, 0x7e, 0x7e, 0x6f, 
   0xaf, 0x48, 0x87, 0x23, 0x1c, 0x8e, 0x9c, 0x7, 
   0xfa };
   pvalue->heldCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 57;
   pvalue->heldCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->heldCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->activeCall.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->activeCall.u._seq2));
   pvalue->activeCall.u._seq2.callID.value = 
      OSUTF8("pvalue->activeCall.u._seq2.callID");
   pvalue->activeCall.u._seq2.callID.cdata = FALSE;

   pvalue->activeCall.u._seq2.m.deviceIDPresent = 1;
   pvalue->activeCall.u._seq2.deviceID._base.t = 2;
   pvalue->activeCall.u._seq2.deviceID._base.u.number.value = 
      OSUTF8("pvalue->activeCall.u._seq2.deviceID._base.u.number");
   pvalue->activeCall.u._seq2.deviceID._base.u.number.cdata = FALSE;
   pvalue->activeCall.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_other;
   pvalue->activeCall.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->activeCall.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->activeCall.u._seq2.deviceID.connectionRate
       = OSI64CONST(1407980801670814800);
   pvalue->activeCall.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pvalue->activeCall.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.delayTolerance
       = OSI64CONST(7316039387490233392);
   pvalue->activeCall.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pvalue->activeCall.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x1b, 0xd3, 0x89, 0x7d, 0x0, 0x40, 0xba, 0x2f, 
   0x32, 0x9d, 0xed, 0xa5, 0x30, 0xb4, 0x4b, 0x33, 
   0xf2, 0x18, 0xd2, 0xe4, 0x62, 0x24, 0x77, 0x8d, 
   0x46, 0xf6, 0x48, 0x95, 0x6f };
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .numocts = 29;
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->activeCall.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.connectionReservationPresent = 1;
   pvalue->connectionReservation = 1;

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   return (pvalue);
}

AlternateCallResponse_ELEM* Test_AlternateCallResponse (OSCTXT* pctxt)
{
   AlternateCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, AlternateCallResponse_ELEM);
   Init_AlternateCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   return (pvalue);
}

