/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

AnswerCall_ELEM* Test_AnswerCall (OSCTXT* pctxt);
AnswerCallResponse_ELEM* Test_AnswerCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   AnswerCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_AnswerCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_AnswerCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

AnswerCall_ELEM* Test_AnswerCall (OSCTXT* pctxt)
{
   AnswerCall_ELEM* pvalue = rtxMemAllocType (pctxt, AnswerCall_ELEM);
   Init_AnswerCall_ELEM (pctxt, pvalue);
   pvalue->callToBeAnswered.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->callToBeAnswered.u._seq2));
   pvalue->callToBeAnswered.u._seq2.callID.value = 
      OSUTF8("pvalue->callToBeAnswered.u._seq2.callID");
   pvalue->callToBeAnswered.u._seq2.callID.cdata = FALSE;

   pvalue->callToBeAnswered.u._seq2.m.deviceIDPresent = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x1b, 0xfc, 0x70, 0x51, 0x10, 0xb9, 0x3b, 0xe2, 
   0x32, 0xc4, 0xd5, 0xb2, 0xe6, 0xc2, 0x11, 0xdf, 
   0xd9, 0xb7, 0x77, 0x33, 0xae, 0xf, 0x99, 0x5a, 
   0x14, 0x64, 0x6f, 0x3e, 0x82, 0xd0, 0xc9, 0x55, 
   0x35, 0xac, 0x64, 0x69, 0x84, 0x6e, 0xa, 0x47, 
   0x47, 0x2c, 0xeb };
   pvalue->callToBeAnswered.u._seq2.deviceID._base.u.otherPlan.numocts = 43;
   pvalue->callToBeAnswered.u._seq2.deviceID._base.u.otherPlan
      .data = testdata;
   }
   pvalue->callToBeAnswered.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPublic_networkspecific;
   pvalue->callToBeAnswered.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->callToBeAnswered.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.connectionRate
       = OSI64CONST(5587448803111890000);
   pvalue->callToBeAnswered.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pvalue->callToBeAnswered.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.delayTolerance
       = OSI64CONST(-1719020143103491808);
   pvalue->callToBeAnswered.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->callToBeAnswered.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pvalue->callToBeAnswered.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xcc, 0x3, 0xfd, 0x2d, 0xf, 0x5f, 0x8e, 0xe0, 
   0x38, 0xac, 0xf8, 0x16, 0x7b, 0xf, 0xe2, 0x61, 
   0xbc, 0x22, 0xdd, 0xb3, 0x88, 0xf1, 0x7b, 0x5b, 
   0x12, 0x39, 0x37, 0xae, 0xce, 0x7a, 0x2e, 0xa1, 
   0xbe, 0xe3, 0x10, 0x48, 0xf2, 0x12, 0x53, 0x13, 
   0x73, 0xac, 0xfb, 0x38, 0x83, 0xee, 0x96, 0x23, 
   0xef, 0x2, 0xad, 0x5c, 0x64, 0x56, 0x58, 0xb5, 
   0xf5, 0xd3, 0x29, 0xbe, 0x52, 0x16, 0xa3 };
   pvalue->callToBeAnswered.u._seq2.deviceID.
      switchingSubDomainInformationElements.numocts = 63;
   pvalue->callToBeAnswered.u._seq2.deviceID.
      switchingSubDomainInformationElements.data = testdata;
   }
   pvalue->callToBeAnswered.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.correlatorDataPresent = 1;
   pvalue->correlatorData.t = 1;
   { static const OSOCTET testdata[] = {
   0xdf, 0xed, 0xdf, 0x2b, 0xd8, 0x1, 0x9, 0xf4, 
   0x5b, 0xd9, 0x6b, 0xe1, 0xd2, 0x31, 0xb0, 0xa7, 
   0x56, 0xea, 0xea, 0x1a, 0x84, 0x9e, 0xc4, 0xb2, 
   0x3f, 0xe8, 0xcf, 0xb6, 0x97, 0xc6, 0xd6, 0x45, 
   0x61, 0x56, 0xdf, 0x71, 0xc6, 0xc5, 0xb2, 0xac, 
   0xc3, 0xd6, 0x17, 0xa9, 0x68, 0xb7, 0x2a, 0xed, 
   0xd7, 0x16, 0x61, 0xca, 0xc3, 0x31, 0xb8, 0xee, 
   0xfb, 0xcc, 0x98, 0xbb, 0x3b, 0x49, 0xe7, 0xad, 
   0x4d, 0x4a, 0xde, 0xe0, 0xc4, 0xa9 };
   pvalue->correlatorData.u.string.numocts = 70;
   pvalue->correlatorData.u.string.data = testdata;
   }

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   return (pvalue);
}

AnswerCallResponse_ELEM* Test_AnswerCallResponse (OSCTXT* pctxt)
{
   AnswerCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, AnswerCallResponse_ELEM);
   Init_AnswerCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;
   pvalue->extensions.security.m.messageSequenceNumberPresent = 1;
   pvalue->extensions.security.messageSequenceNumber
       = OSI64CONST(2644538111095022992);

   pvalue->extensions.security.m.securityInfoPresent = 1;
   pvalue->extensions.security.securityInfo.t = 1;
   { static const OSOCTET testdata[] = {
   0xce, 0x1c, 0xd5, 0xfc, 0x12, 0xea, 0xa8, 0x97, 
   0x1c, 0x8a, 0xb9, 0xa9, 0xda, 0x1e, 0x8d, 0x1a, 
   0xfa, 0xba, 0xcb, 0x7f, 0xd8, 0xa7, 0x4d, 0x7c, 
   0xc3, 0x9e, 0xb1, 0x94, 0xbe, 0x1d, 0xb2, 0x45, 
   0x9a, 0xa0, 0xc0, 0xbc, 0x14, 0x61, 0xa9, 0xf1, 
   0x56, 0xd7, 0x4f, 0x17, 0x8, 0x2b, 0x33, 0x7, 
   0x41, 0xd6, 0xd5, 0x31, 0x1a, 0x18, 0xb2, 0xb9, 
   0xa5, 0x83, 0xdd, 0x30, 0x8c, 0xc8, 0x2, 0x28, 
   0x24, 0x83, 0xc5, 0x13, 0x26, 0x1f };
   pvalue->extensions.security.securityInfo.u.string.numocts = 70;
   pvalue->extensions.security.securityInfo.u.string.data = testdata;
   }

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 2;
   Init_CSTAPrivateData_private (pctxt, &(pvalue->extensions.privateData.
      u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->extensions.privateData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   return (pvalue);
}

