/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

CamponCall_ELEM* Test_CamponCall (OSCTXT* pctxt);
CamponCallResponse_ELEM* Test_CamponCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   CamponCallResponse_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_CamponCallResponse (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_CamponCallResponse (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

CamponCall_ELEM* Test_CamponCall (OSCTXT* pctxt)
{
   CamponCall_ELEM* pvalue = rtxMemAllocType (pctxt, CamponCall_ELEM);
   Init_CamponCall_ELEM (pctxt, pvalue);
   pvalue->camponConnection.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->camponConnection.u._seq2));
   pvalue->camponConnection.u._seq2.callID.value = 
      OSUTF8("pvalue->camponConnection.u._seq2.callID");
   pvalue->camponConnection.u._seq2.callID.cdata = FALSE;

   pvalue->camponConnection.u._seq2.m.deviceIDPresent = 1;
   pvalue->camponConnection.u._seq2.deviceID._base.t = 2;
   pvalue->camponConnection.u._seq2.deviceID._base.u.number.value = 
      OSUTF8("pvalue->camponConnection.u._seq2.deviceID._base.u.number");
   pvalue->camponConnection.u._seq2.deviceID._base.u.number.cdata = FALSE;
   pvalue->camponConnection.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_other;
   pvalue->camponConnection.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pvalue->camponConnection.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->camponConnection.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->camponConnection.u._seq2.deviceID.connectionRate
       = OSI64CONST(7441581058330933800);
   pvalue->camponConnection.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->camponConnection.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pvalue->camponConnection.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->camponConnection.u._seq2.deviceID.delayTolerance
       = OSI64CONST(3748516660505845792);
   pvalue->camponConnection.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->camponConnection.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_atm;
   pvalue->camponConnection.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x24, 0x2, 0xe0, 0x63, 0x1f, 0x71, 0x4d };
   pvalue->camponConnection.u._seq2.deviceID.
      switchingSubDomainInformationElements.numocts = 7;
   pvalue->camponConnection.u._seq2.deviceID.
      switchingSubDomainInformationElements.data = testdata;
   }
   pvalue->camponConnection.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   return (pvalue);
}

CamponCallResponse_ELEM* Test_CamponCallResponse (OSCTXT* pctxt)
{
   CamponCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, CamponCallResponse_ELEM);
   Init_CamponCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.extensionsPresent = 1;

   return (pvalue);
}

