/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

ClearCall_ELEM* Test_ClearCall (OSCTXT* pctxt);
ClearCallResponse_ELEM* Test_ClearCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   ClearCallResponse_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_ClearCallResponse (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_ClearCallResponse (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

ClearCall_ELEM* Test_ClearCall (OSCTXT* pctxt)
{
   ClearCall_ELEM* pvalue = rtxMemAllocType (pctxt, ClearCall_ELEM);
   Init_ClearCall_ELEM (pctxt, pvalue);
   pvalue->callToBeCleared.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->callToBeCleared.u._seq2));
   pvalue->callToBeCleared.u._seq2.callID.value = 
      OSUTF8("pvalue->callToBeCleared.u._seq2.callID");
   pvalue->callToBeCleared.u._seq2.callID.cdata = FALSE;

   pvalue->callToBeCleared.u._seq2.m.deviceIDPresent = 1;
   pvalue->callToBeCleared.u._seq2.deviceID._base.t = 2;
   pvalue->callToBeCleared.u._seq2.deviceID._base.u.number.value = 
      OSUTF8("pvalue->callToBeCleared.u._seq2.deviceID._base.u.number");
   pvalue->callToBeCleared.u._seq2.deviceID._base.u.number.cdata = FALSE;
   pvalue->callToBeCleared.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPublic_unknown;
   pvalue->callToBeCleared.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->callToBeCleared.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->callToBeCleared.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.connectionRate
       = OSI64CONST(6257942659485316800);
   pvalue->callToBeCleared.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pvalue->callToBeCleared.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.delayTolerance
       = OSI64CONST(1715079373166788192);
   pvalue->callToBeCleared.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->callToBeCleared.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pvalue->callToBeCleared.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x34, 0x79, 0xa0, 0xd2, 0x5f, 0xb3, 0x60, 0x65, 
   0xd9, 0x4d, 0x2c, 0x1b, 0xbd, 0x8d, 0xae, 0x34, 
   0xe3, 0xea };
   pvalue->callToBeCleared.u._seq2.deviceID.
      switchingSubDomainInformationElements.numocts = 18;
   pvalue->callToBeCleared.u._seq2.deviceID.
      switchingSubDomainInformationElements.data = testdata;
   }
   pvalue->callToBeCleared.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 2;
   Init_UserData_private (pctxt, &(pvalue->userData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->userData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.reasonPresent = 1;
   pvalue->reason = EventCause_distributed;

   return (pvalue);
}

ClearCallResponse_ELEM* Test_ClearCallResponse (OSCTXT* pctxt)
{
   ClearCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, ClearCallResponse_ELEM);
   Init_ClearCallResponse_ELEM (pctxt, pvalue);

   return (pvalue);
}

