/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

ConferenceCall_ELEM* Test_ConferenceCall (OSCTXT* pctxt);
ConferenceCallResponse_ELEM* Test_ConferenceCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   ConferenceCallResponse_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_ConferenceCallResponse (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_ConferenceCallResponse (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

ConferenceCall_ELEM* Test_ConferenceCall (OSCTXT* pctxt)
{
   ConferenceCall_ELEM* pvalue = rtxMemAllocType (pctxt, ConferenceCall_ELEM);
   Init_ConferenceCall_ELEM (pctxt, pvalue);
   pvalue->heldCall.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->heldCall.u._seq2));
   pvalue->heldCall.u._seq2.callID.value = 
      OSUTF8("pvalue->heldCall.u._seq2.callID");
   pvalue->heldCall.u._seq2.callID.cdata = FALSE;

   pvalue->heldCall.u._seq2.m.deviceIDPresent = 1;
   pvalue->heldCall.u._seq2.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0xc8, 0xc0, 0x87, 0x3c, 0xd, 0x61, 0xc, 0x73, 
   0xb1, 0xd2, 0xeb, 0x45, 0x46, 0xe9, 0x63, 0x8b };
   pvalue->heldCall.u._seq2.deviceID._base.u.otherPlan.numocts = 16;
   pvalue->heldCall.u._seq2.deviceID._base.u.otherPlan.data = testdata;
   }
   pvalue->heldCall.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_level3RegionalNumber;
   pvalue->heldCall.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   OSCRTLMEMSET (&(pvalue->heldCall.u._seq2.deviceID.mediaClass), 0, sizeof (
      pvalue->heldCall.u._seq2.deviceID.mediaClass));
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 1;
   pvalue->heldCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->heldCall.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->heldCall.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->heldCall.u._seq2.deviceID.connectionRate
       = OSI64CONST(1123890545047896064);
   pvalue->heldCall.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->heldCall.u._seq2.deviceID.bitRate = LocalDeviceID_bitRate_variable;
   pvalue->heldCall.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->heldCall.u._seq2.deviceID.delayTolerance
       = OSI64CONST(-6302923695144336309);
   pvalue->heldCall.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->heldCall.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_isdn;
   pvalue->heldCall.u._seq2.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x8e, 0xc9, 0x60, 0x5c, 0x2c, 0xa0, 0xc3, 0xfc, 
   0x38, 0x2f, 0x80, 0x94, 0xfe, 0x42, 0x55, 0xa1, 
   0x94, 0x37, 0x1d, 0x7f, 0xdc, 0x37, 0xa3, 0xb9, 
   0x2b, 0x20, 0x78, 0x5f, 0x59, 0x9e, 0xb5, 0xfe, 
   0x59, 0x39, 0x6f, 0x35, 0x27, 0xd2, 0xb3, 0x63 };
   pvalue->heldCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .numocts = 40;
   pvalue->heldCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->heldCall.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->activeCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->activeCall.u.deviceID));
   pvalue->activeCall.u.deviceID._base.t = 2;
   pvalue->activeCall.u.deviceID._base.u.number.value = 
      OSUTF8("pvalue->activeCall.u.deviceID._base.u.number");
   pvalue->activeCall.u.deviceID._base.u.number.cdata = FALSE;
   pvalue->activeCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_pTNSpecificNumber;
   pvalue->activeCall.u.deviceID.m.typeOfNumberPresent = 1;
   OSCRTLMEMSET (&(pvalue->activeCall.u.deviceID.mediaClass), 0, sizeof (pvalue
      ->activeCall.u.deviceID.mediaClass));
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_dataBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->activeCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->activeCall.u.deviceID.connectionRate
       = OSI64CONST(4059793076057538560);
   pvalue->activeCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->activeCall.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pvalue->activeCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->activeCall.u.deviceID.delayTolerance
       = OSI64CONST(-8642900390552125469);
   pvalue->activeCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->activeCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_isoEthernet;
   pvalue->activeCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x5b, 0xf8, 0xa7, 0x2a, 0xc7, 0xc3, 0xc9, 0xb0, 
   0xb1, 0x64, 0xe9, 0x8b, 0xaf, 0x7a, 0xa9, 0x96, 
   0xb0 };
   pvalue->activeCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 17;
   pvalue->activeCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->activeCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   return (pvalue);
}

ConferenceCallResponse_ELEM* Test_ConferenceCallResponse (OSCTXT* pctxt)
{
   ConferenceCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, ConferenceCallResponse_ELEM);
   Init_ConferenceCallResponse_ELEM (pctxt, pvalue);
   pvalue->conferenceCall.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->conferenceCall.u._seq2));
   pvalue->conferenceCall.u._seq2.callID.value = 
      OSUTF8("pvalue->conferenceCall.u._seq2.callID");
   pvalue->conferenceCall.u._seq2.callID.cdata = FALSE;

   pvalue->m.connectionsPresent = 1;
   { ConnectionListItem* pdata0;
   OSRTDList* plist = (OSRTDList*) (&(pvalue->connections));
   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);

   pdata0->m.endpointPresent = 1;
   pdata0->endpoint.t = 1;
   Init_DeviceID (pctxt, &(pdata0->endpoint.u.deviceID));
   pdata0->endpoint.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x17, 0x58, 0xa3, 0x87, 0x76, 0x52, 0x9d, 0xd9 };
   pdata0->endpoint.u.deviceID._base.u.otherPlan.numocts = 8;
   pdata0->endpoint.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pdata0->endpoint.u.deviceID.typeOfNumber
       = DeviceID_typeOfNumber_dialingNumber;
   pdata0->endpoint.u.deviceID.m.typeOfNumberPresent = 1;
   OSCRTLMEMSET (&(pdata0->endpoint.u.deviceID.mediaClass), 0, sizeof (pdata0->
      endpoint.u.deviceID.mediaClass));
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 0;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_dataBit = 0;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_imageBit = 1;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_audioBit = 0;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_otherBit = 1;
   pdata0->endpoint.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_chatBit = 1;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_emailBit = 0;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_messageBit = 0;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_smsBit = 0;
   pdata0->endpoint.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 1;
   pdata0->endpoint.u.deviceID.mediaClass._extItems = 0;

   pdata0->endpoint.u.deviceID.m.mediaClassPresent = 1;
   pdata0->endpoint.u.deviceID.connectionRate
       = OSI64CONST(782431215415197696);
   pdata0->endpoint.u.deviceID.m.connectionRatePresent = 1;
   pdata0->endpoint.u.deviceID.bitRate = DeviceID_bitRate_constant;
   pdata0->endpoint.u.deviceID.m.bitRatePresent = 1;
   pdata0->endpoint.u.deviceID.delayTolerance
       = OSI64CONST(-8018046850009781025);
   pdata0->endpoint.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->endpoint.u.deviceID.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_rsvp;
   pdata0->endpoint.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xd4, 0x66, 0x78, 0x8f, 0xca, 0xa0, 0xa9, 0xbe, 
   0xbe, 0x56, 0xd, 0xdd, 0xf1, 0xae, 0xa0, 0xdd, 
   0x17, 0x53, 0x7a, 0xf4, 0xd7, 0x8f, 0x9, 0xb7, 
   0x27, 0x4c, 0x23, 0x2c, 0x85, 0xf4, 0xe5, 0x87, 
   0x71, 0xe, 0x93, 0x62, 0xbd, 0x72, 0x5e };
   pdata0->endpoint.u.deviceID.switchingSubDomainInformationElements
      .numocts = 39;
   pdata0->endpoint.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->endpoint.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.associatedNIDPresent = 1;
   pdata0->associatedNID.t = 1;
   Init_DeviceID (pctxt, &(pdata0->associatedNID.u.deviceID));
   pdata0->associatedNID.u.deviceID._base.t = 2;
   pdata0->associatedNID.u.deviceID._base.u.number.value = 
      OSUTF8("pdata0->associatedNID.u.deviceID._base.u.number");
   pdata0->associatedNID.u.deviceID._base.u.number.cdata = FALSE;
   pdata0->associatedNID.u.deviceID.typeOfNumber
       = DeviceID_typeOfNumber_explicitPrivate_abbreviated;
   pdata0->associatedNID.u.deviceID.m.typeOfNumberPresent = 1;
   OSCRTLMEMSET (&(pdata0->associatedNID.u.deviceID.mediaClass), 0, sizeof (
      pdata0->associatedNID.u.deviceID.mediaClass));
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass._extItems = 0;

   pdata0->associatedNID.u.deviceID.m.mediaClassPresent = 1;
   pdata0->associatedNID.u.deviceID.connectionRate
       = OSI64CONST(5169239704071045120);
   pdata0->associatedNID.u.deviceID.m.connectionRatePresent = 1;
   pdata0->associatedNID.u.deviceID.bitRate = DeviceID_bitRate_variable;
   pdata0->associatedNID.u.deviceID.m.bitRatePresent = 1;
   pdata0->associatedNID.u.deviceID.delayTolerance
       = OSI64CONST(-2118290276893437385);
   pdata0->associatedNID.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->associatedNID.u.deviceID.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_other;
   pdata0->associatedNID.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xd2, 0x8e, 0x2f, 0x1b, 0x41, 0x4e, 0x40, 0xa3, 
   0xc, 0x1c, 0x43, 0x6c, 0xe5, 0xdc, 0xcb, 0xbf, 
   0xc3 };
   pdata0->associatedNID.u.deviceID.switchingSubDomainInformationElements
      .numocts = 17;
   pdata0->associatedNID.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->associatedNID.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);
   pdata0->m.newConnectionPresent = 1;
   pdata0->newConnection.t = 1;
   Init_LocalDeviceID (pctxt, &(pdata0->newConnection.u.deviceID));
   pdata0->newConnection.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x55, 0xa4 };
   pdata0->newConnection.u.deviceID._base.u.otherPlan.numocts = 2;
   pdata0->newConnection.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pdata0->newConnection.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_level1RegionalNumber;
   pdata0->newConnection.u.deviceID.m.typeOfNumberPresent = 1;
   OSCRTLMEMSET (&(pdata0->newConnection.u.deviceID.mediaClass), 0, sizeof (
      pdata0->newConnection.u.deviceID.mediaClass));
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pdata0->newConnection.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 1;
   pdata0->newConnection.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pdata0->newConnection.u.deviceID.mediaClass._extItems = 0;

   pdata0->newConnection.u.deviceID.m.mediaClassPresent = 1;
   pdata0->newConnection.u.deviceID.connectionRate
       = OSI64CONST(1940802393570541568);
   pdata0->newConnection.u.deviceID.m.connectionRatePresent = 1;
   pdata0->newConnection.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pdata0->newConnection.u.deviceID.m.bitRatePresent = 1;
   pdata0->newConnection.u.deviceID.delayTolerance
       = OSI64CONST(-2695748634270054682);
   pdata0->newConnection.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->newConnection.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_atm;
   pdata0->newConnection.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x12, 0x41, 0x42, 0xa2, 0xf2, 0x92, 0x86, 0xe7, 
   0xb5, 0x3f, 0x2d, 0x51, 0x41, 0xb0, 0xdf, 0xec, 
   0x3, 0x9f, 0xa5, 0xc2, 0xcc, 0x90, 0xd2, 0x8d, 
   0x8, 0xc1, 0xed, 0xa4, 0x3e, 0x2a, 0x9b, 0xb4, 
   0xbd, 0x19, 0xd, 0x9d, 0x5b, 0xf8, 0xfd, 0x7c, 
   0x9a, 0xec, 0xae, 0xc0, 0xbf, 0x36, 0xd, 0x61, 
   0x1, 0x97, 0xcc, 0xfd, 0xf5, 0x2b };
   pdata0->newConnection.u.deviceID.switchingSubDomainInformationElements
      .numocts = 54;
   pdata0->newConnection.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->newConnection.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.resultingConnectionInfoPresent = 1;
   pdata0->resultingConnectionInfo.m.flowDirectionPresent = 1;
   pdata0->resultingConnectionInfo.flowDirection
       = ConnectionInformation_flowDirect_receive;

   pdata0->resultingConnectionInfo.m.numberOfChannelsPresent = 1;
   pdata0->resultingConnectionInfo.numberOfChannels
       = OSI64CONST(1825023020726732996);

   pdata0->resultingConnectionInfo.m.mediaSessionInfoPresent = 1;
   pdata0->resultingConnectionInfo.mediaSessionInfo.value = 
      OSUTF8("pdata0->resultingConnectionInfo.mediaSessionInfo");
   pdata0->resultingConnectionInfo.mediaSessionInfo.cdata = FALSE;

   rtxDListAppend (pctxt, plist, pdata0);
   }

   return (pvalue);
}

