/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

ConsultationCall_ELEM* Test_ConsultationCall (OSCTXT* pctxt);
ConsultationCallResponse_ELEM* Test_ConsultationCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   ConsultationCallResponse_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_ConsultationCallResponse (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_ConsultationCallResponse (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

ConsultationCall_ELEM* Test_ConsultationCall (OSCTXT* pctxt)
{
   ConsultationCall_ELEM* pvalue = rtxMemAllocType (pctxt, ConsultationCall_ELEM);
   Init_ConsultationCall_ELEM (pctxt, pvalue);
   pvalue->existingCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->existingCall.u.deviceID));
   pvalue->existingCall.u.deviceID._base.t = 2;
   pvalue->existingCall.u.deviceID._base.u.number.value = 
      OSUTF8("pvalue->existingCall.u.deviceID._base.u.number");
   pvalue->existingCall.u.deviceID._base.u.number.cdata = FALSE;
   pvalue->existingCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_dialingNumber;
   pvalue->existingCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pvalue->existingCall.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->existingCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->existingCall.u.deviceID.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->existingCall.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->existingCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->existingCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->existingCall.u.deviceID.connectionRate
       = OSI64CONST(4193542179786445200);
   pvalue->existingCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->existingCall.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pvalue->existingCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->existingCall.u.deviceID.delayTolerance
       = OSI64CONST(-6058370810547970208);
   pvalue->existingCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->existingCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_isoEthernet;
   pvalue->existingCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x7d, 0x80, 0x13, 0x4f, 0x27, 0x6e, 0x6, 0xae, 
   0xf, 0xbd, 0xdf, 0xc2, 0x86, 0x6c, 0x2, 0xd, 
   0xe6, 0x22, 0x1f, 0x38, 0x9b, 0x1a, 0xc8, 0x11, 
   0x9, 0x84, 0x92, 0x97, 0xac, 0xb4, 0x6d, 0x17, 
   0xa0, 0x22, 0xd9, 0x80, 0xe4, 0x22, 0x20, 0xf0, 
   0x8e, 0x60, 0x29, 0x24, 0x4b, 0x74, 0x94, 0xbf, 
   0xce, 0x21, 0xd0, 0x29, 0x17, 0x8e, 0xa8, 0xe4, 
   0xaf, 0xa3, 0x19, 0x24, 0xc6, 0xc1 };
   pvalue->existingCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 62;
   pvalue->existingCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->existingCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->consultedDevice._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x2, 0x52, 0x78, 0xea, 0x9b, 0xe, 0x13, 0x7b, 
   0x1, 0x85, 0x81, 0x43, 0xa1, 0x92, 0x80, 0x0, 
   0x3b, 0xe2, 0x8, 0x80, 0x77, 0xf9, 0x5d, 0x44, 
   0x23, 0x49, 0xd9, 0x78, 0x46, 0xc3, 0xba, 0x60, 
   0x80, 0x1c, 0x4, 0x64, 0xe4, 0xf6, 0x64, 0x52, 
   0x46, 0x5b, 0xc, 0x92, 0x2d, 0x1d, 0xe9, 0x56, 
   0xe8, 0x8, 0x49, 0x77, 0xe5, 0x14, 0xb9, 0x23, 
   0xd2, 0x59, 0xc4, 0xfe, 0xb3, 0x22, 0x4c, 0x5e, 
   0xdf, 0xbb, 0x2a, 0x39, 0xa3, 0x69, 0x5a, 0x76 };
   pvalue->consultedDevice._base.u.otherPlan.numocts = 72;
   pvalue->consultedDevice._base.u.otherPlan.data = testdata;
   }
   pvalue->consultedDevice.typeOfNumber = DeviceID_typeOfNumber_dialingNumber;
   pvalue->consultedDevice.m.typeOfNumberPresent = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_notKnownBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_messageBit = 0;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->consultedDevice.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->consultedDevice.mediaClass._extItems = 0;

   pvalue->consultedDevice.m.mediaClassPresent = 1;
   pvalue->consultedDevice.connectionRate = OSI64CONST(8696153316037215600);
   pvalue->consultedDevice.m.connectionRatePresent = 1;
   pvalue->consultedDevice.bitRate = DeviceID_bitRate_variable;
   pvalue->consultedDevice.m.bitRatePresent = 1;
   pvalue->consultedDevice.delayTolerance = OSI64CONST(1811909720182933792);
   pvalue->consultedDevice.m.delayTolerancePresent = 1;
   pvalue->consultedDevice.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_other;
   pvalue->consultedDevice.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xe0, 0xcc, 0x26, 0x50, 0x45, 0x17, 0xad };
   pvalue->consultedDevice.switchingSubDomainInformationElements.numocts = 7;
   pvalue->consultedDevice.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->consultedDevice.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.connectionReservationPresent = 1;
   pvalue->connectionReservation = 1;

   pvalue->m.accountCodePresent = 1;
   { static const OSOCTET testdata[] = {
   0x23, 0xdd, 0xce, 0x64, 0xc4, 0x76, 0x5, 0xdb, 
   0xcb, 0x71, 0x72, 0xd1, 0x9b, 0x9b, 0x3, 0x51, 
   0x6b, 0x9c, 0x29, 0x87, 0x65, 0x13, 0x5a, 0x5d, 
   0xb3, 0x9a, 0xd1, 0xbd, 0x7c, 0xc7, 0xe1, 0x34, 
   0xd3, 0x7c, 0x53, 0xe1, 0xab, 0x9c, 0x93, 0xf9, 
   0x36 };
   pvalue->accountCode.numocts = 41;
   pvalue->accountCode.data = testdata;
   }

   pvalue->m.authCodePresent = 1;
   { static const OSOCTET testdata[] = {
   0xb3, 0x56, 0x84, 0x4d, 0xed, 0xa, 0x3c, 0xc3, 
   0xf4, 0xe8, 0x23, 0xee, 0x1d, 0x22, 0x63, 0x64, 
   0xa7, 0x9e, 0xfb, 0xc0, 0x29, 0xa0, 0xe5, 0x91, 
   0xdc, 0x97, 0x39, 0xad, 0xa2, 0x74, 0x2b, 0x8a, 
   0x14, 0x3c, 0x7a, 0x49, 0xe9, 0xa3, 0x9d, 0x6, 
   0x25, 0x70, 0xbb, 0x29, 0xa8, 0x6a, 0xdb, 0xba, 
   0xc5, 0x99 };
   pvalue->authCode.numocts = 50;
   pvalue->authCode.data = testdata;
   }

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 2;
   Init_UserData_private (pctxt, &(pvalue->userData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->userData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.callCharacteristicsPresent = 1;

   pvalue->callCharacteristics.m.lowPriorityCallPresent = 1;
   pvalue->callCharacteristics.lowPriorityCall = 1;

   pvalue->callCharacteristics.m.maintainanceCallPresent = 1;
   pvalue->callCharacteristics.maintainanceCall = 0;

   pvalue->callCharacteristics.m.directAgentPresent = 1;
   pvalue->callCharacteristics.directAgent = 1;

   pvalue->callCharacteristics.m.voiceUnitCallPresent = 1;
   pvalue->callCharacteristics.voiceUnitCall = 1;

   pvalue->callCharacteristics.m.privateCallPresent = 1;
   pvalue->callCharacteristics.privateCall = 0;

   pvalue->callCharacteristics.m.personalCallPresent = 1;
   pvalue->callCharacteristics.personalCall = 1;

   pvalue->callCharacteristics.m.confidentialCallPresent = 1;
   pvalue->callCharacteristics.confidentialCall = 0;

   pvalue->callCharacteristics.m.encryptedCallPresent = 1;
   pvalue->callCharacteristics.encryptedCall = 1;

   pvalue->m.mediaCallCharacteristicsPresent = 1;

   pvalue->mediaCallCharacteristics.mediaClass.m.imagePresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.image = 0;

   pvalue->mediaCallCharacteristics.mediaClass.m.audioPresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.audio = 1;

   pvalue->mediaCallCharacteristics.mediaClass.m.otherPresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.other = 1;

   pvalue->mediaCallCharacteristics.mediaClass.m.notKnownPresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.notKnown = 0;

   pvalue->mediaCallCharacteristics.mediaClass.m.imPresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.im = 1;

   pvalue->mediaCallCharacteristics.mediaClass.m.mmsPresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.mms = 1;

   pvalue->mediaCallCharacteristics.m.bitRatePresent = 1;
   pvalue->mediaCallCharacteristics.bitRate
       = MediaCallCharacteristics_bitRate_constant;

   pvalue->m.languagePreferencesPresent = 1;
   pvalue->languagePreferences.value = OSUTF8("pvalue->languagePreferences");
   pvalue->languagePreferences.cdata = FALSE;

   return (pvalue);
}

ConsultationCallResponse_ELEM* Test_ConsultationCallResponse (OSCTXT* pctxt)
{
   ConsultationCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, ConsultationCallResponse_ELEM);
   Init_ConsultationCallResponse_ELEM (pctxt, pvalue);
   pvalue->initiatedCall.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->initiatedCall.u._seq2));
   pvalue->initiatedCall.u._seq2.callID.value = 
      OSUTF8("pvalue->initiatedCall.u._seq2.callID");
   pvalue->initiatedCall.u._seq2.callID.cdata = FALSE;

   pvalue->initiatedCall.u._seq2.m.deviceIDPresent = 1;
   pvalue->initiatedCall.u._seq2.deviceID._base.t = 2;
   pvalue->initiatedCall.u._seq2.deviceID._base.u.number.value = 
      OSUTF8("pvalue->initiatedCall.u._seq2.deviceID._base.u.number");
   pvalue->initiatedCall.u._seq2.deviceID._base.u.number.cdata = FALSE;
   pvalue->initiatedCall.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_implicitPrivate;
   pvalue->initiatedCall.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 0;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 1;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pvalue->initiatedCall.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->initiatedCall.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->initiatedCall.u._seq2.deviceID.connectionRate
       = OSI64CONST(5432914324879727400);
   pvalue->initiatedCall.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->initiatedCall.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pvalue->initiatedCall.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->initiatedCall.u._seq2.deviceID.delayTolerance
       = OSI64CONST(5882725064797752592);
   pvalue->initiatedCall.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->initiatedCall.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_rsvp;
   pvalue->initiatedCall.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x93, 0x55, 0x62, 0x88, 0x1c, 0x50, 0x32, 0x53, 
   0x2, 0x52, 0xcc, 0x5b, 0xc8, 0x50, 0xa1, 0x98, 
   0x58, 0xc5, 0x66, 0x3c, 0xf8, 0x92, 0x80, 0xb5, 
   0x3e, 0x13, 0x63, 0x6b, 0x75, 0x1b, 0x93, 0xfb, 
   0xee, 0x77, 0xc7, 0x36, 0xab, 0x9e, 0x56, 0x9e, 
   0xd5, 0x2e, 0xdf, 0x32, 0x7, 0xdb, 0x78, 0x4a, 
   0xb7, 0x7b, 0x37, 0xbb, 0xe9, 0xc5, 0x60, 0x99, 
   0x6a, 0xf6, 0x2a, 0x4c, 0x2d, 0xf8, 0xc0, 0xc8, 
   0x25, 0x2d, 0x6, 0xa2, 0x30, 0x86 };
   pvalue->initiatedCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .numocts = 70;
   pvalue->initiatedCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->initiatedCall.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.mediaCallCharacteristicsPresent = 1;

   pvalue->mediaCallCharacteristics.mediaClass.m.imagePresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.image = 0;

   pvalue->mediaCallCharacteristics.mediaClass.m.audioPresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.audio = 1;

   pvalue->mediaCallCharacteristics.mediaClass.m.messagePresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.message = 1;

   pvalue->mediaCallCharacteristics.mediaClass.m.imPresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.im = 0;

   pvalue->mediaCallCharacteristics.mediaClass.m.smsPresent = 1;
   pvalue->mediaCallCharacteristics.mediaClass.sms = 0;

   pvalue->mediaCallCharacteristics.m.switchingSubDomainCCIETypePresent = 1;
   pvalue->mediaCallCharacteristics.switchingSubDomainCCIEType
       = MediaCallCharacteristics_switchi_isoEthernet;

   pvalue->mediaCallCharacteristics
      .m.switchingSubDomainInformationElementsPresent = 1;
   { static const OSOCTET testdata[] = {
   0xda, 0x78, 0xcf, 0x2d, 0xb8, 0x5, 0x9a, 0x65, 
   0xaf, 0x1d, 0x4d, 0x0, 0x61, 0xc0, 0x7c, 0xc6, 
   0x94, 0x6f, 0xf5, 0xb2, 0x8, 0x39, 0x5d, 0x19 };
   pvalue->mediaCallCharacteristics.switchingSubDomainInformationElements
      .numocts = 24;
   pvalue->mediaCallCharacteristics.switchingSubDomainInformationElements
      .data = testdata;
   }

   pvalue->m.initiatedCallInfoPresent = 1;
   pvalue->initiatedCallInfo.m.flowDirectionPresent = 1;
   pvalue->initiatedCallInfo.flowDirection
       = ConnectionInformation_flowDirect_transmitAndReceive;

   pvalue->initiatedCallInfo.m.numberOfChannelsPresent = 1;
   pvalue->initiatedCallInfo.numberOfChannels
       = OSI64CONST(5987436951687305392);

   return (pvalue);
}

