/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

DeflectCall_ELEM* Test_DeflectCall (OSCTXT* pctxt);
DeflectCallResponse_ELEM* Test_DeflectCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   DeflectCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_DeflectCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_DeflectCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

DeflectCall_ELEM* Test_DeflectCall (OSCTXT* pctxt)
{
   DeflectCall_ELEM* pvalue = rtxMemAllocType (pctxt, DeflectCall_ELEM);
   Init_DeflectCall_ELEM (pctxt, pvalue);
   pvalue->callToBeDiverted.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->callToBeDiverted.u._seq2));
   pvalue->callToBeDiverted.u._seq2.callID.value = 
      OSUTF8("pvalue->callToBeDiverted.u._seq2.callID");
   pvalue->callToBeDiverted.u._seq2.callID.cdata = FALSE;

   pvalue->callToBeDiverted.u._seq2.m.deviceIDPresent = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x4, 0xfe, 0x3f, 0xb7, 0x84, 0x14, 0xf6, 0xec, 
   0x86, 0x1c, 0x6e, 0xc7, 0x71, 0x94, 0xbc, 0xfd, 
   0x2, 0x88, 0xcf, 0xee, 0xdf, 0xce, 0xe6, 0x37, 
   0x55, 0x1, 0x96, 0x51, 0x23, 0x8c, 0xce, 0xf6, 
   0x33, 0xa1, 0x6c, 0x87 };
   pvalue->callToBeDiverted.u._seq2.deviceID._base.u.otherPlan.numocts = 36;
   pvalue->callToBeDiverted.u._seq2.deviceID._base.u.otherPlan
      .data = testdata;
   }
   pvalue->callToBeDiverted.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_level2RegionalNumber;
   pvalue->callToBeDiverted.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->callToBeDiverted.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->callToBeDiverted.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.connectionRate
       = OSI64CONST(6306076349426482200);
   pvalue->callToBeDiverted.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_variable;
   pvalue->callToBeDiverted.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.delayTolerance
       = OSI64CONST(-2170519784422961408);
   pvalue->callToBeDiverted.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->callToBeDiverted.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_rsvp;
   pvalue->callToBeDiverted.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x8f, 0xc7, 0x5b, 0x51, 0xde, 0xab, 0x74, 0xa4, 
   0xeb, 0xf1, 0x60, 0x86, 0x16, 0x9e, 0x72, 0x34, 
   0xe0, 0x47, 0x4e, 0xd2, 0x62, 0x56, 0xed, 0x7a, 
   0x77, 0xf7, 0x39, 0x84, 0xb1, 0xf4, 0x2f, 0x93 };
   pvalue->callToBeDiverted.u._seq2.deviceID.
      switchingSubDomainInformationElements.numocts = 32;
   pvalue->callToBeDiverted.u._seq2.deviceID.
      switchingSubDomainInformationElements.data = testdata;
   }
   pvalue->callToBeDiverted.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->newDestination._base.t = 2;
   pvalue->newDestination._base.u.number.value = 
      OSUTF8("pvalue->newDestination._base.u.number");
   pvalue->newDestination._base.u.number.cdata = FALSE;
   pvalue->newDestination.typeOfNumber
       = DeviceID_typeOfNumber_explicitPublic_international;
   pvalue->newDestination.m.typeOfNumberPresent = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_audioBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_notKnownBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_messageBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->newDestination.mediaClass._extItems = 0;

   pvalue->newDestination.m.mediaClassPresent = 1;
   pvalue->newDestination.connectionRate = OSI64CONST(7284231744429697200);
   pvalue->newDestination.m.connectionRatePresent = 1;
   pvalue->newDestination.bitRate = DeviceID_bitRate_constant;
   pvalue->newDestination.m.bitRatePresent = 1;
   pvalue->newDestination.delayTolerance = OSI64CONST(7320543124560751792);
   pvalue->newDestination.m.delayTolerancePresent = 1;
   pvalue->newDestination.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_isoEthernet;
   pvalue->newDestination.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xa0, 0x8e, 0xf9, 0x4, 0xf1, 0x6d, 0xa3, 0xde, 
   0x4d, 0x32, 0x10, 0xbb, 0x62, 0x54, 0xfb, 0xba, 
   0xfa, 0x21, 0xaf, 0xae, 0x6e, 0x7a, 0x98, 0x4a, 
   0xd3, 0x45, 0x4f, 0xc1, 0xfd, 0x87, 0x89, 0x5d, 
   0x83, 0x5e, 0x1, 0x66, 0xd5, 0xce, 0xe3, 0xf3, 
   0xa9, 0x93, 0xa4, 0xeb, 0xbb, 0x6f, 0xed, 0x56, 
   0xa8, 0x9f, 0x7a };
   pvalue->newDestination.switchingSubDomainInformationElements.numocts = 51;
   pvalue->newDestination.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->newDestination.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.correlatorDataPresent = 1;
   pvalue->correlatorData.t = 1;
   { static const OSOCTET testdata[] = {
   0xb2, 0xb9, 0x80, 0x7c, 0x3a, 0xce, 0xd6, 0x9c, 
   0xd3, 0xd6, 0x45, 0xc, 0xdd, 0x15, 0xc6, 0x5c, 
   0x5f, 0xf3, 0xde, 0xef, 0x1f, 0x11, 0xd, 0xfb, 
   0xaa, 0x85, 0x9, 0x9f, 0x17, 0x69, 0x3d, 0x3b, 
   0x1d, 0x5d, 0x41, 0xdb, 0xcf, 0x99, 0xb7, 0x72, 
   0x22, 0x4c, 0xcb, 0xa3, 0xf0, 0x41, 0x41, 0xeb, 
   0x2f, 0x22, 0xca, 0xe9, 0x93, 0xc6, 0x1d, 0xfe, 
   0x4d, 0xed, 0x67, 0xa1, 0x18, 0x46, 0x3a };
   pvalue->correlatorData.u.string.numocts = 63;
   pvalue->correlatorData.u.string.data = testdata;
   }

   pvalue->m.languagePreferencesPresent = 1;
   pvalue->languagePreferences.value = OSUTF8("pvalue->languagePreferences");
   pvalue->languagePreferences.cdata = FALSE;

   pvalue->m.reasonPresent = 1;
   pvalue->reason = EventCause_callForwardImmediate;

   return (pvalue);
}

DeflectCallResponse_ELEM* Test_DeflectCallResponse (OSCTXT* pctxt)
{
   DeflectCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, DeflectCallResponse_ELEM);
   Init_DeflectCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   return (pvalue);
}

