/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

DirectedPickupCall_ELEM* Test_DirectedPickupCall (OSCTXT* pctxt);
DirectedPickupCallResponse_ELEM* Test_DirectedPickupCallResponse(OSCTXT* pctxt);

int main (int argc, char** argv)
{
   DirectedPickupCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_DirectedPickupCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_DirectedPickupCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

DirectedPickupCall_ELEM* Test_DirectedPickupCall (OSCTXT* pctxt)
{
   DirectedPickupCall_ELEM* pvalue = rtxMemAllocType (pctxt, DirectedPickupCall_ELEM);
   Init_DirectedPickupCall_ELEM (pctxt, pvalue);
   pvalue->callToBePickedUp.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->callToBePickedUp.u._seq2));
   pvalue->callToBePickedUp.u._seq2.callID.value = 
      OSUTF8("pvalue->callToBePickedUp.u._seq2.callID");
   pvalue->callToBePickedUp.u._seq2.callID.cdata = FALSE;

   pvalue->requestingDevice._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x99, 0xfe, 0x4f, 0x65, 0x35, 0x5a };
   pvalue->requestingDevice._base.u.otherPlan.numocts = 6;
   pvalue->requestingDevice._base.u.otherPlan.data = testdata;
   }
   pvalue->requestingDevice.typeOfNumber
       = DeviceID_typeOfNumber_explicitPrivate_unknown;
   pvalue->requestingDevice.m.typeOfNumberPresent = 1;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_notKnownBit = 0;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_messageBit = 0;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->requestingDevice.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->requestingDevice.mediaClass._extItems = 0;

   pvalue->requestingDevice.m.mediaClassPresent = 1;
   pvalue->requestingDevice.connectionRate = OSI64CONST(9057296732379409800);
   pvalue->requestingDevice.m.connectionRatePresent = 1;
   pvalue->requestingDevice.bitRate = DeviceID_bitRate_variable;
   pvalue->requestingDevice.m.bitRatePresent = 1;
   pvalue->requestingDevice.delayTolerance = OSI64CONST(-7420751274379786208);
   pvalue->requestingDevice.m.delayTolerancePresent = 1;
   pvalue->requestingDevice.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_other;
   pvalue->requestingDevice.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x62, 0x86, 0x85, 0x6e, 0x5c, 0xcb, 0x69, 0x4a, 
   0x4c, 0x1f, 0x8, 0x28, 0x78, 0xfd, 0xb2, 0xfe, 
   0x74, 0x77, 0xa0, 0xb0, 0xc4, 0xce, 0x65, 0x37, 
   0x1a, 0x4d, 0x38, 0xe2, 0x6d, 0x92, 0xec, 0xf5, 
   0xf5, 0xb3, 0xc9, 0xb9, 0xc4 };
   pvalue->requestingDevice.switchingSubDomainInformationElements
      .numocts = 37;
   pvalue->requestingDevice.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->requestingDevice
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.correlatorDataPresent = 1;
   pvalue->correlatorData.t = 2;
   Init_CorrelatorData_private (pctxt, &(pvalue->correlatorData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->correlatorData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 2;
   Init_UserData_private (pctxt, &(pvalue->userData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->userData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   return (pvalue);
}

DirectedPickupCallResponse_ELEM*
    Test_DirectedPickupCallResponse (OSCTXT* pctxt)
{
   DirectedPickupCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, DirectedPickupCallResponse_ELEM);
   Init_DirectedPickupCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.pickedCallPresent = 1;
   pvalue->pickedCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->pickedCall.u.deviceID));
   pvalue->pickedCall.u.deviceID._base.t = 2;
   pvalue->pickedCall.u.deviceID._base.u.number.value = 
      OSUTF8("pvalue->pickedCall.u.deviceID._base.u.number");
   pvalue->pickedCall.u.deviceID._base.u.number.cdata = FALSE;
   pvalue->pickedCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_abbreviated;
   pvalue->pickedCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->pickedCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->pickedCall.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->pickedCall.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->pickedCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->pickedCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->pickedCall.u.deviceID.connectionRate
       = OSI64CONST(7362484176029954400);
   pvalue->pickedCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->pickedCall.u.deviceID.bitRate = LocalDeviceID_bitRate_variable;
   pvalue->pickedCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->pickedCall.u.deviceID.delayTolerance
       = OSI64CONST(-1335639524975613008);
   pvalue->pickedCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->pickedCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pvalue->pickedCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xb3, 0x9f, 0x17 };
   pvalue->pickedCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 3;
   pvalue->pickedCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->pickedCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   return (pvalue);
}

