/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

GroupPickupCall_ELEM* Test_GroupPickupCall (OSCTXT* pctxt);
GroupPickupCallResponse_ELEM* Test_GroupPickupCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   GroupPickupCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_GroupPickupCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_GroupPickupCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

GroupPickupCall_ELEM* Test_GroupPickupCall (OSCTXT* pctxt)
{
   GroupPickupCall_ELEM* pvalue = rtxMemAllocType (pctxt, GroupPickupCall_ELEM);
   Init_GroupPickupCall_ELEM (pctxt, pvalue);
   pvalue->newDestination._base.t = 2;
   pvalue->newDestination._base.u.number.value = 
      OSUTF8("pvalue->newDestination._base.u.number");
   pvalue->newDestination._base.u.number.cdata = FALSE;
   pvalue->newDestination.typeOfNumber
       = DeviceID_typeOfNumber_explicitPublic_subscriber;
   pvalue->newDestination.m.typeOfNumberPresent = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_dataBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_audioBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_notKnownBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->newDestination.mediaClass.MediaClassComponents_messageBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->newDestination.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->newDestination.mediaClass._extItems = 0;

   pvalue->newDestination.m.mediaClassPresent = 1;
   pvalue->newDestination.connectionRate = OSI64CONST(5822487581479569000);
   pvalue->newDestination.m.connectionRatePresent = 1;
   pvalue->newDestination.bitRate = DeviceID_bitRate_constant;
   pvalue->newDestination.m.bitRatePresent = 1;
   pvalue->newDestination.delayTolerance = OSI64CONST(7512514917191598592);
   pvalue->newDestination.m.delayTolerancePresent = 1;
   pvalue->newDestination.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_sip;
   pvalue->newDestination.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xbe, 0xa0, 0xb1, 0x68, 0x1e, 0xea, 0x80, 0x4e, 
   0xf7, 0x27, 0xa4, 0xa3, 0x2d, 0x81, 0xfc, 0x87, 
   0x6e, 0x6c, 0xc9, 0x14, 0x11, 0x46, 0xae, 0xf4, 
   0x14, 0xc2, 0xaf, 0x76, 0xcc, 0x85, 0x3c, 0xf8, 
   0xcc, 0x77, 0x80, 0x89, 0x71, 0xa9, 0x8a, 0x89, 
   0xbf, 0xda, 0xfa, 0x9f, 0x62, 0x7f, 0x59, 0x59, 
   0x82, 0x49, 0xb7, 0x49, 0xd7, 0x97, 0x3a, 0x7b, 
   0x6, 0x57, 0x45, 0x88, 0x44, 0x2d, 0x4a, 0x2b, 
   0xde, 0x7d, 0xd, 0x1b, 0xfd, 0x20, 0xc7, 0x94, 
   0xd9, 0x5d };
   pvalue->newDestination.switchingSubDomainInformationElements.numocts = 74;
   pvalue->newDestination.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->newDestination.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->pickGroup._base.t = 1;
   { static const OSOCTET testdata[] = {
   0xcb, 0x39, 0x80, 0x6e, 0xb4, 0x60, 0x96, 0x6d, 
   0x5e, 0xd8, 0x2b, 0xab, 0x4a, 0xac, 0x22, 0x37, 
   0x82, 0x7 };
   pvalue->pickGroup._base.u.otherPlan.numocts = 18;
   pvalue->pickGroup._base.u.otherPlan.data = testdata;
   }
   pvalue->pickGroup.typeOfNumber
       = DeviceID_typeOfNumber_explicitPublic_international;
   pvalue->pickGroup.m.typeOfNumberPresent = 1;
   pvalue->pickGroup.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->pickGroup.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->pickGroup.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->pickGroup.mediaClass.MediaClassComponents_audioBit = 0;
   pvalue->pickGroup.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->pickGroup.mediaClass.MediaClassComponents_notKnownBit = 1;
   pvalue->pickGroup.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->pickGroup.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->pickGroup.mediaClass.MediaClassComponents_messageBit = 1;
   pvalue->pickGroup.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->pickGroup.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->pickGroup.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->pickGroup.mediaClass._extItems = 0;

   pvalue->pickGroup.m.mediaClassPresent = 1;
   pvalue->pickGroup.connectionRate = OSI64CONST(1683834697240066800);
   pvalue->pickGroup.m.connectionRatePresent = 1;
   pvalue->pickGroup.bitRate = DeviceID_bitRate_variable;
   pvalue->pickGroup.m.bitRatePresent = 1;
   pvalue->pickGroup.delayTolerance = OSI64CONST(-825028334605589408);
   pvalue->pickGroup.m.delayTolerancePresent = 1;
   pvalue->pickGroup.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_rsvp;
   pvalue->pickGroup.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x3f, 0x39, 0x61, 0xde, 0x15, 0x6f, 0xf, 0x78, 
   0xa8, 0xd5, 0xda, 0x7f, 0x17, 0x1b, 0xd2, 0x3f, 
   0x72, 0xa0, 0x68, 0x5b, 0x91, 0x37, 0x4d, 0x98, 
   0xe9, 0x5, 0x4e, 0x8d, 0xfa, 0x79, 0x8b, 0xcf, 
   0xe1, 0x70, 0x1e, 0x56, 0x33, 0xea, 0x77, 0x24, 
   0x9d, 0x83, 0x9c, 0x6d, 0x7d, 0x7e, 0x5, 0x4a, 
   0xd8, 0x19, 0x33, 0x2f };
   pvalue->pickGroup.switchingSubDomainInformationElements.numocts = 52;
   pvalue->pickGroup.switchingSubDomainInformationElements.data = testdata;
   }
   pvalue->pickGroup.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.correlatorDataPresent = 1;
   pvalue->correlatorData.t = 2;
   Init_CorrelatorData_private (pctxt, &(pvalue->correlatorData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->correlatorData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.extensionsPresent = 1;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 1;
   { static const OSOCTET testdata[] = {
   0x54, 0xc8, 0x9e, 0xa1, 0xef, 0x81, 0xd, 0xba, 
   0xcc, 0x7b, 0x6a, 0xe7, 0x22, 0x6f, 0x9f, 0xd4, 
   0xee, 0x94, 0x29, 0xf6, 0x62, 0xfa, 0x42, 0x89, 
   0x2e, 0x21, 0x5, 0xd3, 0x8b, 0x66, 0xcd, 0x80, 
   0x3, 0x65 };
   pvalue->extensions.privateData.u.string.numocts = 34;
   pvalue->extensions.privateData.u.string.data = testdata;
   }

   return (pvalue);
}

GroupPickupCallResponse_ELEM* Test_GroupPickupCallResponse (OSCTXT* pctxt)
{
   GroupPickupCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, GroupPickupCallResponse_ELEM);
   Init_GroupPickupCallResponse_ELEM (pctxt, pvalue);

   return (pvalue);
}

