/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

HoldCall_ELEM* Test_HoldCall (OSCTXT* pctxt);
HoldCallResponse_ELEM* Test_HoldCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   HoldCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_HoldCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_HoldCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

HoldCall_ELEM* Test_HoldCall (OSCTXT* pctxt)
{
   HoldCall_ELEM* pvalue = rtxMemAllocType (pctxt, HoldCall_ELEM);
   Init_HoldCall_ELEM (pctxt, pvalue);
   pvalue->callToBeHeld.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->callToBeHeld.u._seq2));
   pvalue->callToBeHeld.u._seq2.callID.value = 
      OSUTF8("pvalue->callToBeHeld.u._seq2.callID");
   pvalue->callToBeHeld.u._seq2.callID.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 1;
   { static const OSOCTET testdata[] = {
   0xd5, 0x6, 0xa0, 0x18, 0xcf, 0xc8, 0xcb, 0xc2, 
   0xbf, 0x3b, 0x74, 0x82, 0x33, 0xac, 0x7c, 0xf9, 
   0x9c, 0x7e, 0xe8, 0xeb, 0x88, 0x45, 0x88, 0x88, 
   0xcb, 0x97, 0x94, 0xe0, 0xaf, 0xd2, 0xf7, 0x6e, 
   0x7e, 0xdb, 0xa5, 0x3f, 0xeb, 0x9, 0x4f, 0x49, 
   0x55, 0x67, 0xca, 0x68, 0x3f, 0xe5, 0x81, 0xf8, 
   0xb, 0x9d, 0x37, 0x46, 0xe1, 0x58, 0xfc, 0x3, 
   0x2e, 0xf0, 0xae, 0xa2, 0xc0 };
   pvalue->extensions.privateData.u.string.numocts = 61;
   pvalue->extensions.privateData.u.string.data = testdata;
   }

   return (pvalue);
}

HoldCallResponse_ELEM* Test_HoldCallResponse (OSCTXT* pctxt)
{
   HoldCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, HoldCallResponse_ELEM);
   Init_HoldCallResponse_ELEM (pctxt, pvalue);

   return (pvalue);
}

