/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

IntrudeCall_ELEM* Test_IntrudeCall (OSCTXT* pctxt);
IntrudeCallResponse_ELEM* Test_IntrudeCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   IntrudeCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_IntrudeCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_IntrudeCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

IntrudeCall_ELEM* Test_IntrudeCall (OSCTXT* pctxt)
{
   IntrudeCall_ELEM* pvalue = rtxMemAllocType (pctxt, IntrudeCall_ELEM);
   Init_IntrudeCall_ELEM (pctxt, pvalue);
   pvalue->intrude.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->intrude.u._seq2));
   pvalue->intrude.u._seq2.callID.value = 
      OSUTF8("pvalue->intrude.u._seq2.callID");
   pvalue->intrude.u._seq2.callID.cdata = FALSE;

   pvalue->intrude.u._seq2.m.deviceIDPresent = 1;
   pvalue->intrude.u._seq2.deviceID._base.t = 2;
   pvalue->intrude.u._seq2.deviceID._base.u.number.value = 
      OSUTF8("pvalue->intrude.u._seq2.deviceID._base.u.number");
   pvalue->intrude.u._seq2.deviceID._base.u.number.cdata = FALSE;
   pvalue->intrude.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_implicitPrivate;
   pvalue->intrude.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pvalue->intrude.u._seq2.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->intrude.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->intrude.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->intrude.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->intrude.u._seq2.deviceID.connectionRate
       = OSI64CONST(8613397147366440000);
   pvalue->intrude.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->intrude.u._seq2.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pvalue->intrude.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->intrude.u._seq2.deviceID.delayTolerance
       = OSI64CONST(-4821532017556854608);
   pvalue->intrude.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->intrude.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_isoEthernet;
   pvalue->intrude.u._seq2.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x70, 0xda, 0xa, 0x39, 0xae, 0x59, 0xb0, 0xeb, 
   0xe6, 0xe3, 0x10, 0x99, 0xa6, 0x3c, 0xd5, 0x16, 
   0x92, 0x5e, 0x95, 0x4e, 0x41, 0xb7, 0xbc, 0xa8, 
   0x1d, 0x51, 0x8e, 0x6e, 0x56, 0xc9, 0x58, 0xfd, 
   0xc2, 0x91, 0x49, 0xd, 0x30, 0x2f, 0xb1, 0xc8, 
   0x90, 0x18, 0x6, 0x82, 0x88, 0x5a, 0x7b, 0x49, 
   0xae, 0x1d, 0xc, 0x95, 0x22, 0x3e, 0x38, 0x64, 
   0xb7, 0xd, 0xde, 0x72, 0xe4, 0xe7 };
   pvalue->intrude.u._seq2.deviceID.switchingSubDomainInformationElements
      .numocts = 62;
   pvalue->intrude.u._seq2.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->intrude.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->participationType = ParticipationType_active;

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 1;
   { static const OSOCTET testdata[] = {
   0xe9, 0x94, 0xe1, 0x82, 0xfd, 0xd0, 0x25, 0x1c, 
   0x89, 0x91, 0xf1, 0xe1, 0xa9, 0xee, 0x73, 0x2f, 
   0xfe, 0x2b, 0xa0, 0x18, 0x8d, 0xb6, 0x88, 0xac, 
   0xcc, 0x84, 0x8f, 0xab, 0x53, 0x8a, 0x4f, 0x22 };
   pvalue->userData.u.string.numocts = 32;
   pvalue->userData.u.string.data = testdata;
   }

   return (pvalue);
}

IntrudeCallResponse_ELEM* Test_IntrudeCallResponse (OSCTXT* pctxt)
{
   IntrudeCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, IntrudeCallResponse_ELEM);
   Init_IntrudeCallResponse_ELEM (pctxt, pvalue);

   pvalue->m.conferencedCallInfoPresent = 1;

   pvalue->conferencedCallInfo.m.numberOfChannelsPresent = 1;
   pvalue->conferencedCallInfo.numberOfChannels
       = OSI64CONST(7813702333782516592);

   return (pvalue);
}

