/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxsrc/rtxStreamFile.h"
#include "rtxmlsrc/rtSaxCParser.h"
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

int main (int argc, char** argv)
{
   JoinCall_ELEM pdu;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-i")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: reader [-v] [-i <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -i <filename>  read encoded msg from <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Init PDU data type variable */

   Init_JoinCall_ELEM (&ctxt, &pdu);

   /* Create input source object */

   stat = rtxStreamFileOpen (&ctxt, filename, OSRTSTRMF_INPUT);
   if (stat != 0) {
      rtxErrPrint (&ctxt);
      return stat;
   }

   /* Decode */

   if (0 == stat)
      stat = XmlD_JoinCall (&ctxt, &pdu);

   if (0 == stat) {
      if (trace) {
         printf ("Decode was successful\n");
         printf ("Decoded record:\n");
         Print_JoinCall_ELEM ("JoinCall", &(pdu));
      }
   }
   else if (trace) {
      printf ("decode failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxStreamClose (&ctxt);
   rtxFreeContext (&ctxt);

   return stat;
}
