/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

JoinCall_ELEM* Test_JoinCall (OSCTXT* pctxt);
JoinCallResponse_ELEM* Test_JoinCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   JoinCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_JoinCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_JoinCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

JoinCall_ELEM* Test_JoinCall (OSCTXT* pctxt)
{
   JoinCall_ELEM* pvalue = rtxMemAllocType (pctxt, JoinCall_ELEM);
   Init_JoinCall_ELEM (pctxt, pvalue);
   pvalue->activeCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->activeCall.u.deviceID));
   pvalue->activeCall.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x28, 0x18, 0x80, 0xac, 0x79, 0x5a, 0x7a, 0xc9, 
   0x2c, 0xc8, 0x49, 0x8f, 0xcb, 0x81, 0x7, 0x94, 
   0x27, 0x39, 0x78, 0x16, 0xa9, 0xf0, 0x8e, 0xba, 
   0x3a, 0x32, 0xa9, 0x1b, 0x9e, 0x37, 0x46, 0x9, 
   0xbf, 0x63, 0x11, 0xac, 0xe5, 0x6c, 0x8d, 0x5b, 
   0xb6, 0xa1, 0xc3, 0xd5, 0x96, 0xa1, 0xb4, 0x47, 
   0x38, 0x7b, 0x7b, 0xb0, 0x6a, 0x8f, 0xd5, 0x1d, 
   0x88, 0x95, 0x2, 0x4d, 0x8d, 0xaa, 0x37, 0xb1 };
   pvalue->activeCall.u.deviceID._base.u.otherPlan.numocts = 64;
   pvalue->activeCall.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pvalue->activeCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_abbreviated;
   pvalue->activeCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->activeCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->activeCall.u.deviceID.connectionRate
       = OSI64CONST(976185010034863200);
   pvalue->activeCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->activeCall.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pvalue->activeCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->activeCall.u.deviceID.delayTolerance
       = OSI64CONST(-3274498333833784208);
   pvalue->activeCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->activeCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pvalue->activeCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xb3, 0x8a, 0x52, 0x8c, 0x15, 0xe8, 0xa6, 0x6b, 
   0xd6, 0x90, 0xb6, 0x24, 0xee, 0x83, 0xad, 0x64, 
   0x7f, 0xe, 0x33, 0xd1, 0xd, 0x95, 0xe, 0xe4, 
   0x6b, 0x88, 0xea, 0xfa, 0x37 };
   pvalue->activeCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 29;
   pvalue->activeCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->activeCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->joiningDevice._base.t = 2;
   pvalue->joiningDevice._base.u.number.value = 
      OSUTF8("pvalue->joiningDevice._base.u.number");
   pvalue->joiningDevice._base.u.number.cdata = FALSE;
   pvalue->joiningDevice.typeOfNumber
       = DeviceID_typeOfNumber_explicitPrivate_pTNSpecificNumber;
   pvalue->joiningDevice.m.typeOfNumberPresent = 1;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_dataBit = 0;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_audioBit = 0;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_notKnownBit = 1;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_messageBit = 0;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->joiningDevice.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->joiningDevice.mediaClass._extItems = 0;

   pvalue->joiningDevice.m.mediaClassPresent = 1;
   pvalue->joiningDevice.connectionRate = OSI64CONST(6477499841673088800);
   pvalue->joiningDevice.m.connectionRatePresent = 1;
   pvalue->joiningDevice.bitRate = DeviceID_bitRate_variable;
   pvalue->joiningDevice.m.bitRatePresent = 1;
   pvalue->joiningDevice.delayTolerance = OSI64CONST(2673812402053392592);
   pvalue->joiningDevice.m.delayTolerancePresent = 1;
   pvalue->joiningDevice.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_isdn;
   pvalue->joiningDevice.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x76, 0x8d, 0x9f, 0xc6, 0x4c, 0x43, 0xa2, 0xef, 
   0x55, 0xcb, 0x9f, 0xb9, 0x26, 0x78, 0xab, 0x11, 
   0xb8, 0x67, 0x8f, 0xdd, 0x3d, 0x13, 0x73, 0x22, 
   0x89, 0x1f, 0x4f, 0xaa, 0xe0, 0x6, 0x15, 0x1a, 
   0x1b, 0xbb, 0x3d, 0x6c, 0x72, 0x55, 0xfe, 0xbe, 
   0xf1, 0x47, 0xfb, 0x75, 0xd2, 0x5c, 0x23, 0x96 };
   pvalue->joiningDevice.switchingSubDomainInformationElements.numocts = 48;
   pvalue->joiningDevice.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->joiningDevice.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->autoOriginate = AutoOriginate_doNotPrompt;

   pvalue->participationType = ParticipationType_active;

   pvalue->m.authCodePresent = 1;
   { static const OSOCTET testdata[] = {
   0xa8, 0xf3, 0x7d, 0x13, 0x11, 0xf };
   pvalue->authCode.numocts = 6;
   pvalue->authCode.data = testdata;
   }

   pvalue->m.correlatorDataPresent = 1;
   pvalue->correlatorData.t = 2;
   Init_CorrelatorData_private (pctxt, &(pvalue->correlatorData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->correlatorData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 1;
   { static const OSOCTET testdata[] = {
   0xb6, 0x2a, 0x31, 0xfd, 0x1d, 0x70, 0x5f, 0xb4, 
   0xf9, 0x8b, 0x62, 0xdd, 0x58, 0xad, 0x3, 0xd0, 
   0x48, 0x93, 0xe0, 0x5c, 0x2a, 0x90, 0xfa, 0x6a, 
   0xbc, 0xa2, 0xec, 0xa7, 0x4c, 0x31, 0x47, 0xb6, 
   0x1d, 0xad, 0xca, 0x68, 0x55, 0x19, 0xde, 0x93, 
   0xa, 0xaf, 0xf, 0xee, 0xb5, 0xd3, 0xfd, 0x1a, 
   0x3d, 0x59, 0x71, 0xae, 0x41, 0xd3, 0x88, 0x84, 
   0xe3, 0x9d, 0x33, 0x8c, 0x4c, 0x9c, 0x75, 0xe0, 
   0xfb, 0x8a, 0x98, 0xf8, 0x52, 0x47, 0xcd, 0x17, 
   0xc6, 0x71, 0x6a };
   pvalue->userData.u.string.numocts = 75;
   pvalue->userData.u.string.data = testdata;
   }

   pvalue->m.extensionsPresent = 1;

   return (pvalue);
}

JoinCallResponse_ELEM* Test_JoinCallResponse (OSCTXT* pctxt)
{
   JoinCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, JoinCallResponse_ELEM);
   Init_JoinCallResponse_ELEM (pctxt, pvalue);
   pvalue->conferencedCall.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->conferencedCall.u._seq2));
   pvalue->conferencedCall.u._seq2.callID.value = 
      OSUTF8("pvalue->conferencedCall.u._seq2.callID");
   pvalue->conferencedCall.u._seq2.callID.cdata = FALSE;

   pvalue->m.conferencedCallInfoPresent = 1;
   pvalue->conferencedCallInfo.m.flowDirectionPresent = 1;
   pvalue->conferencedCallInfo.flowDirection
       = ConnectionInformation_flowDirect_receive;

   pvalue->conferencedCallInfo.m.mediaSessionInfoPresent = 1;
   pvalue->conferencedCallInfo.mediaSessionInfo.value = 
      OSUTF8("pvalue->conferencedCallInfo.mediaSessionInfo");
   pvalue->conferencedCallInfo.mediaSessionInfo.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;

   return (pvalue);
}

