/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

MakeCall_ELEM* Test_MakeCall (OSCTXT* pctxt);
MakeCallResponse_ELEM* Test_MakeCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   MakeCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);

   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_MakeCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_MakeCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

MakeCall_ELEM* Test_MakeCall (OSCTXT* pctxt)
{
   MakeCall_ELEM* pvalue = rtxMemAllocType (pctxt, MakeCall_ELEM);
   Init_MakeCall_ELEM (pctxt, pvalue);
   pvalue->callingDevice._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x72, 0x14, 0x7a, 0xc8, 0xf2, 0x33, 0xf1, 0x41, 
   0x4d, 0x1b, 0x7d, 0x53, 0x76, 0x96, 0x8f, 0x0, 
   0xa0, 0xf, 0x81, 0x96, 0xf5, 0x13, 0x71, 0xc3, 
   0xb2, 0xf0, 0x1e, 0x74, 0xc0, 0x7d, 0x80, 0x2d, 
   0x95, 0x9b, 0xf0, 0x1c, 0x42, 0x8c, 0x8a, 0x7f, 
   0xd, 0xb8, 0x30, 0x37, 0x11, 0x5a, 0xc4, 0x8f, 
   0x2b, 0xcd, 0x9c, 0xa1, 0xb3, 0x70, 0x23, 0x4c, 
   0xcc, 0x49, 0x3e, 0xb5, 0xc8, 0xe7, 0x7b, 0xcb, 
   0xe6, 0x33, 0x6f, 0x28, 0xf5, 0x98, 0xf9, 0xef, 
   0x16, 0xda };
   pvalue->callingDevice._base.u.otherPlan.numocts = 74;
   pvalue->callingDevice._base.u.otherPlan.data = testdata;
   }
   pvalue->callingDevice.typeOfNumber = DeviceID_typeOfNumber_implicitPublic;
   pvalue->callingDevice.m.typeOfNumberPresent = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_notKnownBit = 0;
   pvalue->callingDevice.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_messageBit = 0;
   pvalue->callingDevice.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->callingDevice.mediaClass._extItems = 0;

   pvalue->callingDevice.m.mediaClassPresent = 1;
   pvalue->callingDevice.connectionRate = OSI64CONST(819961630401256200);
   pvalue->callingDevice.m.connectionRatePresent = 1;
   pvalue->callingDevice.bitRate = DeviceID_bitRate_variable;
   pvalue->callingDevice.m.bitRatePresent = 1;
   pvalue->callingDevice.delayTolerance = OSI64CONST(-8028192811765955408);
   pvalue->callingDevice.m.delayTolerancePresent = 1;
   pvalue->callingDevice.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_atm;
   pvalue->callingDevice.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x49, 0x1c, 0xfd, 0x1d, 0xb4, 0x88, 0x8d, 0xc7, 
   0x9a, 0x4a, 0x9, 0x56, 0x3e, 0x1e, 0x5c, 0x4e, 
   0x55, 0xbf, 0x7a, 0xaa, 0x48, 0xbd, 0x33 };
   pvalue->callingDevice.switchingSubDomainInformationElements.numocts = 23;
   pvalue->callingDevice.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->callingDevice.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->calledDirectoryNumber._base.t = 2;
   pvalue->calledDirectoryNumber._base.u.number.value = 
      OSUTF8("pvalue->calledDirectoryNumber._base.u.number");
   pvalue->calledDirectoryNumber._base.u.number.cdata = FALSE;
   pvalue->calledDirectoryNumber.typeOfNumber
       = DeviceID_typeOfNumber_explicitPublic_international;
   pvalue->calledDirectoryNumber.m.typeOfNumberPresent = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->calledDirectoryNumber.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->calledDirectoryNumber.mediaClass
      .MediaClassComponents_messageBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->calledDirectoryNumber.mediaClass._extItems = 0;

   pvalue->calledDirectoryNumber.m.mediaClassPresent = 1;
   pvalue->calledDirectoryNumber.connectionRate
       = OSI64CONST(4101778536974632800);
   pvalue->calledDirectoryNumber.m.connectionRatePresent = 1;
   pvalue->calledDirectoryNumber.bitRate = DeviceID_bitRate_constant;
   pvalue->calledDirectoryNumber.m.bitRatePresent = 1;
   pvalue->calledDirectoryNumber.delayTolerance
       = OSI64CONST(-4509648225423455408);
   pvalue->calledDirectoryNumber.m.delayTolerancePresent = 1;
   pvalue->calledDirectoryNumber.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_rsvp;
   pvalue->calledDirectoryNumber.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x56, 0xb4, 0x59, 0x2e, 0x27, 0x53, 0xcd, 0xdb, 
   0xc, 0x3c, 0x32, 0xa6, 0xd3, 0x45, 0x82, 0xd1, 
   0x4f, 0x56, 0x2e, 0x6a, 0x87, 0xaa, 0xcd, 0x1, 
   0x7b, 0xd3, 0xb8, 0x31, 0x3a, 0x48, 0xe0, 0xdb, 
   0x38, 0xaf, 0x5, 0xe5, 0x9b, 0xc9, 0x88, 0x83, 
   0xf6, 0x98, 0x4, 0x4b, 0x9a, 0xab, 0x70, 0x96, 
   0x2, 0x40, 0xe5, 0x79, 0x7d, 0xf8, 0x68, 0x50, 
   0x9c, 0x83, 0xab, 0x25, 0x84, 0xd6, 0xc3, 0x7a, 
   0xac, 0x5f, 0xc8, 0x35, 0xa6, 0xdf };
   pvalue->calledDirectoryNumber.switchingSubDomainInformationElements
      .numocts = 70;
   pvalue->calledDirectoryNumber.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->calledDirectoryNumber
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.accountCodePresent = 1;
   { static const OSOCTET testdata[] = {
   0x7e, 0xb2, 0xd9, 0x2e, 0x50, 0x54, 0xfa, 0xdf, 
   0x91, 0x54, 0x63, 0x6a, 0x41, 0x13, 0x8b, 0xc9, 
   0x73, 0xf5, 0xa2, 0x22, 0x6c, 0x68, 0xe, 0x91, 
   0xb6, 0xdc, 0xf7, 0xc2, 0xf5, 0xa8, 0x53, 0xcd, 
   0x67, 0x61, 0x4f, 0x99, 0x33, 0x9e, 0x20, 0xd7, 
   0x20, 0x46, 0x2a, 0xcb, 0xc1, 0xc5, 0x6d, 0xea, 
   0xa6, 0xdb, 0xae, 0x1c, 0xb2, 0x58, 0xcd, 0x12, 
   0x1c, 0xf5, 0xc9, 0x88, 0x3d, 0x2d, 0x50, 0x6c, 
   0x37, 0x2f, 0xe5, 0xac, 0x86, 0x60, 0x7f, 0x3b, 
   0x96, 0x7d, 0xa5, 0x1 };
   pvalue->accountCode.numocts = 76;
   pvalue->accountCode.data = testdata;
   }

   pvalue->m.authCodePresent = 1;
   { static const OSOCTET testdata[] = {
   0x68 };
   pvalue->authCode.numocts = 1;
   pvalue->authCode.data = testdata;
   }

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 1;
   { static const OSOCTET testdata[] = {
   0xf5, 0x36, 0x5, 0x67, 0x2b, 0xda, 0xd2, 0xb3, 
   0x69, 0x60, 0x25, 0x3a, 0x5a, 0x0, 0x5a, 0x12, 
   0x62, 0xde, 0x5c, 0xa1, 0x17, 0xa2, 0x42, 0xd3, 
   0x70, 0x79, 0x81, 0x9, 0x47, 0x2e, 0x0, 0x76, 
   0x4, 0x1f, 0x4, 0xe6, 0xb3, 0x28, 0xc5, 0x12, 
   0x4c, 0xd2, 0x2a, 0xfe, 0x55, 0xe6, 0x68, 0x23, 
   0x62, 0xa6, 0x9f, 0x31, 0xe1, 0x52, 0x9b };
   pvalue->userData.u.string.numocts = 55;
   pvalue->userData.u.string.data = testdata;
   }

   pvalue->m.callCharacteristicsPresent = 1;

   pvalue->callCharacteristics.m.lowPriorityCallPresent = 1;
   pvalue->callCharacteristics.lowPriorityCall = 0;

   pvalue->callCharacteristics.m.highPriorityCallPresent = 1;
   pvalue->callCharacteristics.highPriorityCall = 0;

   pvalue->callCharacteristics.m.directAgentPresent = 1;
   pvalue->callCharacteristics.directAgent = 0;

   pvalue->callCharacteristics.m.privateCallPresent = 1;
   pvalue->callCharacteristics.privateCall = 1;

   pvalue->callCharacteristics.m.personalCallPresent = 1;
   pvalue->callCharacteristics.personalCall = 0;

   pvalue->callCharacteristics.m.sensitiveCallPresent = 1;
   pvalue->callCharacteristics.sensitiveCall = 0;

   pvalue->callCharacteristics.m.confidentialCallPresent = 1;
   pvalue->callCharacteristics.confidentialCall = 0;

   pvalue->m.callingConnectionInfoPresent = 1;

   pvalue->m.subjectOfCallPresent = 1;
   pvalue->subjectOfCall.value = OSUTF8("pvalue->subjectOfCall");
   pvalue->subjectOfCall.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;
   pvalue->extensions.security.m.messageSequenceNumberPresent = 1;
   pvalue->extensions.security.messageSequenceNumber
       = OSI64CONST(4850243341381409392);

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 1;
   { static const OSOCTET testdata[] = {
   0x88, 0x2b, 0x42, 0xfd, 0x7c, 0xd, 0x96, 0x6e, 
   0xcb, 0x9, 0x8c, 0x55, 0x39, 0xe0, 0xb, 0x33, 
   0x66, 0x92, 0x12, 0xc8, 0x84, 0xf2, 0x4a, 0x4, 
   0x68, 0xe4, 0x19, 0x3b, 0xa1, 0xb1, 0xf2, 0xdc, 
   0xc9, 0x30, 0xbb, 0xd7, 0xf, 0xa4, 0xdf, 0xd8, 
   0x47, 0x2b, 0xe };
   pvalue->extensions.privateData.u.string.numocts = 43;
   pvalue->extensions.privateData.u.string.data = testdata;
   }

   return (pvalue);
}

MakeCallResponse_ELEM* Test_MakeCallResponse (OSCTXT* pctxt)
{
   MakeCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, MakeCallResponse_ELEM);
   Init_MakeCallResponse_ELEM (pctxt, pvalue);
   pvalue->callingDevice.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->callingDevice.u.deviceID));
   pvalue->callingDevice.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x2d, 0x1d, 0x88, 0x9d, 0x1, 0xa8, 0xd5, 0x59, 
   0xc, 0x5c, 0x17, 0xf6, 0xa7, 0x61, 0xed, 0xf7, 
   0xe7, 0xec, 0x29, 0xef, 0x3b, 0x73, 0x64, 0x51, 
   0xda, 0x67, 0xb9, 0xc7, 0x7e, 0xa7, 0xab, 0x23, 
   0x72, 0x5c, 0xee, 0x3, 0x69, 0xfb, 0xa6, 0xac, 
   0x45, 0x15, 0x55, 0xca, 0xa0, 0x31, 0x6, 0xd, 
   0x53, 0x64, 0xe7, 0xcb, 0xc4, 0xde, 0xfa, 0x34, 
   0x3e, 0xd, 0xe7, 0x2f, 0x93, 0x24, 0x38, 0xe1, 
   0x50, 0xaf, 0x83, 0xa3, 0xcb, 0x61, 0x40, 0xb0, 
   0xc7, 0xd3, 0x52, 0x72, 0xf1, 0x7d, 0x8 };
   pvalue->callingDevice.u.deviceID._base.u.otherPlan.numocts = 79;
   pvalue->callingDevice.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pvalue->callingDevice.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_level3RegionalNumber;
   pvalue->callingDevice.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pvalue->callingDevice.u.deviceID.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->callingDevice.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->callingDevice.u.deviceID.mediaClass._extItems = 0;

   pvalue->callingDevice.u.deviceID.m.mediaClassPresent = 1;
   pvalue->callingDevice.u.deviceID.connectionRate
       = OSI64CONST(3334172850018153000);
   pvalue->callingDevice.u.deviceID.m.connectionRatePresent = 1;
   pvalue->callingDevice.u.deviceID.bitRate = LocalDeviceID_bitRate_variable;
   pvalue->callingDevice.u.deviceID.m.bitRatePresent = 1;
   pvalue->callingDevice.u.deviceID.delayTolerance
       = OSI64CONST(-6879176891649948608);
   pvalue->callingDevice.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->callingDevice.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pvalue->callingDevice.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xb6, 0x7, 0x62, 0x1f, 0x19, 0xfe, 0x6f, 0x9c, 
   0xa1, 0x12, 0x1, 0x7f, 0xc2, 0x26, 0xfe, 0x4, 
   0x2a, 0xaa, 0x5a, 0xdb, 0xfd, 0xcd, 0xfb, 0x30, 
   0xdb, 0x35, 0xaa, 0xbb, 0x8d, 0x3e, 0xdd, 0xb3, 
   0x75, 0xa, 0xa6, 0xca, 0x86, 0x56, 0x32, 0x0, 
   0xec, 0x6c, 0x90, 0x1e, 0x1d, 0x27, 0xb2, 0x87, 
   0x81, 0xd3, 0xdd };
   pvalue->callingDevice.u.deviceID.switchingSubDomainInformationElements
      .numocts = 51;
   pvalue->callingDevice.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->callingDevice.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   pvalue->extensions.security.m.securityInfoPresent = 1;
   pvalue->extensions.security.securityInfo.t = 1;
   { static const OSOCTET testdata[] = {
   0x45, 0x35, 0xaa, 0x54, 0x74, 0xdc, 0xab, 0xb4, 
   0x49, 0xc, 0xdf, 0x5, 0xc, 0x3c, 0x17, 0xcf, 
   0x65, 0x62, 0x7b, 0x53, 0x26, 0x99, 0x4b, 0x5d, 
   0x12, 0xda, 0x90, 0xb2, 0xec, 0x63, 0xb5, 0x63, 
   0x4e, 0x4b, 0x9c, 0x1f, 0x0, 0x73, 0x14, 0xcf, 
   0xf0, 0x4e, 0x60, 0x21, 0x71, 0x26, 0x2a };
   pvalue->extensions.security.securityInfo.u.string.numocts = 47;
   pvalue->extensions.security.securityInfo.u.string.data = testdata;
   }

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 2;
   Init_CSTAPrivateData_private (pctxt, &(pvalue->extensions.privateData.
      u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->extensions.privateData.u.private_._elemList);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   return (pvalue);
}
