/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

MakePredictiveCall_ELEM* Test_MakePredictiveCall (OSCTXT* pctxt);
MakePredictiveCallResponse_ELEM*
    Test_MakePredictiveCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   MakePredictiveCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_MakePredictiveCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_MakePredictiveCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

MakePredictiveCall_ELEM* Test_MakePredictiveCall (OSCTXT* pctxt)
{
   MakePredictiveCall_ELEM* pvalue = rtxMemAllocType (pctxt, MakePredictiveCall_ELEM);
   Init_MakePredictiveCall_ELEM (pctxt, pvalue);
   pvalue->callingDevice._base.t = 2;
   pvalue->callingDevice._base.u.number.value = 
      OSUTF8("pvalue->callingDevice._base.u.number");
   pvalue->callingDevice._base.u.number.cdata = FALSE;
   pvalue->callingDevice.typeOfNumber
       = DeviceID_typeOfNumber_explicitPrivate_level1RegionalNumber;
   pvalue->callingDevice.m.typeOfNumberPresent = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->callingDevice.mediaClass.MediaClassComponents_notKnownBit = 0;
   pvalue->callingDevice.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->callingDevice.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->callingDevice.mediaClass.MediaClassComponents_messageBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->callingDevice.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->callingDevice.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->callingDevice.mediaClass._extItems = 0;

   pvalue->callingDevice.m.mediaClassPresent = 1;
   pvalue->callingDevice.connectionRate = OSI64CONST(4997177763307072200);
   pvalue->callingDevice.m.connectionRatePresent = 1;
   pvalue->callingDevice.bitRate = DeviceID_bitRate_variable;
   pvalue->callingDevice.m.bitRatePresent = 1;
   pvalue->callingDevice.delayTolerance = OSI64CONST(-4750598158696189808);
   pvalue->callingDevice.m.delayTolerancePresent = 1;
   pvalue->callingDevice.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_atm;
   pvalue->callingDevice.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x7f, 0x69, 0x3d, 0x1, 0x52, 0x49, 0xa8, 0x6e, 
   0x1c, 0xc3, 0xf8, 0x6c, 0xd1, 0x2d, 0xd3, 0x65, 
   0xd5, 0xa9, 0x30, 0x90, 0xf9, 0xb5, 0x8b, 0xd8, 
   0xfd, 0xb0, 0x1b, 0xe8, 0xd9, 0x9f, 0xd3, 0x92, 
   0xc4, 0x98, 0xf8, 0x35, 0xcf, 0xb, 0x13, 0xfa, 
   0x8c, 0xde, 0x63, 0xf2, 0x3, 0x14, 0xd2, 0xe6, 
   0x9, 0x5f, 0xed, 0xf9, 0x28, 0x76, 0x4c, 0xed, 
   0xaf, 0x7b, 0xa2, 0x16, 0x1d, 0x42, 0x42, 0x57, 
   0x78, 0x5e, 0x42, 0xbf, 0x51, 0x2b, 0xad };
   pvalue->callingDevice.switchingSubDomainInformationElements.numocts = 71;
   pvalue->callingDevice.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->callingDevice.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->calledDirectoryNumber._base.t = 1;
   { static const OSOCTET testdata[] = {
   0xef, 0xcb, 0x58, 0xdc, 0x7c, 0xd1, 0x3f, 0xca, 
   0x15, 0xf9, 0xa0, 0x8f, 0xa8, 0x37, 0x24, 0xed, 
   0x89, 0x4, 0x3c, 0x9f, 0x89, 0x29, 0x29, 0xe9, 
   0x96, 0xe8, 0xb5, 0x66, 0x28, 0xcf, 0x23, 0x60, 
   0xf8, 0x15, 0x54, 0x56, 0xd4, 0xbf, 0x2e, 0x70, 
   0x81, 0x87, 0x42, 0x89, 0x77, 0xa2, 0xb6, 0x8f, 
   0x9, 0xf9, 0x7f, 0xe5, 0xa1, 0x6d, 0xd9, 0xfa, 
   0xaf, 0x26, 0xa7, 0x51, 0xfb, 0x26 };
   pvalue->calledDirectoryNumber._base.u.otherPlan.numocts = 62;
   pvalue->calledDirectoryNumber._base.u.otherPlan.data = testdata;
   }
   pvalue->calledDirectoryNumber.typeOfNumber = DeviceID_typeOfNumber_other;
   pvalue->calledDirectoryNumber.m.typeOfNumberPresent = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_dataBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_audioBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->calledDirectoryNumber.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->calledDirectoryNumber.mediaClass
      .MediaClassComponents_messageBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->calledDirectoryNumber.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->calledDirectoryNumber.mediaClass._extItems = 0;

   pvalue->calledDirectoryNumber.m.mediaClassPresent = 1;
   pvalue->calledDirectoryNumber.connectionRate
       = OSI64CONST(6818939408331765000);
   pvalue->calledDirectoryNumber.m.connectionRatePresent = 1;
   pvalue->calledDirectoryNumber.bitRate = DeviceID_bitRate_variable;
   pvalue->calledDirectoryNumber.m.bitRatePresent = 1;
   pvalue->calledDirectoryNumber.delayTolerance
       = OSI64CONST(-2993014766926384208);
   pvalue->calledDirectoryNumber.m.delayTolerancePresent = 1;
   pvalue->calledDirectoryNumber.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_isoEthernet;
   pvalue->calledDirectoryNumber.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xbc, 0x4f, 0xb3, 0xab, 0xba, 0x2e, 0x97, 0xdd, 
   0x68, 0xc8, 0x9d, 0xc, 0x46, 0xdc, 0x5, 0x58, 
   0x20, 0xc3, 0xd4, 0xa3, 0xa9, 0x21, 0xaf, 0x2b, 
   0x77, 0x82, 0xb4, 0xf1, 0x1a, 0xb5, 0x59, 0x4c, 
   0x48, 0xb8, 0x57, 0x98, 0xfe, 0xe, 0x1a, 0x9, 
   0x77, 0xc8, 0xd2, 0x7, 0x58, 0xa7 };
   pvalue->calledDirectoryNumber.switchingSubDomainInformationElements
      .numocts = 46;
   pvalue->calledDirectoryNumber.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->calledDirectoryNumber
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.defaultActionPresent = 1;
   pvalue->defaultAction = DetectionAction_remainConnected;

   pvalue->m.autoOriginatePresent = 1;
   pvalue->autoOriginate = AutoOriginate_doNotPrompt;

   pvalue->m.alertTimePresent = 1;
   pvalue->alertTime = OSI64CONST(2790909565886870992);

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 2;
   Init_UserData_private (pctxt, &(pvalue->userData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->userData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.languagePreferencesPresent = 1;
   pvalue->languagePreferences.value = OSUTF8("pvalue->languagePreferences");
   pvalue->languagePreferences.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;

   return (pvalue);
}

MakePredictiveCallResponse_ELEM*
    Test_MakePredictiveCallResponse (OSCTXT* pctxt)
{
   MakePredictiveCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, MakePredictiveCallResponse_ELEM);
   Init_MakePredictiveCallResponse_ELEM (pctxt, pvalue);
   pvalue->initiatedCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->initiatedCall.u.deviceID));
   pvalue->initiatedCall.u.deviceID._base.t = 2;
   pvalue->initiatedCall.u.deviceID._base.u.number.value = 
      OSUTF8("pvalue->initiatedCall.u.deviceID._base.u.number");
   pvalue->initiatedCall.u.deviceID._base.u.number.cdata = FALSE;
   pvalue->initiatedCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPublic_unknown;
   pvalue->initiatedCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->initiatedCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->initiatedCall.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->initiatedCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->initiatedCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->initiatedCall.u.deviceID.connectionRate
       = OSI64CONST(5836280276258031600);
   pvalue->initiatedCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->initiatedCall.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pvalue->initiatedCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->initiatedCall.u.deviceID.delayTolerance
       = OSI64CONST(1946458865164670992);
   pvalue->initiatedCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->initiatedCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_atm;
   pvalue->initiatedCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xd5, 0xae, 0xc, 0x1a, 0xb9, 0x84, 0x49, 0xdd, 
   0x29, 0xd5, 0xf7, 0x66, 0x79, 0x51, 0xc8, 0x93, 
   0x52, 0x62, 0x91, 0xe7, 0xf4, 0x2e, 0xdc, 0x8b, 
   0x37, 0x7e, 0x3a, 0xc7, 0x35, 0xe6, 0xe9, 0x39, 
   0x2f, 0x16, 0xe7, 0x8d, 0xfd };
   pvalue->initiatedCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 37;
   pvalue->initiatedCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->initiatedCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.extensionsPresent = 1;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 2;
   Init_CSTAPrivateData_private (pctxt, &(pvalue->extensions.privateData.
      u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->extensions.privateData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   return (pvalue);
}

