/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

ParkCall_ELEM* Test_ParkCall (OSCTXT* pctxt);
ParkCallResponse_ELEM* Test_ParkCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   ParkCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_ParkCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_ParkCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

ParkCall_ELEM* Test_ParkCall (OSCTXT* pctxt)
{
   ParkCall_ELEM* pvalue = rtxMemAllocType (pctxt, ParkCall_ELEM);
   Init_ParkCall_ELEM (pctxt, pvalue);
   pvalue->parking.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->parking.u.deviceID));
   pvalue->parking.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0xc4, 0x82, 0x82, 0x7b, 0xdf, 0xce, 0x55, 0x4, 
   0xb4, 0x9d, 0x20, 0x27, 0xe1, 0x8c, 0xd8, 0x40, 
   0x44, 0x61, 0xc9, 0xed, 0x65, 0x22, 0x4f, 0x88, 
   0x97, 0x74, 0xc6, 0x42, 0xb1, 0xd6, 0x2, 0xe, 
   0x62, 0xe0, 0x86, 0x35, 0x4, 0xa2, 0x5, 0xbc, 
   0x7a, 0xdc, 0xc1, 0x2, 0x6b, 0x19, 0xde, 0x2e, 
   0x78, 0x63, 0xb7, 0x6a, 0xb0, 0x2c, 0x4d };
   pvalue->parking.u.deviceID._base.u.otherPlan.numocts = 55;
   pvalue->parking.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pvalue->parking.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_unknown;
   pvalue->parking.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_dataBit = 0;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_notKnownBit = 0;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_messageBit = 0;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->parking.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->parking.u.deviceID.mediaClass._extItems = 0;

   pvalue->parking.u.deviceID.m.mediaClassPresent = 1;
   pvalue->parking.u.deviceID.connectionRate
       = OSI64CONST(9192408844494961800);
   pvalue->parking.u.deviceID.m.connectionRatePresent = 1;
   pvalue->parking.u.deviceID.bitRate = LocalDeviceID_bitRate_variable;
   pvalue->parking.u.deviceID.m.bitRatePresent = 1;
   pvalue->parking.u.deviceID.delayTolerance
       = OSI64CONST(3088719179674900192);
   pvalue->parking.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->parking.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_rsvp;
   pvalue->parking.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x3b, 0xbe, 0x27, 0x4, 0xa7, 0x5b, 0xc5, 0x3, 
   0x60, 0xb0, 0x4a, 0xca, 0x60, 0x15, 0x32, 0x95, 
   0x2e, 0x8f, 0x44, 0x45, 0x30, 0xc, 0xb0, 0xa4, 
   0x3b, 0xa4, 0x17, 0xda, 0xc, 0xd6, 0xa1, 0x2b, 
   0x4d, 0x76, 0x93, 0x58, 0xc9, 0xb4, 0xf4, 0xba, 
   0x75, 0x6, 0x36, 0x5c, 0x64, 0xce, 0x76, 0xb1, 
   0xf0, 0x10, 0xd2, 0x4a, 0x86, 0x84, 0xd8, 0xf7, 
   0x6a, 0xe4, 0x10, 0xdd, 0x71, 0xc8, 0x23, 0x58, 
   0x7c, 0xd0, 0x35, 0x3e, 0x29, 0x95, 0x5e, 0xdc, 
   0xd, 0xf, 0x4a, 0x2f, 0x75, 0xe3, 0x1d };
   pvalue->parking.u.deviceID.switchingSubDomainInformationElements
      .numocts = 79;
   pvalue->parking.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->parking.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->parkTo._base.t = 2;
   pvalue->parkTo._base.u.number.value = 
      OSUTF8("pvalue->parkTo._base.u.number");
   pvalue->parkTo._base.u.number.cdata = FALSE;
   pvalue->parkTo.typeOfNumber
       = DeviceID_typeOfNumber_explicitPublic_subscriber;
   pvalue->parkTo.m.typeOfNumberPresent = 1;
   pvalue->parkTo.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->parkTo.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->parkTo.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->parkTo.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->parkTo.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->parkTo.mediaClass.MediaClassComponents_notKnownBit = 0;
   pvalue->parkTo.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->parkTo.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->parkTo.mediaClass.MediaClassComponents_messageBit = 0;
   pvalue->parkTo.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->parkTo.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->parkTo.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->parkTo.mediaClass._extItems = 0;

   pvalue->parkTo.m.mediaClassPresent = 1;
   pvalue->parkTo.connectionRate = OSI64CONST(8575959832967755800);
   pvalue->parkTo.m.connectionRatePresent = 1;
   pvalue->parkTo.bitRate = DeviceID_bitRate_constant;
   pvalue->parkTo.m.bitRatePresent = 1;
   pvalue->parkTo.delayTolerance = OSI64CONST(6483973963711958992);
   pvalue->parkTo.m.delayTolerancePresent = 1;
   pvalue->parkTo.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_rsvp;
   pvalue->parkTo.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xb5, 0x70, 0xaa, 0x7f, 0x6b, 0x55, 0x8, 0x6a, 
   0xa6, 0x14, 0x35, 0xe3, 0x5, 0x37, 0xba, 0x9d };
   pvalue->parkTo.switchingSubDomainInformationElements.numocts = 16;
   pvalue->parkTo.switchingSubDomainInformationElements.data = testdata;
   }
   pvalue->parkTo.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.correlatorDataPresent = 1;
   pvalue->correlatorData.t = 1;
   { static const OSOCTET testdata[] = {
   0x54, 0x83, 0xa6, 0x3, 0x43, 0xbe, 0xa5, 0x0, 
   0x3f, 0xe1, 0xac, 0xf6, 0x92, 0x9b, 0xb8, 0x9c, 
   0xe7, 0x65, 0x3f, 0x24, 0x2b, 0x1b, 0x0, 0x94, 
   0xa4, 0x8c, 0xda, 0xa8, 0x65, 0xf9, 0x69, 0x3f, 
   0x10, 0x17, 0x8, 0x18, 0x9e, 0xfc, 0x92, 0x70, 
   0x2a, 0x2b, 0x6b, 0x38, 0xdb, 0x80, 0xa7, 0xe3, 
   0x2, 0x4b, 0xe9, 0xa1, 0xfe, 0xd4, 0x4a, 0xfd, 
   0x79, 0x96, 0xd8, 0x26, 0x13, 0x68, 0x10, 0xe2, 
   0xf, 0xe2, 0x47, 0x7, 0x1d, 0xc6, 0x8, 0x4f, 
   0xbf, 0x1b, 0x46, 0x81, 0x83 };
   pvalue->correlatorData.u.string.numocts = 77;
   pvalue->correlatorData.u.string.data = testdata;
   }

   pvalue->m.subjectOfCallPresent = 1;
   pvalue->subjectOfCall.value = OSUTF8("pvalue->subjectOfCall");
   pvalue->subjectOfCall.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;
   pvalue->extensions.security.m.messageSequenceNumberPresent = 1;
   pvalue->extensions.security.messageSequenceNumber
       = OSI64CONST(7835095084867478992);

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   return (pvalue);
}

ParkCallResponse_ELEM* Test_ParkCallResponse (OSCTXT* pctxt)
{
   ParkCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, ParkCallResponse_ELEM);
   Init_ParkCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.parkedToPresent = 1;
   pvalue->parkedTo.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->parkedTo.u._seq2));
   pvalue->parkedTo.u._seq2.callID.value = 
      OSUTF8("pvalue->parkedTo.u._seq2.callID");
   pvalue->parkedTo.u._seq2.callID.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   return (pvalue);
}

