/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

ReconnectCall_ELEM* Test_ReconnectCall (OSCTXT* pctxt);
ReconnectCallResponse_ELEM* Test_ReconnectCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   ReconnectCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_ReconnectCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_ReconnectCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

ReconnectCall_ELEM* Test_ReconnectCall (OSCTXT* pctxt)
{
   ReconnectCall_ELEM* pvalue = rtxMemAllocType (pctxt, ReconnectCall_ELEM);
   Init_ReconnectCall_ELEM (pctxt, pvalue);
   pvalue->activeCall.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->activeCall.u._seq2));
   pvalue->activeCall.u._seq2.callID.value = 
      OSUTF8("pvalue->activeCall.u._seq2.callID");
   pvalue->activeCall.u._seq2.callID.cdata = FALSE;

   pvalue->activeCall.u._seq2.m.deviceIDPresent = 1;
   pvalue->activeCall.u._seq2.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0xbc, 0x44, 0x46, 0x7e, 0xb5, 0x54, 0x45, 0x80, 
   0x85, 0x76, 0xf4, 0xda, 0x52, 0x46, 0x8c, 0x74, 
   0x77, 0x35, 0x78, 0x13, 0xd5, 0xde, 0x60 };
   pvalue->activeCall.u._seq2.deviceID._base.u.otherPlan.numocts = 23;
   pvalue->activeCall.u._seq2.deviceID._base.u.otherPlan.data = testdata;
   }
   pvalue->activeCall.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_dynamic;
   pvalue->activeCall.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->activeCall.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->activeCall.u._seq2.deviceID.connectionRate
       = OSI64CONST(3987496208810228400);
   pvalue->activeCall.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_variable;
   pvalue->activeCall.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.delayTolerance
       = OSI64CONST(2332091351827808992);
   pvalue->activeCall.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_rsvp;
   pvalue->activeCall.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x15, 0x99, 0x5a, 0xae, 0xa2, 0xa0, 0x48, 0x15, 
   0xb1, 0x97, 0xa4, 0xbb, 0x1c, 0x12, 0xb, 0x3, 
   0xdc, 0x8d, 0xf8, 0x5d, 0x12, 0x7a, 0x73, 0x71, 
   0x7a, 0x57, 0x12, 0x78, 0x94, 0x61 };
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .numocts = 30;
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->activeCall.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->heldCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->heldCall.u.deviceID));
   pvalue->heldCall.u.deviceID._base.t = 2;
   pvalue->heldCall.u.deviceID._base.u.number.value = 
      OSUTF8("pvalue->heldCall.u.deviceID._base.u.number");
   pvalue->heldCall.u.deviceID._base.u.number.cdata = FALSE;
   pvalue->heldCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_pTNSpecificNumber;
   pvalue->heldCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_dataBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_audioBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_chatBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_messageBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->heldCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->heldCall.u.deviceID.connectionRate
       = OSI64CONST(3363165657409615200);
   pvalue->heldCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->heldCall.u.deviceID.bitRate = LocalDeviceID_bitRate_variable;
   pvalue->heldCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->heldCall.u.deviceID.delayTolerance
       = OSI64CONST(-2856213753409387808);
   pvalue->heldCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->heldCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_atm;
   pvalue->heldCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x6f, 0xd3, 0x1a, 0xc3, 0x8a, 0x8f, 0x46, 0x5, 
   0x3f, 0x29, 0x70, 0xd1, 0x6c, 0xe0, 0x74, 0x6d, 
   0x17, 0x99, 0xae, 0x88, 0xd, 0x68, 0x3, 0x46, 
   0x44, 0xa9, 0x78, 0xef };
   pvalue->heldCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 28;
   pvalue->heldCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->heldCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.extensionsPresent = 1;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 2;
   Init_CSTAPrivateData_private (pctxt, &(pvalue->extensions.privateData.
      u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->extensions.privateData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   return (pvalue);
}

ReconnectCallResponse_ELEM* Test_ReconnectCallResponse (OSCTXT* pctxt)
{
   ReconnectCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, ReconnectCallResponse_ELEM);
   Init_ReconnectCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.extensionsPresent = 1;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 1;
   { static const OSOCTET testdata[] = {
   0x53, 0x4a, 0x4e, 0xf3, 0x56, 0xb9, 0xb2, 0xd6, 
   0x12 };
   pvalue->extensions.privateData.u.string.numocts = 9;
   pvalue->extensions.privateData.u.string.data = testdata;
   }

   return (pvalue);
}

