/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

RetrieveCall_ELEM* Test_RetrieveCall (OSCTXT* pctxt);
RetrieveCallResponse_ELEM* Test_RetrieveCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   RetrieveCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_RetrieveCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_RetrieveCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

RetrieveCall_ELEM* Test_RetrieveCall (OSCTXT* pctxt)
{
   RetrieveCall_ELEM* pvalue = rtxMemAllocType (pctxt, RetrieveCall_ELEM);
   Init_RetrieveCall_ELEM (pctxt, pvalue);
   pvalue->callToBeRetrieved.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->callToBeRetrieved.u._seq2));
   pvalue->callToBeRetrieved.u._seq2.callID.value = 
      OSUTF8("pvalue->callToBeRetrieved.u._seq2.callID");
   pvalue->callToBeRetrieved.u._seq2.callID.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 1;
   { static const OSOCTET testdata[] = {
   0xa2, 0x45, 0xef, 0x21, 0x80, 0x25, 0x58, 0x6f, 
   0x22, 0xc3, 0x8b, 0x5d, 0x23, 0x30, 0x6e, 0x3f, 
   0x47, 0xb9, 0x1a, 0x84, 0xc4, 0x4b, 0x46, 0xcd, 
   0x39, 0xf8, 0x45, 0x3a, 0x24, 0x4a, 0xa8, 0xe1, 
   0xaf, 0xba, 0x55, 0xd3, 0x30, 0x5, 0xa9, 0xf7, 
   0x93, 0xa8, 0x89, 0xcf, 0xb3, 0xc7 };
   pvalue->extensions.privateData.u.string.numocts = 46;
   pvalue->extensions.privateData.u.string.data = testdata;
   }

   return (pvalue);
}

RetrieveCallResponse_ELEM* Test_RetrieveCallResponse (OSCTXT* pctxt)
{
   RetrieveCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, RetrieveCallResponse_ELEM);
   Init_RetrieveCallResponse_ELEM (pctxt, pvalue);
   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;

   return (pvalue);
}

