/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

SingleStepConferenceCall_ELEM* Test_SingleStepConferenceCall (OSCTXT* pctxt);
SingleStepConferenceCallResponse_ELEM*
    Test_SingleStepConferenceCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   SingleStepConferenceCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_SingleStepConferenceCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_SingleStepConferenceCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

SingleStepConferenceCall_ELEM* Test_SingleStepConferenceCall (OSCTXT* pctxt)
{
   SingleStepConferenceCall_ELEM* pvalue = rtxMemAllocType (pctxt, SingleStepConferenceCall_ELEM);
   Init_SingleStepConferenceCall_ELEM (pctxt, pvalue);
   pvalue->activeCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->activeCall.u.deviceID));
   pvalue->activeCall.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x79, 0xa, 0x89, 0x5d, 0xf3, 0x97, 0xd9, 0x20, 
   0xaf, 0x7c, 0x7b, 0x0, 0x24, 0xb6, 0x88, 0x31, 
   0x71, 0xf4, 0xf2, 0x98, 0xf4, 0x3c, 0xae, 0x9b, 
   0xf0, 0x29, 0xf1, 0xba, 0xd0, 0x2, 0x91, 0xba, 
   0x2d, 0x73, 0x5b, 0xee, 0xf, 0x9d, 0xfe, 0x58, 
   0x1a };
   pvalue->activeCall.u.deviceID._base.u.otherPlan.numocts = 41;
   pvalue->activeCall.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pvalue->activeCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPublic_abbreviated;
   pvalue->activeCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_dataBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_imageBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_otherBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_smsBit = 1;
   pvalue->activeCall.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->activeCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->activeCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->activeCall.u.deviceID.connectionRate
       = OSI64CONST(6512966771103421200);
   pvalue->activeCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->activeCall.u.deviceID.bitRate = LocalDeviceID_bitRate_variable;
   pvalue->activeCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->activeCall.u.deviceID.delayTolerance
       = OSI64CONST(1397002942561426192);
   pvalue->activeCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->activeCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_rsvp;
   pvalue->activeCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x27, 0xd4, 0x98, 0x5e, 0xb7, 0x58, 0x26, 0x39, 
   0xa4, 0x70, 0xb5, 0x40, 0x52, 0xf8, 0x3e, 0x8f, 
   0x97, 0x39, 0x64, 0xa5, 0x4, 0x89, 0x43, 0x7e, 
   0x76, 0x26, 0x4a, 0x1a, 0xc1, 0x62, 0x75, 0x62, 
   0xd0, 0x2e, 0xf, 0x70, 0xb1, 0x9c, 0xe0, 0x87, 
   0xeb, 0xee, 0x7c, 0xdc, 0x72, 0xbc, 0xe9, 0x87, 
   0xbb, 0x56, 0x7b, 0x13, 0x32, 0xe3, 0x22, 0xb1, 
   0x9b, 0xe3, 0xd2, 0x77, 0x18, 0x19, 0x81, 0xb, 
   0x63, 0xf3, 0xbb, 0x63, 0x7c, 0x1f, 0xd6, 0x4f, 
   0x48, 0xa2, 0xc9, 0x78, 0xf0, 0x5c, 0x9c, 0x16 };
   pvalue->activeCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 80;
   pvalue->activeCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->activeCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->deviceToJoin._base.t = 2;
   pvalue->deviceToJoin._base.u.number.value = 
      OSUTF8("pvalue->deviceToJoin._base.u.number");
   pvalue->deviceToJoin._base.u.number.cdata = FALSE;
   pvalue->deviceToJoin.typeOfNumber
       = DeviceID_typeOfNumber_explicitPublic_national;
   pvalue->deviceToJoin.m.typeOfNumberPresent = 1;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_audioBit = 0;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_notKnownBit = 1;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_emailBit = 0;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_messageBit = 0;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_imBit = 1;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->deviceToJoin.mediaClass.MediaClassComponents_mmsBit = 1;
   pvalue->deviceToJoin.mediaClass._extItems = 0;

   pvalue->deviceToJoin.m.mediaClassPresent = 1;
   pvalue->deviceToJoin.connectionRate = OSI64CONST(6502270395560940000);
   pvalue->deviceToJoin.m.connectionRatePresent = 1;
   pvalue->deviceToJoin.bitRate = DeviceID_bitRate_constant;
   pvalue->deviceToJoin.m.bitRatePresent = 1;
   pvalue->deviceToJoin.delayTolerance = OSI64CONST(6815561605528876192);
   pvalue->deviceToJoin.m.delayTolerancePresent = 1;
   pvalue->deviceToJoin.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_isoEthernet;
   pvalue->deviceToJoin.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x2c, 0xb2, 0x40, 0x86, 0x2d, 0xc0, 0x4f, 0x69, 
   0x24, 0x18, 0x5b, 0xcf, 0xc, 0x42, 0x86, 0x54, 
   0xe3, 0xa3, 0x50, 0x36, 0xec, 0xc0, 0x8b, 0x11, 
   0xce, 0x68, 0x3d, 0x57, 0x2, 0x86, 0xe1, 0x7c, 
   0x9e, 0xc1, 0xf6, 0x80, 0xfc, 0x2c, 0x2b, 0xe3, 
   0x48, 0x25, 0x92, 0x96, 0xdd, 0x37, 0x58, 0x77, 
   0x33, 0x9, 0xb6, 0x88, 0xc, 0x3f, 0xac, 0xc3, 
   0xba, 0xd0, 0x4c, 0xdb, 0xc3, 0xae, 0x8b, 0xc2, 
   0x6, 0x53, 0xf2, 0x3f, 0x55, 0x8, 0x1b, 0xf7 };
   pvalue->deviceToJoin.switchingSubDomainInformationElements.numocts = 72;
   pvalue->deviceToJoin.switchingSubDomainInformationElements.data = testdata;
   }
   pvalue->deviceToJoin.m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->participationType = ParticipationType_active;

   pvalue->m.correlatorDataPresent = 1;
   pvalue->correlatorData.t = 2;
   Init_CorrelatorData_private (pctxt, &(pvalue->correlatorData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->correlatorData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.userDataPresent = 1;
   pvalue->userData.t = 2;
   Init_UserData_private (pctxt, &(pvalue->userData.u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->userData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.subjectOfCallPresent = 1;
   pvalue->subjectOfCall.value = OSUTF8("pvalue->subjectOfCall");
   pvalue->subjectOfCall.cdata = FALSE;

   pvalue->m.languagePreferencesPresent = 1;
   pvalue->languagePreferences.value = OSUTF8("pvalue->languagePreferences");
   pvalue->languagePreferences.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;

   return (pvalue);
}

SingleStepConferenceCallResponse_ELEM*
    Test_SingleStepConferenceCallResponse (OSCTXT* pctxt)
{
   SingleStepConferenceCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, SingleStepConferenceCallResponse_ELEM);
   Init_SingleStepConferenceCallResponse_ELEM (pctxt, pvalue);
   pvalue->conferencedCall.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->conferencedCall.u._seq2));
   pvalue->conferencedCall.u._seq2.callID.value = 
      OSUTF8("pvalue->conferencedCall.u._seq2.callID");
   pvalue->conferencedCall.u._seq2.callID.cdata = FALSE;

   pvalue->m.conferencedCallInfoPresent = 1;

   pvalue->conferencedCallInfo.m.numberOfChannelsPresent = 1;
   pvalue->conferencedCallInfo.numberOfChannels
       = OSI64CONST(-1185890267380876208);

   pvalue->conferencedCallInfo.m.mediaSessionInfoPresent = 1;
   pvalue->conferencedCallInfo.mediaSessionInfo.value = 
      OSUTF8("pvalue->conferencedCallInfo.mediaSessionInfo");
   pvalue->conferencedCallInfo.mediaSessionInfo.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 1;
   { static const OSOCTET testdata[] = {
   0x38, 0xed, 0x6f, 0xce, 0x65, 0x2b, 0x8a, 0xa4, 
   0xb, 0x59, 0xd5, 0xa2, 0x4c, 0x64, 0x52, 0xb9, 
   0xa6, 0x13, 0xa8, 0xc3, 0xe5, 0x42, 0xbd, 0xbe, 
   0x37, 0xb8, 0x25, 0x9b, 0x88 };
   pvalue->extensions.privateData.u.string.numocts = 29;
   pvalue->extensions.privateData.u.string.data = testdata;
   }

   return (pvalue);
}

