/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

SnapshotCall_ELEM* Test_SnapshotCall (OSCTXT* pctxt);
SnapshotCallResponse_ELEM* Test_SnapshotCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   SnapshotCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_SnapshotCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_SnapshotCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

SnapshotCall_ELEM* Test_SnapshotCall (OSCTXT* pctxt)
{
   SnapshotCall_ELEM* pvalue = rtxMemAllocType (pctxt, SnapshotCall_ELEM);
   Init_SnapshotCall_ELEM (pctxt, pvalue);
   pvalue->snapshotObject.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->snapshotObject.u._seq2));
   pvalue->snapshotObject.u._seq2.callID.value = 
      OSUTF8("pvalue->snapshotObject.u._seq2.callID");
   pvalue->snapshotObject.u._seq2.callID.cdata = FALSE;

   pvalue->m.extensionsPresent = 1;
   pvalue->extensions.m.securityPresent = 1;
   pvalue->extensions.security.m.messageSequenceNumberPresent = 1;
   pvalue->extensions.security.messageSequenceNumber
       = OSI64CONST(9091637727542112592);

   pvalue->extensions.security.m.timeStampPresent = 1;
   pvalue->extensions.security.timeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->extensions.security.timeStamp.cdata = FALSE;

   pvalue->extensions.m.privateDataPresent = 1;
   pvalue->extensions.privateData.t = 2;
   Init_CSTAPrivateData_private (pctxt, &(pvalue->extensions.privateData.
      u.private_));
   { OSXMLSTRING* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->extensions.privateData.u.private_);
   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocTypeZ (pctxt, OSXMLSTRING);
   pdata0
      ->value = OSUTF8("<anyTest>any <b z=\"1\">test</b> element</anyTest>");
   rtxDListAppend (pctxt, plist, pdata0);
   }

   return (pvalue);
}

SnapshotCallResponse_ELEM* Test_SnapshotCallResponse (OSCTXT* pctxt)
{
   SnapshotCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, SnapshotCallResponse_ELEM);
   Init_SnapshotCallResponse_ELEM (pctxt, pvalue);
   pvalue->crossRefIDorSnapshotData.t = 2;
   Init_SnapshotCallData (pctxt, &(pvalue->crossRefIDorSnapshotData.
      u.snapshotData));
   { SnapshotCallResponseInfo* pdata0;
   OSRTDList* plist = &(pvalue->crossRefIDorSnapshotData.u.snapshotData);
   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 3;
   Init_Empty (pctxt, &(pdata0->deviceOnCall._base.u.restricted));

   pdata0->m.localConnectionInfoPresent = 1;
   pdata0->localConnectionInfo = LocalConnectionState_initiated;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 2;
   Init_Empty (pctxt, &(pdata0->deviceOnCall._base.u.notKnown));

   pdata0->m.callIdentifierPresent = 1;
   pdata0->callIdentifier.t = 1;
   Init_LocalDeviceID (pctxt, &(pdata0->callIdentifier.u.deviceID));
   pdata0->callIdentifier.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0xfc, 0x7a, 0x70, 0xb4, 0x71, 0x5f, 0x9e, 0x31, 
   0x87, 0x17, 0xbf, 0x5b, 0x3c, 0xdd, 0xbc, 0x4a, 
   0xfb, 0x15, 0xd6, 0x71, 0x29, 0xad, 0x93, 0x4d, 
   0xce, 0xb9, 0x84, 0x35, 0x13, 0x89, 0x1a, 0xe1, 
   0x61, 0xd1, 0x12, 0x3b, 0xdc, 0x5b, 0xc0, 0xd, 
   0xf, 0x8a, 0xb7, 0x1f, 0xe9, 0x64, 0x10, 0xe5, 
   0x8b, 0x5a, 0x5d, 0x3e, 0xdf, 0xeb, 0x8c, 0x5f, 
   0xc, 0xfe, 0xa9, 0xb, 0x3d, 0xfe, 0x6c, 0x19, 
   0xc8, 0x86, 0xe2, 0x68, 0xbb, 0xc8, 0x29 };
   pdata0->callIdentifier.u.deviceID._base.u.otherPlan.numocts = 71;
   pdata0->callIdentifier.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pdata0->callIdentifier.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_dialingNumber;
   pdata0->callIdentifier.u.deviceID.m.typeOfNumberPresent = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass._extItems = 0;

   pdata0->callIdentifier.u.deviceID.m.mediaClassPresent = 1;
   pdata0->callIdentifier.u.deviceID.connectionRate
       = OSI64CONST(5579848746805390200);
   pdata0->callIdentifier.u.deviceID.m.connectionRatePresent = 1;
   pdata0->callIdentifier.u.deviceID.bitRate = LocalDeviceID_bitRate_variable;
   pdata0->callIdentifier.u.deviceID.m.bitRatePresent = 1;
   pdata0->callIdentifier.u.deviceID.delayTolerance
       = OSI64CONST(1064852333610694192);
   pdata0->callIdentifier.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->callIdentifier.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_rsvp;
   pdata0->callIdentifier.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x42, 0x54, 0x60, 0x47, 0xb9, 0x3e, 0x67, 0xc2, 
   0x8d, 0x21, 0x20, 0x80, 0x75, 0xd, 0x73, 0xbe, 
   0x80, 0x22, 0xcb, 0xa0, 0x7e, 0x33, 0x46, 0x57, 
   0x66, 0xc6, 0x30, 0x9, 0xe8, 0xcc, 0x85, 0x20, 
   0xe2, 0x7f, 0xdd, 0x59, 0xe4, 0xb0, 0x7d, 0x51, 
   0x80, 0x1e, 0x8b, 0xcd, 0x92, 0x74, 0x85, 0x92, 
   0x44, 0xf, 0x5 };
   pdata0->callIdentifier.u.deviceID.switchingSubDomainInformationElements
      .numocts = 51;
   pdata0->callIdentifier.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->callIdentifier.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.mediaServiceInfoListPresent = 1;
   { CallMediaInfoList_callMediaInfo* pdata1;
   OSRTDList* plist = &(pdata0->mediaServiceInfoList);
   pdata1 = rtxMemAllocType (pctxt, CallMediaInfoList_callMediaInfo);
   Init_CallMediaInfoList_callMediaInfo (pctxt, pdata1);
   pdata1->mediaServiceType = MediaServiceType_cstaIVRScript8;

   pdata1->m.mediaServiceVersionPresent = 1;
   pdata1->mediaServiceVersion = OSI64CONST(-5231935058107843808);

   pdata1->m.mediaStreamIDPresent = 1;
   pdata1->mediaStreamID.value = OSUTF8("pdata1->mediaStreamID");
   pdata1->mediaStreamID.cdata = FALSE;

   rtxDListAppend (pctxt, plist, pdata1);

   pdata1 = rtxMemAllocType (pctxt, CallMediaInfoList_callMediaInfo);
   Init_CallMediaInfoList_callMediaInfo (pctxt, pdata1);
   pdata1->mediaServiceType = MediaServiceType_usb;

   pdata1->m.mediaStreamIDPresent = 1;
   pdata1->mediaStreamID.value = OSUTF8("pdata1->mediaStreamID");
   pdata1->mediaStreamID.cdata = FALSE;

   pdata1->m.connectionInformationPresent = 1;
   pdata1->connectionInformation.m.flowDirectionPresent = 1;
   pdata1->connectionInformation.flowDirection
       = ConnectionInformation_flowDirect_transmitAndReceive;

   pdata1->connectionInformation.m.mediaSessionInfoPresent = 1;
   pdata1->connectionInformation.mediaSessionInfo.value = 
      OSUTF8("pdata1->connectionInformation.mediaSessionInfo");
   pdata1->connectionInformation.mediaSessionInfo.cdata = FALSE;

   rtxDListAppend (pctxt, plist, pdata1);

   pdata1 = rtxMemAllocType (pctxt, CallMediaInfoList_callMediaInfo);
   Init_CallMediaInfoList_callMediaInfo (pctxt, pdata1);
   pdata1->mediaServiceType = MediaServiceType_soundCaptureTransmitApi;

   pdata1->m.mediaServiceVersionPresent = 1;
   pdata1->mediaServiceVersion = OSI64CONST(-1095815525970508208);

   pdata1->m.mediaServiceInstancePresent = 1;
   pdata1->mediaServiceInstance.value = 
      OSUTF8("pdata1->mediaServiceInstance");
   pdata1->mediaServiceInstance.cdata = FALSE;

   rtxDListAppend (pctxt, plist, pdata1);
   }

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 1;
   Init_DeviceID (pctxt, &(pdata0->deviceOnCall._base.u.deviceIdentifier));
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.t = 2;
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number.value = 
      OSUTF8("pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number");
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number.cdata = FALSE;
   pdata0->deviceOnCall._base.u.deviceIdentifier.typeOfNumber
       = DeviceID_typeOfNumber_explicitPrivate_pTNSpecificNumber;
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.typeOfNumberPresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_dataBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_imageBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_otherBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_chatBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_messageBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_imBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass._extItems = 0;

   pdata0->deviceOnCall._base.u.deviceIdentifier.m.mediaClassPresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.connectionRate
       = OSI64CONST(2280298375516847400);
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.connectionRatePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.bitRate
       = DeviceID_bitRate_constant;
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.bitRatePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.delayTolerance
       = OSI64CONST(-6261038978721298208);
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.delayTolerancePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_sip;
   pdata0->deviceOnCall._base.u.deviceIdentifier
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x30, 0x50, 0xf8, 0x31, 0xc3, 0x34, 0x23, 0xae, 
   0xf0, 0xf6, 0xc6 };
   pdata0->deviceOnCall._base.u.deviceIdentifier.
      switchingSubDomainInformationElements.numocts = 11;
   pdata0->deviceOnCall._base.u.deviceIdentifier.
      switchingSubDomainInformationElements.data = testdata;
   }
   pdata0->deviceOnCall._base.u.deviceIdentifier
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.callIdentifierPresent = 1;
   pdata0->callIdentifier.t = 2;
   Init_ConnectionID_2 (pctxt, &(pdata0->callIdentifier.u._seq2));
   pdata0->callIdentifier.u._seq2.callID.value = 
      OSUTF8("pdata0->callIdentifier.u._seq2.callID");
   pdata0->callIdentifier.u._seq2.callID.cdata = FALSE;

   pdata0->m.localConnectionInfoPresent = 1;
   pdata0->localConnectionInfo = LocalConnectionState_alerting;

   pdata0->m.servicesPermittedPresent = 1;
   pdata0->servicesPermitted.callControlServices.m.acceptCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.acceptCall = 1;

   pdata0->servicesPermitted.callControlServices.m.alternateCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.alternateCall = 0;

   pdata0->servicesPermitted.callControlServices.m.answerCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.answerCall = 1;

   pdata0->servicesPermitted.callControlServices.m.callBackMessagePresent = 1;
   pdata0->servicesPermitted.callControlServices.callBackMessage = 1;

   pdata0->servicesPermitted.callControlServices.m.campOnCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.campOnCall = 1;

   pdata0->servicesPermitted.callControlServices.m.clearConnectionPresent = 1;
   pdata0->servicesPermitted.callControlServices.clearConnection = 0;

   pdata0->servicesPermitted.callControlServices
      .m.consultationCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.consultationCall = 0;

   pdata0->servicesPermitted.callControlServices.m.deflectCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.deflectCall = 1;

   pdata0->servicesPermitted.callControlServices
      .m.directedPickupCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.directedPickupCall = 0;

   pdata0->servicesPermitted.callControlServices.m.groupPickupCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.groupPickupCall = 1;

   pdata0->servicesPermitted.callControlServices.m.holdCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.holdCall = 0;

   pdata0->servicesPermitted.callControlServices.m.intrudeCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.intrudeCall = 1;

   pdata0->servicesPermitted.callControlServices.m.makeCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.makeCall = 1;

   pdata0->servicesPermitted.callControlServices.m.sendMessagePresent = 1;
   pdata0->servicesPermitted.callControlServices.sendMessage = 0;

   pdata0->servicesPermitted.callControlServices
      .m.singleStepTransferPresent = 1;
   pdata0->servicesPermitted.callControlServices.singleStepTransfer = 1;

   pdata0->servicesPermitted.callControlServices.m.transferCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.transferCall = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.cancelTelephonyTonesPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.cancelTelephonyTones = 0;

   pdata0->servicesPermitted.callAssociatedServices
      .m.generateTelephonyTonesPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.generateTelephonyTones
       = 0;

   pdata0->servicesPermitted.callAssociatedServices
      .m.sendUserInformationPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.sendUserInformation = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.changeConnectionInformationPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.changeConnectionInformation
       = 0;

   pdata0->servicesPermitted.mediaAttachementServices
      .m.attachMediaServicePresent = 1;
   pdata0->servicesPermitted.mediaAttachementServices.attachMediaService = 1;

   pdata0->servicesPermitted.mediaAttachementServices
      .m.detachMediaServicePresent = 1;
   pdata0->servicesPermitted.mediaAttachementServices.detachMediaService = 0;

   pdata0->servicesPermitted.routeingServices
      .m.routeRegisterCancelPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRegisterCancel = 1;

   pdata0->servicesPermitted.routeingServices.m.routeRegisterAbortPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRegisterAbort = 1;

   pdata0->servicesPermitted.routeingServices.m.reRoutePresent = 1;
   pdata0->servicesPermitted.routeingServices.reRoute = 1;

   pdata0->servicesPermitted.routeingServices.m.routeEndPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeEnd = 1;

   pdata0->servicesPermitted.routeingServices.m.routeRejectPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeReject = 0;

   pdata0->servicesPermitted.routeingServices.m.routeRequestPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRequest = 0;

   pdata0->servicesPermitted.voiceServices.m.clearPresent = 1;
   pdata0->servicesPermitted.voiceServices.clear = 0;

   pdata0->servicesPermitted.voiceServices.m.recordMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.recordMessage = 0;

   pdata0->servicesPermitted.voiceServices.m.repositionPresent = 1;
   pdata0->servicesPermitted.voiceServices.reposition = 0;

   pdata0->servicesPermitted.voiceServices.m.reviewPresent = 1;
   pdata0->servicesPermitted.voiceServices.review = 0;

   pdata0->servicesPermitted.voiceServices.m.stopPresent = 1;
   pdata0->servicesPermitted.voiceServices.stop = 1;

   pdata0->m.mediaServiceInfoListPresent = 1;
   { CallMediaInfoList_callMediaInfo* pdata1;
   OSRTDList* plist = &(pdata0->mediaServiceInfoList);
   pdata1 = rtxMemAllocType (pctxt, CallMediaInfoList_callMediaInfo);
   Init_CallMediaInfoList_callMediaInfo (pctxt, pdata1);
   pdata1->mediaServiceType = MediaServiceType_dataModem;

   rtxDListAppend (pctxt, plist, pdata1);

   pdata1 = rtxMemAllocType (pctxt, CallMediaInfoList_callMediaInfo);
   Init_CallMediaInfoList_callMediaInfo (pctxt, pdata1);
   pdata1->mediaServiceType = MediaServiceType_cstaIVRScript4;

   pdata1->m.mediaServiceVersionPresent = 1;
   pdata1->mediaServiceVersion = OSI64CONST(-4891339942149889808);

   pdata1->m.mediaServiceInstancePresent = 1;
   pdata1->mediaServiceInstance.value = 
      OSUTF8("pdata1->mediaServiceInstance");
   pdata1->mediaServiceInstance.cdata = FALSE;

   pdata1->m.mediaStreamIDPresent = 1;
   pdata1->mediaStreamID.value = OSUTF8("pdata1->mediaStreamID");
   pdata1->mediaStreamID.cdata = FALSE;

   pdata1->m.connectionInformationPresent = 1;

   pdata1->connectionInformation.m.mediaSessionInfoPresent = 1;
   pdata1->connectionInformation.mediaSessionInfo.value = 
      OSUTF8("pdata1->connectionInformation.mediaSessionInfo");
   pdata1->connectionInformation.mediaSessionInfo.cdata = FALSE;

   rtxDListAppend (pctxt, plist, pdata1);
   }

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 3;
   Init_Empty (pctxt, &(pdata0->deviceOnCall._base.u.restricted));

   pdata0->m.callIdentifierPresent = 1;
   pdata0->callIdentifier.t = 1;
   Init_LocalDeviceID (pctxt, &(pdata0->callIdentifier.u.deviceID));
   pdata0->callIdentifier.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x77, 0xc9, 0x1b, 0x6, 0xa6, 0xd3, 0x58, 0x4d, 
   0x98, 0xd2, 0x51, 0x17, 0x5d, 0x75, 0xa1, 0x57, 
   0xf5, 0xd2 };
   pdata0->callIdentifier.u.deviceID._base.u.otherPlan.numocts = 18;
   pdata0->callIdentifier.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pdata0->callIdentifier.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_deviceNumber;
   pdata0->callIdentifier.u.deviceID.m.typeOfNumberPresent = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_imBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass._extItems = 0;

   pdata0->callIdentifier.u.deviceID.m.mediaClassPresent = 1;
   pdata0->callIdentifier.u.deviceID.connectionRate
       = OSI64CONST(4668686440726136400);
   pdata0->callIdentifier.u.deviceID.m.connectionRatePresent = 1;
   pdata0->callIdentifier.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pdata0->callIdentifier.u.deviceID.m.bitRatePresent = 1;
   pdata0->callIdentifier.u.deviceID.delayTolerance
       = OSI64CONST(-2164890113084813408);
   pdata0->callIdentifier.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->callIdentifier.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pdata0->callIdentifier.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x74, 0xf2, 0xcf, 0x15, 0xbf, 0x61, 0x2a, 0xc6, 
   0xc2, 0x3, 0x6d, 0x82, 0x13, 0xde, 0x7c, 0xef, 
   0xf2, 0x36, 0x21, 0x45, 0xe0, 0x0, 0x73, 0x88, 
   0x18, 0xe1, 0x34, 0x9b, 0x3a, 0xcc, 0xcd, 0x4d, 
   0x7b, 0x7, 0x2, 0xd4, 0x7a, 0xba, 0x93, 0xf4, 
   0x9d, 0xdc, 0x5a, 0xba, 0x2d, 0x7e, 0x1f, 0x8c, 
   0xfa, 0xe4, 0x2e, 0xf6, 0xc3, 0x6d, 0xf3, 0x73, 
   0x31, 0x1d, 0x17, 0x96, 0x19, 0x71 };
   pdata0->callIdentifier.u.deviceID.switchingSubDomainInformationElements
      .numocts = 62;
   pdata0->callIdentifier.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->callIdentifier.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.localConnectionInfoPresent = 1;
   pdata0->localConnectionInfo = LocalConnectionState_fail;

   pdata0->m.mediaServiceInfoListPresent = 1;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 2;
   Init_Empty (pctxt, &(pdata0->deviceOnCall._base.u.notKnown));

   pdata0->m.callIdentifierPresent = 1;
   pdata0->callIdentifier.t = 2;
   Init_ConnectionID_2 (pctxt, &(pdata0->callIdentifier.u._seq2));
   pdata0->callIdentifier.u._seq2.callID.value = 
      OSUTF8("pdata0->callIdentifier.u._seq2.callID");
   pdata0->callIdentifier.u._seq2.callID.cdata = FALSE;

   pdata0->m.localConnectionInfoPresent = 1;
   pdata0->localConnectionInfo = LocalConnectionState_null;

   pdata0->m.servicesPermittedPresent = 1;

   pdata0->servicesPermitted.callControlServices.m.alternateCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.alternateCall = 0;

   pdata0->servicesPermitted.callControlServices.m.answerCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.answerCall = 1;

   pdata0->servicesPermitted.callControlServices.m.callBackPresent = 1;
   pdata0->servicesPermitted.callControlServices.callBack = 1;

   pdata0->servicesPermitted.callControlServices.m.callBackMessagePresent = 1;
   pdata0->servicesPermitted.callControlServices.callBackMessage = 0;

   pdata0->servicesPermitted.callControlServices.m.conferenceCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.conferenceCall = 0;

   pdata0->servicesPermitted.callControlServices.m.deflectCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.deflectCall = 1;

   pdata0->servicesPermitted.callControlServices.m.dialDigitsPresent = 1;
   pdata0->servicesPermitted.callControlServices.dialDigits = 1;

   pdata0->servicesPermitted.callControlServices
      .m.directedPickupCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.directedPickupCall = 0;

   pdata0->servicesPermitted.callControlServices.m.holdCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.holdCall = 0;

   pdata0->servicesPermitted.callControlServices.m.intrudeCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.intrudeCall = 1;

   pdata0->servicesPermitted.callControlServices
      .m.makePredictiveCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.makePredictiveCall = 1;

   pdata0->servicesPermitted.callControlServices.m.reconnectCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.reconnectCall = 1;

   pdata0->servicesPermitted.callControlServices.m.sendMessagePresent = 1;
   pdata0->servicesPermitted.callControlServices.sendMessage = 1;

   pdata0->servicesPermitted.callControlServices
      .m.singleStepConferencePresent = 1;
   pdata0->servicesPermitted.callControlServices.singleStepConference = 0;

   pdata0->servicesPermitted.callControlServices
      .m.singleStepTransferPresent = 1;
   pdata0->servicesPermitted.callControlServices.singleStepTransfer = 1;

   pdata0->servicesPermitted.callControlServices.m.transferCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.transferCall = 0;

   pdata0->servicesPermitted.callAssociatedServices
      .m.associateDataPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.associateData = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.cancelTelephonyTonesPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.cancelTelephonyTones = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.generateTelephonyTonesPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.generateTelephonyTones
       = 0;

   pdata0->servicesPermitted.callAssociatedServices
      .m.changeConnectionInformationPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.changeConnectionInformation
       = 1;

   pdata0->servicesPermitted.routeingServices.m.reRoutePresent = 1;
   pdata0->servicesPermitted.routeingServices.reRoute = 1;

   pdata0->servicesPermitted.routeingServices.m.routeUsedPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeUsed = 0;

   pdata0->servicesPermitted.voiceServices.m.activatePresent = 1;
   pdata0->servicesPermitted.voiceServices.activate = 1;

   pdata0->servicesPermitted.voiceServices.m.deactivatePresent = 1;
   pdata0->servicesPermitted.voiceServices.deactivate = 1;

   pdata0->servicesPermitted.voiceServices.m.concatenateMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.concatenateMessage = 1;

   pdata0->servicesPermitted.voiceServices.m.deleteMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.deleteMessage = 0;

   pdata0->servicesPermitted.voiceServices.m.queryVoiceAttributePresent = 1;
   pdata0->servicesPermitted.voiceServices.queryVoiceAttribute = 1;

   pdata0->servicesPermitted.voiceServices.m.recordMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.recordMessage = 1;

   pdata0->servicesPermitted.voiceServices.m.repositionPresent = 1;
   pdata0->servicesPermitted.voiceServices.reposition = 0;

   pdata0->servicesPermitted.voiceServices.m.reviewPresent = 1;
   pdata0->servicesPermitted.voiceServices.review = 1;

   pdata0->servicesPermitted.voiceServices.m.setVoiceAttributePresent = 1;
   pdata0->servicesPermitted.voiceServices.setVoiceAttribute = 1;

   pdata0->servicesPermitted.voiceServices.m.stopPresent = 1;
   pdata0->servicesPermitted.voiceServices.stop = 0;

   pdata0->servicesPermitted.voiceServices.m.suspendPresent = 1;
   pdata0->servicesPermitted.voiceServices.suspend = 1;

   pdata0->servicesPermitted.voiceServices.m.synthesizeMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.synthesizeMessage = 0;

   pdata0->m.mediaServiceInfoListPresent = 1;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 1;
   Init_DeviceID (pctxt, &(pdata0->deviceOnCall._base.u.deviceIdentifier));
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.t = 2;
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number.value = 
      OSUTF8("pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number");
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number.cdata = FALSE;
   pdata0->deviceOnCall._base.u.deviceIdentifier.typeOfNumber
       = DeviceID_typeOfNumber_deviceNumber;
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.typeOfNumberPresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_imageBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_otherBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_chatBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_emailBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_messageBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_imBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass._extItems = 0;

   pdata0->deviceOnCall._base.u.deviceIdentifier.m.mediaClassPresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.connectionRate
       = OSI64CONST(1853287804518321600);
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.connectionRatePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.bitRate
       = DeviceID_bitRate_variable;
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.bitRatePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.delayTolerance
       = OSI64CONST(-3029607630624346208);
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.delayTolerancePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_isdn;
   pdata0->deviceOnCall._base.u.deviceIdentifier
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xb0, 0x82, 0xf, 0xe5, 0x16, 0xaa, 0x7d, 0x9a, 
   0x73, 0x4b, 0xf3, 0x20, 0xc3, 0xbc, 0xcc };
   pdata0->deviceOnCall._base.u.deviceIdentifier.
      switchingSubDomainInformationElements.numocts = 15;
   pdata0->deviceOnCall._base.u.deviceIdentifier.
      switchingSubDomainInformationElements.data = testdata;
   }
   pdata0->deviceOnCall._base.u.deviceIdentifier
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.localConnectionInfoPresent = 1;
   pdata0->localConnectionInfo = LocalConnectionState_null;

   pdata0->m.mediaServiceInfoListPresent = 1;
   { CallMediaInfoList_callMediaInfo* pdata1;
   OSRTDList* plist = &(pdata0->mediaServiceInfoList);
   pdata1 = rtxMemAllocType (pctxt, CallMediaInfoList_callMediaInfo);
   Init_CallMediaInfoList_callMediaInfo (pctxt, pdata1);
   pdata1->mediaServiceType = MediaServiceType_cstaVoiceUnit;

   pdata1->m.mediaServiceVersionPresent = 1;
   pdata1->mediaServiceVersion = OSI64CONST(-2083822845815482208);

   pdata1->m.mediaServiceInstancePresent = 1;
   pdata1->mediaServiceInstance.value = 
      OSUTF8("pdata1->mediaServiceInstance");
   pdata1->mediaServiceInstance.cdata = FALSE;

   pdata1->m.connectionInformationPresent = 1;
   pdata1->connectionInformation.m.flowDirectionPresent = 1;
   pdata1->connectionInformation.flowDirection
       = ConnectionInformation_flowDirect_transmitAndReceive;

   rtxDListAppend (pctxt, plist, pdata1);
   }

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 3;
   Init_Empty (pctxt, &(pdata0->deviceOnCall._base.u.restricted));

   pdata0->m.localConnectionInfoPresent = 1;
   pdata0->localConnectionInfo = LocalConnectionState_fail;

   pdata0->m.servicesPermittedPresent = 1;

   pdata0->servicesPermitted.callControlServices.m.alternateCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.alternateCall = 0;

   pdata0->servicesPermitted.callControlServices.m.answerCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.answerCall = 1;

   pdata0->servicesPermitted.callControlServices.m.callBackPresent = 1;
   pdata0->servicesPermitted.callControlServices.callBack = 1;

   pdata0->servicesPermitted.callControlServices.m.campOnCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.campOnCall = 1;

   pdata0->servicesPermitted.callControlServices.m.clearCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.clearCall = 0;

   pdata0->servicesPermitted.callControlServices
      .m.consultationCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.consultationCall = 0;

   pdata0->servicesPermitted.callControlServices.m.holdCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.holdCall = 0;

   pdata0->servicesPermitted.callControlServices.m.makeCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.makeCall = 1;

   pdata0->servicesPermitted.callControlServices.m.parkCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.parkCall = 1;

   pdata0->servicesPermitted.callControlServices.m.reconnectCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.reconnectCall = 1;

   pdata0->servicesPermitted.callControlServices.m.transferCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.transferCall = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.associateDataPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.associateData = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.generateDigitsPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.generateDigits = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.generateTelephonyTonesPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.generateTelephonyTones
       = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.sendUserInformationPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.sendUserInformation = 1;

   pdata0->servicesPermitted.mediaAttachementServices
      .m.detachMediaServicePresent = 1;
   pdata0->servicesPermitted.mediaAttachementServices.detachMediaService = 0;

   pdata0->servicesPermitted.routeingServices.m.routeRegisterPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRegister = 1;

   pdata0->servicesPermitted.routeingServices
      .m.routeRegisterCancelPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRegisterCancel = 1;

   pdata0->servicesPermitted.routeingServices.m.routeEndPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeEnd = 1;

   pdata0->servicesPermitted.routeingServices.m.routeRequestPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRequest = 0;

   pdata0->servicesPermitted.routeingServices.m.routeUsedPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeUsed = 1;

   pdata0->servicesPermitted.voiceServices.m.deactivatePresent = 1;
   pdata0->servicesPermitted.voiceServices.deactivate = 1;

   pdata0->servicesPermitted.voiceServices.m.concatenateMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.concatenateMessage = 0;

   pdata0->servicesPermitted.voiceServices.m.deleteMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.deleteMessage = 0;

   pdata0->servicesPermitted.voiceServices.m.repositionPresent = 1;
   pdata0->servicesPermitted.voiceServices.reposition = 0;

   pdata0->servicesPermitted.voiceServices.m.resumePresent = 1;
   pdata0->servicesPermitted.voiceServices.resume = 1;

   pdata0->servicesPermitted.voiceServices.m.reviewPresent = 1;
   pdata0->servicesPermitted.voiceServices.review = 0;

   pdata0->servicesPermitted.voiceServices.m.synthesizeMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.synthesizeMessage = 0;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 2;
   Init_Empty (pctxt, &(pdata0->deviceOnCall._base.u.notKnown));

   pdata0->m.callIdentifierPresent = 1;
   pdata0->callIdentifier.t = 1;
   Init_LocalDeviceID (pctxt, &(pdata0->callIdentifier.u.deviceID));
   pdata0->callIdentifier.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0xe3, 0x4d, 0xa9, 0xa0, 0xd2, 0xe, 0x55, 0x7b, 
   0xa0, 0x8b, 0x1d, 0x9c, 0xc7, 0x9f, 0xc7, 0xd4, 
   0x9e, 0x30, 0x30, 0xc0, 0x5, 0x32, 0x79, 0xba, 
   0xe3, 0x3d, 0x1d, 0xbc, 0xde, 0x9, 0xdc, 0x1a, 
   0x61, 0xcc, 0x56, 0xde, 0xe7 };
   pdata0->callIdentifier.u.deviceID._base.u.otherPlan.numocts = 37;
   pdata0->callIdentifier.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pdata0->callIdentifier.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_dialingNumber;
   pdata0->callIdentifier.u.deviceID.m.typeOfNumberPresent = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->callIdentifier.u.deviceID.mediaClass._extItems = 0;

   pdata0->callIdentifier.u.deviceID.m.mediaClassPresent = 1;
   pdata0->callIdentifier.u.deviceID.connectionRate
       = OSI64CONST(4125423156594854400);
   pdata0->callIdentifier.u.deviceID.m.connectionRatePresent = 1;
   pdata0->callIdentifier.u.deviceID.bitRate = LocalDeviceID_bitRate_variable;
   pdata0->callIdentifier.u.deviceID.m.bitRatePresent = 1;
   pdata0->callIdentifier.u.deviceID.delayTolerance
       = OSI64CONST(-4927369838714037008);
   pdata0->callIdentifier.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->callIdentifier.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pdata0->callIdentifier.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xa2, 0x4f, 0x51, 0x36, 0x79, 0x69, 0x7b, 0x3b, 
   0x8a, 0x74, 0xdf, 0xcb, 0xc5, 0x3, 0xd0, 0xfb, 
   0x10, 0xce, 0xb1, 0x3a, 0x23, 0x61, 0x84, 0x6c, 
   0x43, 0x44, 0x5f, 0x64, 0xf7, 0x28, 0x9b, 0x27, 
   0xc4, 0x90, 0x4c, 0x53, 0x5, 0x81, 0xd8, 0xa2, 
   0x78, 0xbb, 0x4c, 0x51, 0x9a, 0xfa, 0x28, 0xed, 
   0xc4 };
   pdata0->callIdentifier.u.deviceID.switchingSubDomainInformationElements
      .numocts = 49;
   pdata0->callIdentifier.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->callIdentifier.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.servicesPermittedPresent = 1;
   pdata0->servicesPermitted.callControlServices.m.acceptCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.acceptCall = 0;

   pdata0->servicesPermitted.callControlServices.m.alternateCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.alternateCall = 0;

   pdata0->servicesPermitted.callControlServices.m.callBackMessagePresent = 1;
   pdata0->servicesPermitted.callControlServices.callBackMessage = 1;

   pdata0->servicesPermitted.callControlServices.m.clearCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.clearCall = 0;

   pdata0->servicesPermitted.callControlServices.m.clearConnectionPresent = 1;
   pdata0->servicesPermitted.callControlServices.clearConnection = 0;

   pdata0->servicesPermitted.callControlServices
      .m.consultationCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.consultationCall = 0;

   pdata0->servicesPermitted.callControlServices.m.deflectCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.deflectCall = 0;

   pdata0->servicesPermitted.callControlServices.m.groupPickupCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.groupPickupCall = 0;

   pdata0->servicesPermitted.callControlServices.m.holdCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.holdCall = 1;

   pdata0->servicesPermitted.callControlServices.m.intrudeCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.intrudeCall = 0;

   pdata0->servicesPermitted.callControlServices.m.retrieveCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.retrieveCall = 0;

   pdata0->servicesPermitted.callControlServices
      .m.singleStepTransferPresent = 1;
   pdata0->servicesPermitted.callControlServices.singleStepTransfer = 1;

   pdata0->servicesPermitted.callControlServices.m.transferCallPresent = 1;
   pdata0->servicesPermitted.callControlServices.transferCall = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.associateDataPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.associateData = 1;

   pdata0->servicesPermitted.callAssociatedServices
      .m.cancelTelephonyTonesPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.cancelTelephonyTones = 0;

   pdata0->servicesPermitted.callAssociatedServices
      .m.generateTelephonyTonesPresent = 1;
   pdata0->servicesPermitted.callAssociatedServices.generateTelephonyTones
       = 0;

   pdata0->servicesPermitted.mediaAttachementServices
      .m.attachMediaServicePresent = 1;
   pdata0->servicesPermitted.mediaAttachementServices.attachMediaService = 0;

   pdata0->servicesPermitted.mediaAttachementServices
      .m.detachMediaServicePresent = 1;
   pdata0->servicesPermitted.mediaAttachementServices.detachMediaService = 0;

   pdata0->servicesPermitted.routeingServices
      .m.routeRegisterCancelPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRegisterCancel = 0;

   pdata0->servicesPermitted.routeingServices.m.routeRegisterAbortPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRegisterAbort = 1;

   pdata0->servicesPermitted.routeingServices.m.reRoutePresent = 1;
   pdata0->servicesPermitted.routeingServices.reRoute = 1;

   pdata0->servicesPermitted.routeingServices.m.routeRejectPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeReject = 0;

   pdata0->servicesPermitted.routeingServices.m.routeRequestPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeRequest = 1;

   pdata0->servicesPermitted.routeingServices.m.routeSelectPresent = 1;
   pdata0->servicesPermitted.routeingServices.routeSelect = 1;

   pdata0->servicesPermitted.voiceServices.m.activatePresent = 1;
   pdata0->servicesPermitted.voiceServices.activate = 0;

   pdata0->servicesPermitted.voiceServices.m.clearPresent = 1;
   pdata0->servicesPermitted.voiceServices.clear = 0;

   pdata0->servicesPermitted.voiceServices.m.playMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.playMessage = 0;

   pdata0->servicesPermitted.voiceServices.m.queryVoiceAttributePresent = 1;
   pdata0->servicesPermitted.voiceServices.queryVoiceAttribute = 1;

   pdata0->servicesPermitted.voiceServices.m.repositionPresent = 1;
   pdata0->servicesPermitted.voiceServices.reposition = 0;

   pdata0->servicesPermitted.voiceServices.m.resumePresent = 1;
   pdata0->servicesPermitted.voiceServices.resume = 0;

   pdata0->servicesPermitted.voiceServices.m.reviewPresent = 1;
   pdata0->servicesPermitted.voiceServices.review = 1;

   pdata0->servicesPermitted.voiceServices.m.suspendPresent = 1;
   pdata0->servicesPermitted.voiceServices.suspend = 1;

   pdata0->servicesPermitted.voiceServices.m.synthesizeMessagePresent = 1;
   pdata0->servicesPermitted.voiceServices.synthesizeMessage = 0;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, SnapshotCallResponseInfo);
   Init_SnapshotCallResponseInfo (pctxt, pdata0);
   pdata0->deviceOnCall._base.t = 1;
   Init_DeviceID (pctxt, &(pdata0->deviceOnCall._base.u.deviceIdentifier));
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.t = 2;
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number.value = 
      OSUTF8("pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number");
   pdata0->deviceOnCall._base.u.deviceIdentifier._base.u.number.cdata = FALSE;
   pdata0->deviceOnCall._base.u.deviceIdentifier.typeOfNumber
       = DeviceID_typeOfNumber_explicitPrivate_level3RegionalNumber;
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.typeOfNumberPresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_dataBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_imageBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_otherBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_chatBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_messageBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_imBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_smsBit = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->deviceOnCall._base.u.deviceIdentifier.mediaClass._extItems = 0;

   pdata0->deviceOnCall._base.u.deviceIdentifier.m.mediaClassPresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.connectionRate
       = OSI64CONST(5023918702163275200);
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.connectionRatePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.bitRate
       = DeviceID_bitRate_constant;
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.bitRatePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.delayTolerance
       = OSI64CONST(7585137677453707792);
   pdata0->deviceOnCall._base.u.deviceIdentifier.m.delayTolerancePresent = 1;
   pdata0->deviceOnCall._base.u.deviceIdentifier.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_isdn;
   pdata0->deviceOnCall._base.u.deviceIdentifier
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x2a, 0x4b, 0x3c, 0x3b, 0x97, 0x5b, 0x9e, 0x29, 
   0x45, 0xc8, 0xd0, 0x65, 0x3e, 0xd5, 0xc5, 0x40, 
   0xdf, 0xb6, 0x19, 0xed, 0x32, 0xc0, 0x65, 0x22, 
   0xd2, 0x94, 0x81, 0xd9, 0xfd, 0x2a, 0x42, 0xb5, 
   0xc4, 0x3f, 0x69, 0xa8, 0x4f, 0x8d, 0x64, 0xe6, 
   0xe5, 0x55, 0xf9, 0x4a, 0x8d, 0x3, 0x97, 0xa4, 
   0x6c, 0x29, 0xcf, 0x28, 0x4c, 0xf2, 0x3e, 0xed, 
   0xec, 0xc7, 0x71, 0xb7, 0x81, 0x65, 0x70, 0x71, 
   0x7e, 0x83, 0x1b };
   pdata0->deviceOnCall._base.u.deviceIdentifier.
      switchingSubDomainInformationElements.numocts = 67;
   pdata0->deviceOnCall._base.u.deviceIdentifier.
      switchingSubDomainInformationElements.data = testdata;
   }
   pdata0->deviceOnCall._base.u.deviceIdentifier
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.callIdentifierPresent = 1;
   pdata0->callIdentifier.t = 2;
   Init_ConnectionID_2 (pctxt, &(pdata0->callIdentifier.u._seq2));
   pdata0->callIdentifier.u._seq2.callID.value = 
      OSUTF8("pdata0->callIdentifier.u._seq2.callID");
   pdata0->callIdentifier.u._seq2.callID.cdata = FALSE;

   pdata0->m.localConnectionInfoPresent = 1;
   pdata0->localConnectionInfo = LocalConnectionState_hold;

   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.callLinkageDataPresent = 1;

   pvalue->callLinkageData.globalCallData.globalCallLinkageID.t = 1;
   pvalue->callLinkageData.globalCallData.globalCallLinkageID.
      u.subDomainCallLinkageID.value = 
      OSUTF8("pvalue->callLinkageData.globalCallData.globa");
   pvalue->callLinkageData.globalCallData.globalCallLinkageID.
      u.subDomainCallLinkageID.cdata = FALSE;

   pvalue->callLinkageData.m.threadDataPresent = 1;
   pvalue->callLinkageData.threadData
      .m.threadSwitchingSubDomainNamePresent = 1;
   pvalue->callLinkageData.threadData.threadSwitchingSubDomainName.value = 
      OSUTF8("pvalue->ca");
   pvalue->callLinkageData.threadData.threadSwitchingSubDomainName
      .cdata = FALSE;

   pvalue->callLinkageData.threadData.threadLinkageID.t = 2;
   pvalue->callLinkageData.threadData.threadLinkageID.u.globallyUniqueThreadID
      .value = 
      OSUTF8("pvalue->callLinkageData.threadData.threadLinkageID.u.gl");
   pvalue->callLinkageData.threadData.threadLinkageID.u.globallyUniqueThreadID
      .cdata = FALSE;

   pvalue->callLinkageData.threadData.m.threadIDTimeStampPresent = 1;
   pvalue->callLinkageData.threadData.threadIDTimeStamp.value = 
      OSUTF8("01234567890123,00+0123");
   pvalue->callLinkageData.threadData.threadIDTimeStamp.cdata = FALSE;

   return (pvalue);
}

