#!/usr/local/bin/perl
# Execute all test programs

require "../getMakeProg.pl";

select (STDOUT);
$| = 1;
select (STDERR);
$| = 1;

# include the current directory so that we can run reader and writer programs
# without modification
my $ps = (index ($ENV{"PATH"}, ';') >= 0) ? ';' : ':';
$ENV{"PATH"} = $ENV{"PATH"} . $ps . '.';

if (defined ($ARGV[0])) {
   $makeprog = $ARGV[0]
}
else {
   $makeprog = &getMakeProg();
}
print "makeprog is $makeprog\n";

print "\n";
print "**************************************";
print "**************************************\n";
print "\n";

# Run all test cases

@dirlist = (`ls .`);

foreach $filename (@dirlist) {
    $filename =~ s/\n$//;

    if (-d $filename) {
        chdir ($filename);
        print ("$filename\n");

        if (-e "test.pl") {
            print `perl test.pl`;
        }
        elsif (-e "makefile") {
            `$makeprog`;

            if (-e "writer.exe" || -e "writer") {
                print ("writer ");
                @proglist = ("writer", "-notrace");
                $stat = system (@proglist);
                if ($stat == 0) { print ("OK\n"); } 
                else { print ("failed.\n"); }

                if (-e "./good/message.xml") {
                    print `diff message.xml ./good`;
                }
            }

            if (-e "reader.exe" || -e "reader") {
                print ("reader ");
                @proglist = ("reader", "-notrace");
                $stat = system (@proglist);
                if ($stat == 0) { print ("OK\n"); } 
                else { print ("failed.\n"); }
            }

            if (-e "tester.exe" || -e "tester") {
                print ("tester ");
                @proglist = ("tester", "-notrace");
                $stat = system (@proglist);
                if ($stat == 0) { print ("OK\n"); } 
                else { print ("failed.\n"); }

                if (-e "message.xml" && -e "message2.xml") {
                    print "diff message.xml message2.xml\n";
                    print `diff message.xml message2.xml`;
               }
            }
        }

        print "\n";
        print "**************************************";
        print "**************************************\n";
        print "\n";

        chdir ('..');
    }
}
