/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.2.B, Date: 01-Jun-2007.
 * Copyright (c) 2003-2007 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "csta.h"
#include "rtxsrc/rtxMemLeakCheck.h"

TransferCall_ELEM* Test_TransferCall (OSCTXT* pctxt);
TransferCallResponse_ELEM* Test_TransferCallResponse (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   TransferCall_ELEM* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   FILE*        fp;
   const OSOCTET* pMsgBuf;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   pdata = Test_TransferCall (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_TransferCall (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      fp = fopen (filename, "w");
      if (fp) {
         fputs ((char*)pMsgBuf, fp);
         fclose (fp);
      }
      else {
         printf ("Error opening output file for write access\n");
         return -1;
      }
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

TransferCall_ELEM* Test_TransferCall (OSCTXT* pctxt)
{
   TransferCall_ELEM* pvalue = rtxMemAllocType (pctxt, TransferCall_ELEM);
   Init_TransferCall_ELEM (pctxt, pvalue);
   pvalue->heldCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->heldCall.u.deviceID));
   pvalue->heldCall.u.deviceID._base.t = 2;
   pvalue->heldCall.u.deviceID._base.u.number.value = 
      OSUTF8("pvalue->heldCall.u.deviceID._base.u.number");
   pvalue->heldCall.u.deviceID._base.u.number.cdata = FALSE;
   pvalue->heldCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_dynamic;
   pvalue->heldCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_voiceBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_dataBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_imageBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_audioBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_otherBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_chatBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_emailBit = 1;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_messageBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_imBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_smsBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass.MediaClassComponents_mmsBit = 0;
   pvalue->heldCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->heldCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->heldCall.u.deviceID.connectionRate
       = OSI64CONST(7754027817598147800);
   pvalue->heldCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->heldCall.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pvalue->heldCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->heldCall.u.deviceID.delayTolerance
       = OSI64CONST(3659004886229292592);
   pvalue->heldCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->heldCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_isoEthernet;
   pvalue->heldCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xcd, 0xa3, 0x3f, 0x2b, 0xe, 0x6e, 0x7a, 0xbd, 
   0x3b, 0x32, 0xf6, 0x13, 0x7c, 0xc7, 0xde, 0x45, 
   0x87, 0x43, 0x1b, 0x6a, 0xc7, 0x6, 0x62, 0x95, 
   0xc6, 0x15, 0x86, 0x60, 0xb5, 0x80, 0x1a, 0x1b, 
   0xcf, 0xe5, 0xa5, 0x36, 0x56, 0x77, 0xf5, 0x72, 
   0x68, 0x4, 0x43, 0x6d, 0x13, 0xe9, 0xb7, 0xa3, 
   0xb0, 0x73, 0x1c, 0x78, 0x8d, 0x83, 0xab, 0x56, 
   0xed };
   pvalue->heldCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 57;
   pvalue->heldCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->heldCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->activeCall.t = 2;
   Init_ConnectionID_2 (pctxt, &(pvalue->activeCall.u._seq2));
   pvalue->activeCall.u._seq2.callID.value = 
      OSUTF8("pvalue->activeCall.u._seq2.callID");
   pvalue->activeCall.u._seq2.callID.cdata = FALSE;

   pvalue->activeCall.u._seq2.m.deviceIDPresent = 1;
   pvalue->activeCall.u._seq2.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x3, 0xcd, 0x14, 0xc0, 0x29, 0x9c, 0x91, 0x4, 
   0x4a, 0xb6, 0x1c, 0x62, 0x9, 0xd6, 0x5f, 0x8f, 
   0x80, 0xdb, 0x66, 0xae, 0x23, 0x6, 0x72, 0xb2, 
   0x46, 0x96, 0x34, 0x72, 0x63, 0xe7, 0x6, 0xd2, 
   0xae, 0x77, 0xf4, 0xfc, 0x82, 0x67, 0x29, 0xe8, 
   0x56, 0x0, 0x13, 0xbd, 0x26, 0x38, 0x51, 0x4f, 
   0x8c, 0xb1 };
   pvalue->activeCall.u._seq2.deviceID._base.u.otherPlan.numocts = 50;
   pvalue->activeCall.u._seq2.deviceID._base.u.otherPlan.data = testdata;
   }
   pvalue->activeCall.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPublic_networkspecific;
   pvalue->activeCall.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 1;
   pvalue->activeCall.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->activeCall.u._seq2.deviceID.mediaClass._extItems = 0;

   pvalue->activeCall.u._seq2.deviceID.m.mediaClassPresent = 1;
   pvalue->activeCall.u._seq2.deviceID.connectionRate
       = OSI64CONST(374373143986842000);
   pvalue->activeCall.u._seq2.deviceID.m.connectionRatePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pvalue->activeCall.u._seq2.deviceID.m.bitRatePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.delayTolerance
       = OSI64CONST(-2974999818644310608);
   pvalue->activeCall.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_isoEthernet;
   pvalue->activeCall.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x8f, 0x15, 0x19, 0x39, 0x50, 0x72, 0x35, 0x9a, 
   0xb1, 0xef, 0xca, 0x4c, 0xd7, 0xe4, 0x4d, 0xd8, 
   0x5f, 0x22, 0x9d, 0x5a, 0x6f, 0x1, 0xef, 0x2d, 
   0xbf, 0xb5, 0xe8, 0x6d };
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .numocts = 28;
   pvalue->activeCall.u._seq2.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->activeCall.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.extensionsPresent = 1;

   return (pvalue);
}

TransferCallResponse_ELEM* Test_TransferCallResponse (OSCTXT* pctxt)
{
   TransferCallResponse_ELEM* pvalue = rtxMemAllocType (pctxt, TransferCallResponse_ELEM);
   Init_TransferCallResponse_ELEM (pctxt, pvalue);
   pvalue->transferredCall.t = 1;
   Init_LocalDeviceID (pctxt, &(pvalue->transferredCall.u.deviceID));
   pvalue->transferredCall.u.deviceID._base.t = 2;
   pvalue->transferredCall.u.deviceID._base.u.number.value = 
      OSUTF8("pvalue->transferredCall.u.deviceID._base.u.number");
   pvalue->transferredCall.u.deviceID._base.u.number.cdata = FALSE;
   pvalue->transferredCall.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_pTNSpecificNumber;
   pvalue->transferredCall.u.deviceID.m.typeOfNumberPresent = 1;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_imBit = 0;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pvalue->transferredCall.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pvalue->transferredCall.u.deviceID.mediaClass._extItems = 0;

   pvalue->transferredCall.u.deviceID.m.mediaClassPresent = 1;
   pvalue->transferredCall.u.deviceID.connectionRate
       = OSI64CONST(7980059121824790000);
   pvalue->transferredCall.u.deviceID.m.connectionRatePresent = 1;
   pvalue->transferredCall.u.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pvalue->transferredCall.u.deviceID.m.bitRatePresent = 1;
   pvalue->transferredCall.u.deviceID.delayTolerance
       = OSI64CONST(-7105489679443498208);
   pvalue->transferredCall.u.deviceID.m.delayTolerancePresent = 1;
   pvalue->transferredCall.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_other;
   pvalue->transferredCall.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x9f, 0xe3, 0xd9, 0xbc, 0x50, 0xf6, 0xec, 0x69, 
   0xb9, 0x8d, 0xba, 0x99, 0xf0, 0xe1, 0xfa, 0x37, 
   0xc2, 0x97, 0x4f, 0x72, 0x22, 0x18, 0x4, 0x93, 
   0x79, 0x18, 0xc6, 0xd7, 0x5f, 0x22, 0x67, 0xda, 
   0xb7, 0xad, 0x4f, 0x2d, 0x3a, 0xa7, 0x43, 0x14, 
   0xf3, 0xee, 0x3b, 0xb2, 0x3a, 0x27, 0x3a, 0xf5, 
   0x15, 0x6c, 0x80, 0x19, 0xa6, 0xc0, 0x19, 0xe, 
   0x19, 0xc3, 0x79, 0xab, 0x8a, 0x90, 0xc7, 0x69, 
   0x89, 0x44, 0x81, 0x2, 0x15, 0x9a, 0x88, 0x56, 
   0xbd, 0x9d, 0x5d, 0x4d, 0x45 };
   pvalue->transferredCall.u.deviceID.switchingSubDomainInformationElements
      .numocts = 77;
   pvalue->transferredCall.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pvalue->transferredCall.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pvalue->m.connectionsPresent = 1;
   { ConnectionListItem* pdata0;
   OSRTDList* plist = (OSRTDList*)&(pvalue->connections);
   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);
   pdata0->m.newConnectionPresent = 1;
   pdata0->newConnection.t = 2;
   Init_ConnectionID_2 (pctxt, &(pdata0->newConnection.u._seq2));
   pdata0->newConnection.u._seq2.callID.value = 
      OSUTF8("pdata0->newConnection.u._seq2.callID");
   pdata0->newConnection.u._seq2.callID.cdata = FALSE;

   pdata0->newConnection.u._seq2.m.deviceIDPresent = 1;
   pdata0->newConnection.u._seq2.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x73, 0x27, 0x64, 0x64, 0x41, 0xc5, 0xa9, 0x2a, 
   0xd3, 0x7c, 0x55, 0x4d, 0xa5, 0x38, 0xe4, 0xd0, 
   0x10, 0x83, 0xaf, 0xc, 0xa8, 0x8a, 0x26, 0xe, 
   0xe3, 0xc2, 0x2d, 0x93, 0x8, 0xa4, 0x45, 0x22, 
   0xb1, 0xa5, 0x63, 0x91, 0x70, 0x76, 0x13, 0xb1, 
   0x43, 0xa4, 0xd4, 0xc1, 0x6c, 0x27, 0xcf, 0xe3, 
   0xea, 0xfb, 0x49, 0x5a, 0x24, 0xd0, 0xef, 0x17, 
   0xe5, 0xed, 0xfc, 0x9, 0x6e, 0xcf, 0x2e, 0x21 };
   pdata0->newConnection.u._seq2.deviceID._base.u.otherPlan.numocts = 64;
   pdata0->newConnection.u._seq2.deviceID._base.u.otherPlan.data = testdata;
   }
   pdata0->newConnection.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_deviceNumber;
   pdata0->newConnection.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 0;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->newConnection.u._seq2.deviceID.mediaClass._extItems = 0;

   pdata0->newConnection.u._seq2.deviceID.m.mediaClassPresent = 1;
   pdata0->newConnection.u._seq2.deviceID.connectionRate
       = OSI64CONST(4402965953565550800);
   pdata0->newConnection.u._seq2.deviceID.m.connectionRatePresent = 1;
   pdata0->newConnection.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pdata0->newConnection.u._seq2.deviceID.m.bitRatePresent = 1;
   pdata0->newConnection.u._seq2.deviceID.delayTolerance
       = OSI64CONST(-3345995159828263808);
   pdata0->newConnection.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pdata0->newConnection.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_rsvp;
   pdata0->newConnection.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x15, 0x89, 0xe, 0x8b, 0x91, 0xf6, 0xcc, 0xae, 
   0x36, 0x41, 0x84, 0x76, 0x81, 0xc8, 0xce, 0x2c, 
   0xfb, 0x73, 0x28, 0x8e, 0x98, 0x31, 0x3a, 0xf7, 
   0xfc, 0x9b, 0x47, 0xaf, 0x6f, 0xcd, 0xf6, 0xd, 
   0x3b, 0xc3, 0x10, 0xe1, 0x35, 0x4d, 0xd9, 0xe8, 
   0xce, 0x7f, 0xa6, 0x22, 0xc4, 0x23, 0x60, 0xd9, 
   0xe6 };
   pdata0->newConnection.u._seq2.deviceID.switchingSubDomainInformationElements
      .numocts = 49;
   pdata0->newConnection.u._seq2.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->newConnection.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.oldConnectionPresent = 1;
   pdata0->oldConnection.t = 1;
   Init_LocalDeviceID (pctxt, &(pdata0->oldConnection.u.deviceID));
   pdata0->oldConnection.u.deviceID._base.t = 2;
   pdata0->oldConnection.u.deviceID._base.u.number.value = 
      OSUTF8("pdata0->oldConnection.u.deviceID._base.u.number");
   pdata0->oldConnection.u.deviceID._base.u.number.cdata = FALSE;
   pdata0->oldConnection.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_dynamic;
   pdata0->oldConnection.u.deviceID.m.typeOfNumberPresent = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass.MediaClassComponents_imBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass._extItems = 0;

   pdata0->oldConnection.u.deviceID.m.mediaClassPresent = 1;
   pdata0->oldConnection.u.deviceID.connectionRate
       = OSI64CONST(7882384324107922200);
   pdata0->oldConnection.u.deviceID.m.connectionRatePresent = 1;
   pdata0->oldConnection.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pdata0->oldConnection.u.deviceID.m.bitRatePresent = 1;
   pdata0->oldConnection.u.deviceID.delayTolerance
       = OSI64CONST(7618915705482595792);
   pdata0->oldConnection.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->oldConnection.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_isoEthernet;
   pdata0->oldConnection.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xb9, 0x9d, 0x9d, 0x83, 0x2f, 0xa7, 0x47, 0x9e, 
   0xb4, 0x9d };
   pdata0->oldConnection.u.deviceID.switchingSubDomainInformationElements
      .numocts = 10;
   pdata0->oldConnection.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->oldConnection.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.endpointPresent = 1;
   pdata0->endpoint.t = 2;
   Init_Empty (pctxt, &(pdata0->endpoint.u.notKnown));

   pdata0->m.associatedNIDPresent = 1;
   pdata0->associatedNID.t = 2;
   Init_Empty (pctxt, &(pdata0->associatedNID.u.notKnown));

   pdata0->m.resultingConnectionInfoPresent = 1;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);

   pdata0->m.associatedNIDPresent = 1;
   pdata0->associatedNID.t = 1;
   Init_DeviceID (pctxt, &(pdata0->associatedNID.u.deviceID));
   pdata0->associatedNID.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0xc1, 0xdd, 0xfa, 0xa6, 0x61, 0xd4, 0xb1, 0xd1, 
   0x7f, 0xea, 0xb3, 0x43, 0xeb, 0xfa, 0x41, 0x8, 
   0xc5, 0x82, 0x26, 0xbd, 0x6, 0x0, 0xe2, 0x1e, 
   0x89, 0x6a, 0x27, 0x9c, 0x1d, 0x21, 0xcc, 0x14 };
   pdata0->associatedNID.u.deviceID._base.u.otherPlan.numocts = 32;
   pdata0->associatedNID.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pdata0->associatedNID.u.deviceID.typeOfNumber
       = DeviceID_typeOfNumber_implicitPrivate;
   pdata0->associatedNID.u.deviceID.m.typeOfNumberPresent = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass._extItems = 0;

   pdata0->associatedNID.u.deviceID.m.mediaClassPresent = 1;
   pdata0->associatedNID.u.deviceID.connectionRate
       = OSI64CONST(864999001106440200);
   pdata0->associatedNID.u.deviceID.m.connectionRatePresent = 1;
   pdata0->associatedNID.u.deviceID.bitRate = DeviceID_bitRate_constant;
   pdata0->associatedNID.u.deviceID.m.bitRatePresent = 1;
   pdata0->associatedNID.u.deviceID.delayTolerance
       = OSI64CONST(266001970727492992);
   pdata0->associatedNID.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->associatedNID.u.deviceID.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_atm;
   pdata0->associatedNID.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x4, 0x26, 0xfd, 0x6f, 0x57, 0x31, 0x45, 0x5c, 
   0xca, 0x27, 0x87, 0xe5, 0xe9, 0xef, 0x2b, 0x51, 
   0xd9, 0x92, 0xe8, 0xb0, 0xc8, 0x7a, 0xdc, 0x61, 
   0xe3, 0xa8, 0xb8, 0xec, 0xef, 0xea, 0x73, 0x12, 
   0x7b, 0x69, 0x69, 0x73, 0x32, 0xa2, 0xbf, 0x87, 
   0xd8, 0xa8, 0x7b, 0x4e, 0xec, 0xad, 0xa7, 0x1, 
   0x78, 0x3e, 0x7a, 0x2b, 0x91 };
   pdata0->associatedNID.u.deviceID.switchingSubDomainInformationElements
      .numocts = 53;
   pdata0->associatedNID.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->associatedNID.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.resultingConnectionInfoPresent = 1;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);
   pdata0->m.newConnectionPresent = 1;
   pdata0->newConnection.t = 2;
   Init_ConnectionID_2 (pctxt, &(pdata0->newConnection.u._seq2));
   pdata0->newConnection.u._seq2.callID.value = 
      OSUTF8("pdata0->newConnection.u._seq2.callID");
   pdata0->newConnection.u._seq2.callID.cdata = FALSE;

   pdata0->newConnection.u._seq2.m.deviceIDPresent = 1;
   pdata0->newConnection.u._seq2.deviceID._base.t = 2;
   pdata0->newConnection.u._seq2.deviceID._base.u.number.value = 
      OSUTF8("pdata0->newConnection.u._seq2.deviceID._base.u.number");
   pdata0->newConnection.u._seq2.deviceID._base.u.number.cdata = FALSE;
   pdata0->newConnection.u._seq2.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPrivate_unknown;
   pdata0->newConnection.u._seq2.deviceID.m.typeOfNumberPresent = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_imBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->newConnection.u._seq2.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pdata0->newConnection.u._seq2.deviceID.mediaClass._extItems = 0;

   pdata0->newConnection.u._seq2.deviceID.m.mediaClassPresent = 1;
   pdata0->newConnection.u._seq2.deviceID.connectionRate
       = OSI64CONST(107808206125534200);
   pdata0->newConnection.u._seq2.deviceID.m.connectionRatePresent = 1;
   pdata0->newConnection.u._seq2.deviceID.bitRate
       = LocalDeviceID_bitRate_constant;
   pdata0->newConnection.u._seq2.deviceID.m.bitRatePresent = 1;
   pdata0->newConnection.u._seq2.deviceID.delayTolerance
       = OSI64CONST(-5489774005395022208);
   pdata0->newConnection.u._seq2.deviceID.m.delayTolerancePresent = 1;
   pdata0->newConnection.u._seq2.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_atm;
   pdata0->newConnection.u._seq2.deviceID
      .m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x7d, 0xcf, 0xd, 0xe6, 0xd6, 0x39, 0x40, 0x20, 
   0xd8, 0x38, 0x7a, 0xd7, 0x49, 0xc6, 0xc5, 0x5e, 
   0xa6, 0x55, 0xbd, 0xc4, 0xda, 0x8b, 0x77, 0x6c, 
   0x1e, 0x77, 0xfa, 0x6c, 0x4f, 0xbc, 0x42, 0xf1, 
   0x71, 0x89, 0x63, 0xf7, 0x7f, 0xd9, 0xf2, 0xb, 
   0xc7, 0x33, 0xba, 0x64, 0x15, 0x87, 0xc4, 0x9b, 
   0x38, 0xd3, 0xef, 0x3f, 0x51, 0x2b, 0x7b, 0x79, 
   0xde, 0x4b, 0xc2, 0xb6, 0xed, 0x5c, 0x16, 0x5a, 
   0x2, 0xf, 0xf6, 0x74, 0x81, 0xa4, 0xc, 0x9b, 
   0x41 };
   pdata0->newConnection.u._seq2.deviceID.switchingSubDomainInformationElements
      .numocts = 73;
   pdata0->newConnection.u._seq2.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->newConnection.u._seq2.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.oldConnectionPresent = 1;
   pdata0->oldConnection.t = 1;
   Init_LocalDeviceID (pctxt, &(pdata0->oldConnection.u.deviceID));
   pdata0->oldConnection.u.deviceID._base.t = 1;
   { static const OSOCTET testdata[] = {
   0x47, 0x7c, 0x10, 0x1a, 0xd6, 0x57, 0x9b, 0x7a, 
   0xa3, 0x32, 0x10, 0xa2, 0xc5, 0x70, 0x88, 0xc2, 
   0xed, 0xf7, 0xa9, 0x1e, 0x76, 0xb, 0xed, 0xbe, 
   0x17, 0x48, 0xf4, 0x15, 0x51, 0xe7, 0x9d, 0x37, 
   0xa, 0x5, 0xf0, 0x30, 0x6a, 0x11, 0x22, 0x95, 
   0x68, 0xba, 0xa0, 0x59, 0xa9, 0x67, 0xc, 0x87, 
   0x94, 0x82, 0xfe, 0xe7, 0xbc, 0x4a, 0x7, 0xb4, 
   0x90 };
   pdata0->oldConnection.u.deviceID._base.u.otherPlan.numocts = 57;
   pdata0->oldConnection.u.deviceID._base.u.otherPlan.data = testdata;
   }
   pdata0->oldConnection.u.deviceID.typeOfNumber
       = LocalDeviceID_typeOfNumber_explicitPublic_national;
   pdata0->oldConnection.u.deviceID.m.typeOfNumberPresent = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 1;
   pdata0->oldConnection.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 0;
   pdata0->oldConnection.u.deviceID.mediaClass._extItems = 0;

   pdata0->oldConnection.u.deviceID.m.mediaClassPresent = 1;
   pdata0->oldConnection.u.deviceID.connectionRate
       = OSI64CONST(5756901910390144800);
   pdata0->oldConnection.u.deviceID.m.connectionRatePresent = 1;
   pdata0->oldConnection.u.deviceID.bitRate = LocalDeviceID_bitRate_constant;
   pdata0->oldConnection.u.deviceID.m.bitRatePresent = 1;
   pdata0->oldConnection.u.deviceID.delayTolerance
       = OSI64CONST(8286031759053133792);
   pdata0->oldConnection.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->oldConnection.u.deviceID.switchingSubDomainCCIEType
       = LocalDeviceID_switchingSubDomain_isdn;
   pdata0->oldConnection.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0xd0, 0xb2, 0xbe, 0x87, 0x9c, 0x22, 0x48, 0x4d, 
   0xc4, 0xd7, 0xe3, 0x12, 0xd6, 0x5, 0x7, 0x7e, 
   0x78, 0x2a, 0x46, 0xeb, 0x1e, 0x98, 0x42, 0x65, 
   0x27, 0x8e, 0x7e, 0x70, 0x74, 0x2f, 0x70, 0xc3, 
   0x7d, 0x9e, 0xd4, 0xfd, 0x15, 0x82, 0xaa, 0x95, 
   0x4a, 0xa2, 0x60, 0x96, 0x2a, 0x8c, 0xc, 0xd3, 
   0x3d, 0x4e, 0x3a, 0xc1, 0x13, 0xb9, 0xb3, 0xfe, 
   0x34, 0xd8, 0x41, 0xcc, 0xbd, 0x62, 0xcd, 0x6, 
   0x99, 0x66, 0xeb, 0xca, 0x85, 0x93, 0xa9, 0xf0, 
   0xd4, 0x30 };
   pdata0->oldConnection.u.deviceID.switchingSubDomainInformationElements
      .numocts = 74;
   pdata0->oldConnection.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->oldConnection.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   pdata0->m.resultingConnectionInfoPresent = 1;

   pdata0->resultingConnectionInfo.m.mediaSessionInfoPresent = 1;
   pdata0->resultingConnectionInfo.mediaSessionInfo.value = 
      OSUTF8("pdata0->resultingConnectionInfo.mediaSessionInfo");
   pdata0->resultingConnectionInfo.mediaSessionInfo.cdata = FALSE;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);

   pdata0->m.resultingConnectionInfoPresent = 1;

   pdata0->resultingConnectionInfo.m.mediaSessionInfoPresent = 1;
   pdata0->resultingConnectionInfo.mediaSessionInfo.value = 
      OSUTF8("pdata0->resultingConnectionInfo.mediaSessionInfo");
   pdata0->resultingConnectionInfo.mediaSessionInfo.cdata = FALSE;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);

   pdata0->m.associatedNIDPresent = 1;
   pdata0->associatedNID.t = 2;
   Init_Empty (pctxt, &(pdata0->associatedNID.u.notKnown));

   pdata0->m.resultingConnectionInfoPresent = 1;

   rtxDListAppend (pctxt, plist, pdata0);

   pdata0 = rtxMemAllocType (pctxt, ConnectionListItem);
   Init_ConnectionListItem (pctxt, pdata0);

   pdata0->m.associatedNIDPresent = 1;
   pdata0->associatedNID.t = 1;
   Init_DeviceID (pctxt, &(pdata0->associatedNID.u.deviceID));
   pdata0->associatedNID.u.deviceID._base.t = 2;
   pdata0->associatedNID.u.deviceID._base.u.number.value = 
      OSUTF8("pdata0->associatedNID.u.deviceID._base.u.number");
   pdata0->associatedNID.u.deviceID._base.u.number.cdata = FALSE;
   pdata0->associatedNID.u.deviceID.typeOfNumber
       = DeviceID_typeOfNumber_deviceNumber;
   pdata0->associatedNID.u.deviceID.m.typeOfNumberPresent = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_voiceBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_dataBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_imageBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_audioBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_otherBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_notKnownBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_chatBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_emailBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_messageBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass.MediaClassComponents_imBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_smsBit = 0;
   pdata0->associatedNID.u.deviceID.mediaClass
      .MediaClassComponents_mmsBit = 1;
   pdata0->associatedNID.u.deviceID.mediaClass._extItems = 0;

   pdata0->associatedNID.u.deviceID.m.mediaClassPresent = 1;
   pdata0->associatedNID.u.deviceID.connectionRate
       = OSI64CONST(7146023313078163800);
   pdata0->associatedNID.u.deviceID.m.connectionRatePresent = 1;
   pdata0->associatedNID.u.deviceID.bitRate = DeviceID_bitRate_constant;
   pdata0->associatedNID.u.deviceID.m.bitRatePresent = 1;
   pdata0->associatedNID.u.deviceID.delayTolerance
       = OSI64CONST(5324261668053470992);
   pdata0->associatedNID.u.deviceID.m.delayTolerancePresent = 1;
   pdata0->associatedNID.u.deviceID.switchingSubDomainCCIEType
       = DeviceID_switchingSubDomainCCIET_other;
   pdata0->associatedNID.u.deviceID.m.switchingSubDomainCCIETypePresent = 1;
   { static const OSOCTET testdata[] = {
   0x27, 0x59, 0xdc, 0x3c, 0xf2, 0xd3, 0xec, 0xc1, 
   0xf, 0x7b, 0xd6, 0x55, 0x1b, 0xe8, 0x3a, 0x9 };
   pdata0->associatedNID.u.deviceID.switchingSubDomainInformationElements
      .numocts = 16;
   pdata0->associatedNID.u.deviceID.switchingSubDomainInformationElements
      .data = testdata;
   }
   pdata0->associatedNID.u.deviceID
      .m.switchingSubDomainInformationElementsPresent = 1;

   rtxDListAppend (pctxt, plist, pdata0);
   }

   pvalue->m.transferredCallInfoPresent = 1;
   pvalue->transferredCallInfo.m.flowDirectionPresent = 1;
   pvalue->transferredCallInfo.flowDirection
       = ConnectionInformation_flowDirect_transmitAndReceive;

   pvalue->transferredCallInfo.m.numberOfChannelsPresent = 1;
   pvalue->transferredCallInfo.numberOfChannels
       = OSI64CONST(3311654164665560992);

   return (pvalue);
}

