/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 2.7.0, Date: 03-Feb-2022.
 * Copyright (c) 2003-2021 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include "csta3xml_Project.h"
#include "my_envelope.h"
#include "rtxsrc/rtxErrCodes.h"
#include "rtxsrc/rtxMemory.h"

int XmlDT_Header (OSCTXT* pctxt, Header* pvalue)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpGetXmlnsAttrs (pctxt, &(pvalue->_nsAttrs));
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode attributes */
   if (rtXmlpNeedDecodeAttributes (pctxt)) {
      size_t i, nAttrs = 0;

      stat = rtXmlpGetAttributeCount (pctxt);
      if (stat < 0) return LOG_RTERR (pctxt, stat);
      else nAttrs = (size_t)stat;
      stat = 0;

      for (i = 0; i < nAttrs; i++) {
         OSAnyAttr* pAnyAttr;
         OSXMLNameFragments attrName;
         OSINT16 nsidx;

         if (rtXmlpSelectAttribute (pctxt, &attrName, &nsidx, i) != 0) 
            continue;

         if (nsidx < -1) continue;

         pAnyAttr = rtxMemAllocType (pctxt, OSAnyAttr);
         if (pAnyAttr == 0)
            return LOG_RTERR (pctxt, RTERR_NOMEM);

         stat = rtXmlpDecDynUTF8Str (pctxt, &(pAnyAttr->value));

         if (stat == 0) {
            pAnyAttr->name = rtxUTF8Strndup 
                  (pctxt, attrName.mQName.value, attrName.mQName.length);

            rtxDListAppend (pctxt, &pvalue->_anyAttr, (void*)pAnyAttr);
         }
         else {
            rtxMemFreePtr (pctxt, pAnyAttr);
            return LOG_RTERR (pctxt, stat);
         }
      }
      rtXmlpHideAttributes (pctxt);
   }

   { OSXMLElemDescr elemDescr;

   stat = rtXmlpGetNextElem (pctxt, &elemDescr, -1);
   if (stat < 0) return LOG_RTERR (pctxt, stat);
   else if(stat != XML_OK_EOB) {
      /* decode xsd:any element as XML text */
      stat = rtXmlpDecAnyElem (pctxt, &pvalue->_any.value);
      pvalue->_any.cdata = FALSE;

      if (stat != 0) return LOG_RTERR (pctxt, stat);

      stat = rtXmlpMatchEndTag (pctxt, -1);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }
   else return LOG_RTERR (pctxt, XML_E_ELEMSMISRQ);
   }

   return stat;
}

int XmlDT_Body (OSCTXT* pctxt, Body* pvalue)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpGetXmlnsAttrs (pctxt, &(pvalue->_nsAttrs));
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode attributes */
   if (rtXmlpNeedDecodeAttributes (pctxt)) {
      size_t i, nAttrs = 0;

      stat = rtXmlpGetAttributeCount (pctxt);
      if (stat < 0) return LOG_RTERR (pctxt, stat);
      else nAttrs = (size_t)stat;
      stat = 0;

      for (i = 0; i < nAttrs; i++) {
         OSAnyAttr* pAnyAttr;
         OSXMLNameFragments attrName;
         OSINT16 nsidx;

         if (rtXmlpSelectAttribute (pctxt, &attrName, &nsidx, i) != 0) 
            continue;

         if (nsidx < -1) continue;

         pAnyAttr = rtxMemAllocType (pctxt, OSAnyAttr);
         if (pAnyAttr == 0)
            return LOG_RTERR (pctxt, RTERR_NOMEM);

         stat = rtXmlpDecDynUTF8Str (pctxt, &(pAnyAttr->value));

         if (stat == 0) {
            pAnyAttr->name = rtxUTF8Strndup 
                  (pctxt, attrName.mQName.value, attrName.mQName.length);

            rtxDListAppend (pctxt, &pvalue->_anyAttr, (void*)pAnyAttr);
         }
         else {
            rtxMemFreePtr (pctxt, pAnyAttr);
            return LOG_RTERR (pctxt, stat);
         }
      }
      rtXmlpHideAttributes (pctxt);
   }

   { OSXMLElemDescr elemDescr;

   stat = rtXmlpGetNextElem (pctxt, &elemDescr, -1);
   if (stat < 0) return LOG_RTERR (pctxt, stat);
   else if(stat != XML_OK_EOB) {
      /* decode xsd:any element as XML text */
      stat = rtXmlpDecAnyElem (pctxt, &pvalue->_any.value);
      pvalue->_any.cdata = FALSE;

      if (stat != 0) return LOG_RTERR (pctxt, stat);

      stat = rtXmlpMatchEndTag (pctxt, -1);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }
   else return LOG_RTERR (pctxt, XML_E_ELEMSMISRQ);
   }

   return stat;
}

int XmlDT_Envelope (OSCTXT* pctxt, Envelope* pvalue)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpGetXmlnsAttrs (pctxt, &(pvalue->_nsAttrs));
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode attributes */
   if (rtXmlpNeedDecodeAttributes (pctxt)) {
      size_t i, nAttrs = 0;

      stat = rtXmlpGetAttributeCount (pctxt);
      if (stat < 0) return LOG_RTERR (pctxt, stat);
      else nAttrs = (size_t)stat;
      stat = 0;

      for (i = 0; i < nAttrs; i++) {
         OSAnyAttr* pAnyAttr;
         OSXMLNameFragments attrName;
         OSINT16 nsidx;

         if (rtXmlpSelectAttribute (pctxt, &attrName, &nsidx, i) != 0) 
            continue;

         if (nsidx < -1) continue;

         pAnyAttr = rtxMemAllocType (pctxt, OSAnyAttr);
         if (pAnyAttr == 0)
            return LOG_RTERR (pctxt, RTERR_NOMEM);

         stat = rtXmlpDecDynUTF8Str (pctxt, &(pAnyAttr->value));

         if (stat == 0) {
            pAnyAttr->name = rtxUTF8Strndup 
                  (pctxt, attrName.mQName.value, attrName.mQName.length);

            rtxDListAppend (pctxt, &pvalue->_anyAttr, (void*)pAnyAttr);
         }
         else {
            rtxMemFreePtr (pctxt, pAnyAttr);
            return LOG_RTERR (pctxt, stat);
         }
      }
      rtXmlpHideAttributes (pctxt);
   }

   { int elemID;

   static const OSXMLElemIDRec elemtab[] = {
      {{{OSUTF8("Header"), 6}, -6}, 0 },
      {{{OSUTF8("Body"), 4}, -6}, 1 }
   } ;

   static const OSXMLGroupDesc groupDesc[] = {
      { 0,  2, -1}, { 1,  1, -1}
    };

   int i;
   OSBOOL flBase = (OSBOOL) rtXmlpIsDecodeAsGroup (pctxt);

   stat = 0;
   for (i = 0; i < 2; i++) {
      OSBOOL flEndTag = TRUE;

      elemID = rtXmlpGetNextSeqElemID (pctxt, elemtab, groupDesc, i, 1, 
         flBase);
      if (elemID < 0) return LOG_RTERR (pctxt, elemID);
      else if (elemID == XML_OK_EOB) break;

      switch (elemID) {
      case 0: { /* Header */
         stat = XmlDT_Header (pctxt, &(pvalue->Header));
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         pvalue->m.HeaderPresent = TRUE;
         break;
      }
      case 1: { /* Body */
         stat = XmlDT_Body (pctxt, &(pvalue->Body));
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         break;
      }
      }

      if (flEndTag) {
         stat = rtXmlpMatchEndTag (pctxt, -1);
         if (stat < 0) return LOG_RTERR (pctxt, stat);
      }

      i = elemID;
   }
   }

   return stat;
}

int XmlDT_detail (OSCTXT* pctxt, detail* pvalue)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpGetXmlnsAttrs (pctxt, &(pvalue->_nsAttrs));
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode attributes */
   if (rtXmlpNeedDecodeAttributes (pctxt)) {
      size_t i, nAttrs = 0;

      stat = rtXmlpGetAttributeCount (pctxt);
      if (stat < 0) return LOG_RTERR (pctxt, stat);
      else nAttrs = (size_t)stat;
      stat = 0;

      for (i = 0; i < nAttrs; i++) {
         OSAnyAttr* pAnyAttr;
         OSXMLNameFragments attrName;
         OSINT16 nsidx;

         if (rtXmlpSelectAttribute (pctxt, &attrName, &nsidx, i) != 0) 
            continue;

         if (nsidx < -1) continue;

         pAnyAttr = rtxMemAllocType (pctxt, OSAnyAttr);
         if (pAnyAttr == 0)
            return LOG_RTERR (pctxt, RTERR_NOMEM);

         stat = rtXmlpDecDynUTF8Str (pctxt, &(pAnyAttr->value));

         if (stat == 0) {
            pAnyAttr->name = rtxUTF8Strndup 
                  (pctxt, attrName.mQName.value, attrName.mQName.length);

            rtxDListAppend (pctxt, &pvalue->_anyAttr, (void*)pAnyAttr);
         }
         else {
            rtxMemFreePtr (pctxt, pAnyAttr);
            return LOG_RTERR (pctxt, stat);
         }
      }
      rtXmlpHideAttributes (pctxt);
   }

   { OSXMLElemDescr elemDescr;

   stat = rtXmlpGetNextElem (pctxt, &elemDescr, -1);
   if (stat < 0) return LOG_RTERR (pctxt, stat);
   else if(stat != XML_OK_EOB) {
      /* decode xsd:any element as XML text */
      stat = rtXmlpDecAnyElem (pctxt, &pvalue->_any.value);
      pvalue->_any.cdata = FALSE;

      if (stat != 0) return LOG_RTERR (pctxt, stat);

      stat = rtXmlpMatchEndTag (pctxt, -1);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }
   else return LOG_RTERR (pctxt, XML_E_ELEMSMISRQ);
   }

   return stat;
}

int XmlDT_Fault (OSCTXT* pctxt, Fault* pvalue)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpGetXmlnsAttrs (pctxt, &(pvalue->_nsAttrs));
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode xsi attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpDecXSIAttrs (pctxt);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

      rtXmlpHideAttributes (pctxt);
   }

   { int elemID;

   static const OSXMLElemIDRec elemtab[] = {
      {{{OSUTF8("faultcode"), 9}, 0}, 0 },
      {{{OSUTF8("faultstring"), 11}, 0}, 1 },
      {{{OSUTF8("detail"), 6}, 0}, 2 }
   } ;

   static const OSXMLGroupDesc groupDesc[] = {
      { 0,  1, -1}, { 1,  1, -1}, { 2,  1, -1}
    };

   int i;
   OSBOOL flBase = (OSBOOL) rtXmlpIsDecodeAsGroup (pctxt);

   stat = 0;
   for (i = 0; i < 3; i++) {
      OSBOOL flEndTag = TRUE;

      elemID = rtXmlpGetNextSeqElemID (pctxt, elemtab, groupDesc, i, 1, 
         flBase);
      if (elemID < 0) return LOG_RTERR (pctxt, elemID);
      else if (elemID == XML_OK_EOB) break;

      switch (elemID) {
      case 0: { /* faultcode */
         rtXmlpSetWhiteSpaceMode (pctxt, OSXMLWSM_COLLAPSE);

         stat = rtXmlpDecXmlStr (pctxt, &(pvalue->faultcode));
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         break;
      }
      case 1: { /* faultstring */
         stat = rtXmlpDecXmlStr (pctxt, &(pvalue->faultstring));
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         break;
      }
      case 2: { /* detail */
         stat = XmlDT_detail (pctxt, &(pvalue->detail));
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         pvalue->m.detailPresent = TRUE;
         break;
      }
      }

      if (flEndTag) {
         stat = rtXmlpMatchEndTag (pctxt, -1);
         if (stat < 0) return LOG_RTERR (pctxt, stat);
      }

      i = elemID;
   }
   }

   return stat;
}

/**
 * Global element functions.  These functions encode or 
 * decode complete XML documents.  They are generated for global 
 * elements that are either:
 *
 * 1) not referenced by any other types, or
 * 2) explicitly declared to be a PDU using the -pdu command line
 *    option, or
 * 3) explicitly declared to be a PDU using the <isPDU/> 
 *    configuration file element.
 */
int XmlD_Envelope (OSCTXT* pctxt, Envelope* pvalue)
{
   int stat = 0;

   rtXmlpCreateReader (pctxt);

   Init_Envelope (pctxt, pvalue);

   rtXmlpSetNamespaceTable (pctxt, Get_csta3xml_NSURI(pctxt), 2);

   stat = rtXmlpMatchStartTag (pctxt, OSUTF8("Envelope"), -6);
   if (stat < 0) return LOG_RTERR (pctxt, stat);

   stat = XmlDT_Envelope (pctxt, pvalue);
   if (stat != 0) return LOG_RTERR (pctxt, stat);

   stat = rtXmlpMatchEndTag (pctxt, -1);
   if (stat < 0) return LOG_RTERR (pctxt, stat);

   return rtxErrGetStatus (pctxt);
}

